define(['marionette'], function(Marionette) {
  var onClick;
  return Marionette.Controller.extend({
    initialize: function(_arg) {
      this.app = _arg.app;
    },
    init: function(callback) {
      this.app.menuRegion.reset();
      this.app.userEvents.restartNodeConnect(this.app);
      this.hs = null;
      return require(['views/menu', 'views/components/horizontal-swipe'], (function(_this) {
        return function(MenuView, HorizontalSwipe) {
          var canvas;
          _this.view = new MenuView({
            app: _this.app,
            id: 'menu',
            type: 'menu'
          });
          _this.app.menuRegion.show(_this.view);
          _this.app.userEvents.nodeConnect(_this.app);
          canvas = document.body.querySelector('.js-canvas');
          if (_this.hs != null) {
            _this.hs.undelegate();
          }
          _this.hs = new HorizontalSwipe(document.body, {
            onSwipeLeft: function() {
              return _this.close();
            },
            onSwipeRight: function() {
              return _this.open();
            }
          });
          if (callback != null) {
            return callback();
          }
        };
      })(this));
    },
    close: onClick = function(event) {
      if (event != null) {
        event.stopPropagation();
      }
      document.body.classList.remove('menu-opened');
      document.body.querySelector('.js-canvas').removeEventListener('click', onClick, true);
      $('body').find('.o-main__item--canvas').css({
        width: $(window).width()
      });
      return $(window).resize(function() {
        return $('body').find('.o-main__item--canvas').css({
          width: $(window).width()
        });
      });
    },
    open: function() {
      document.body.classList.add('menu-opened');
      setTimeout(((function(_this) {
        return function() {
          return document.body.querySelector('.js-canvas').addEventListener('click', _this.close, true);
        };
      })(this)), 0);
      $('body').find('.o-main__item--canvas').css({
        width: $(window).width() - $('body').find('.o-main__item--menu').width()
      });
      return $(window).resize(function() {
        return $('body').find('.o-main__item--canvas').css({
          width: $(window).width() - $('body').find('.o-main__item--menu').width()
        });
      });
    },
    reload: function() {
      require.undef('views/menu');
      require.undef('text!templates/menu.tmpl');
      return this.init((function(_this) {
        return function() {
          if (_this.app.config.debug) {
            return console.log("reload menu");
          }
        };
      })(this));
    }
  });
});
