var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['marionette', 'jquery'], function(Marionette, $) {
  var QuestsController;
  QuestsController = (function(_super) {
    __extends(QuestsController, _super);

    function QuestsController() {
      this.doIfCompleted = __bind(this.doIfCompleted, this);
      this.checkCompleted = __bind(this.checkCompleted, this);
      this.clearCache = __bind(this.clearCache, this);
      return QuestsController.__super__.constructor.apply(this, arguments);
    }

    QuestsController.prototype.initialize = function(_arg) {
      this.app = _arg.app;
    };

    QuestsController.prototype._cache = {};

    QuestsController.prototype.clearCache = function() {
      return this._cache = {};
    };

    QuestsController.prototype.checkCompleted = function(cid) {
      var deferred;
      deferred = $.Deferred();
      if (this._cache.hasOwnProperty(cid)) {
        if (this._cache[cid].completed) {
          deferred.resolve(true);
        } else {
          deferred.reject(this._cache[cid]);
        }
      } else {
        app.server.quests.check_completed({
          cid: cid,
          success: (function(_this) {
            return function(data) {
              if (data) {
                _this._cache[cid] = {
                  completed: (data != null ? data.completed : void 0) || 0,
                  message: (data != null ? data.message : void 0) || app.tr('Access Denied')
                };
              }
              if (!data || !(data != null ? data.completed : void 0)) {
                return deferred.reject({
                  message: (data != null ? data.message : void 0) || app.tr('Access Denied')
                });
              } else {
                return deferred.resolve(true);
              }
            };
          })(this),
          error: function() {
            return deferred.reject({
              message: app.tr('Access Denied')
            });
          }
        });
      }
      return deferred;
    };

    QuestsController.prototype.doIfCompleted = function(cid, fn) {
      return this.checkCompleted(cid).then(function() {
        return fn();
      }, function(data) {
        return app.screens.modal('common/info-popup', {
          msg: data.message
        });
      });
    };

    return QuestsController;

  })(Marionette.Controller);
  return QuestsController;
});
