var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['jquery', 'marionette'], function(jquery, Marionette) {
  var ServerController;
  ServerController = (function(_super) {
    __extends(ServerController, _super);

    function ServerController() {
      return ServerController.__super__.constructor.apply(this, arguments);
    }

    ServerController.prototype.defaultCacheValidityInMs = 60 * 1000;

    ServerController.prototype.reload = function() {
      require.undef('controllers/server');
      return require(['controllers/server'], (function(_this) {
        return function(ServerController) {
          if (_this.app.config.debug) {
            console.log("reload server controller");
          }
          return _this.app.server = new ServerController({
            app: _this.app
          });
        };
      })(this));
    };

    ServerController.prototype.required = function(options, fields) {
      if (options == null) {
        throw new Error('options should be specified');
      }
      return fields.forEach(function(field) {
        if (!((options[field] != null) && options[field] !== '')) {
          throw new Error("options." + field + " should be specified");
        }
      });
    };

    ServerController.prototype.ajax = function(options) {
      var data, error, method, success, url, xhr;
      xhr = new XMLHttpRequest();
      method = options.method || 'GET';
      url = app.config.serverURLProtocol + '://' + this.app.config.serverURL + options.url;
      if (options.data) {
        if (this.app.config.debug) {
          console.log("data '" + (JSON.stringify(options.data)) + " sended to '" + url + "'");
        }
        data = $.param(options.data);
      }
      success = options.success;
      error = options.error;
      xhr.open(method, url, true);
      xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
      xhr.withCredentials = true;
      xhr.onreadystatechange = function() {
        var err, errorObject, isServerError, json;
        if (xhr.readyState === 4) {
          if (xhr.getResponseHeader('Content-Type') === '' || xhr.getResponseHeader('Content-Type') === null) {
            isServerError = true;
          } else if (xhr.getResponseHeader('Content-Type').indexOf("application/json") === -1) {
            isServerError = true;
          }
          if (isServerError) {
            errorObject = {
              error: 1,
              isConnectionError: true,
              setFlash: {
                0: {
                  msg: app.tr('Server connection error')
                }
              }
            };
            return error(errorObject, xhr);
          }
          if (xhr.status === 200 || xhr.status === 0) {
            try {
              try {
                if (xhr.responseText !== '') {
                  json = JSON.parse(xhr.responseText);
                } else {
                  json = '';
                }
              } catch (_error) {
                err = _error;
                error('JSON parse error', xhr);
              }
              return success(json, xhr);
            } catch (_error) {
              err = _error;
              if (app.config.debug) {
                return console.log(err);
              }
            }
          } else {
            try {
              try {
                if (xhr.responseText !== '') {
                  json = JSON.parse(xhr.responseText);
                } else {
                  json = '';
                }
              } catch (_error) {
                err = _error;
                error('JSON parse error', xhr);
              }
              return error(json, xhr);
            } catch (_error) {
              err = _error;
              if (app.config.debug) {
                return console.log(err);
              }
            }
          }
        }
      };
      if (data) {
        return xhr.send(data);
      } else {
        return xhr.send();
      }
    };

    ServerController.prototype.createRequest = function(description, pointer) {
      var fun, server;
      fun = (function(_this) {
        return function(options) {
          var actionName, err, os, query, version, vpageUrl, _ref;
          if (_this.app.config.googleAnalyticsEnabled && _this.app.ga) {
            if (!description.googleAnalyticsIgnore && description.method === 'POST') {
              actionName = pointer;
              if (description.vpageUrl) {
                vpageUrl = description.vpageUrl(options);
              } else {
                vpageUrl = '/api/' + actionName;
              }
              _this.app.ga('send', 'pageview', {
                page: vpageUrl,
                title: ''
              });
            }
          }
          if ((((description.cache == null) && !description.required) || description.cache === true) && fun.cache.isValid()) {
            if (_this.app.config.debug) {
              console.log("Info: return cached response for " + pointer);
            }
            if (options.success != null) {
              setTimeout((function() {
                return options.success(fun.cache.lastRes, true);
              }), 0);
            } else if (_this.app.config.debug) {
              console.log(fun.cache.lastRes);
            }
            return;
          }
          if (description.required != null) {
            _this.required(options, description.required);
          } else {
            options = options != null ? options : {};
          }
          query = {
            method: (_ref = description.method) != null ? _ref : 'GET'
          };
          query.reauth = false;
          query.success = function(data, xhr) {
            if (data.error === 1) {
              query.error(data, xhr);
            }
            if ((data.error != null) && (parseInt(data.error) === 403) && (!query.reauth)) {
              if (_this.app.config.debug) {
                console.log('Info: reauth');
              }
              query.reauth = true;
              if (options.reauth != null) {
                options.reauth();
              }
              _this.reauth({
                success: function() {
                  return _this.ajax(query);
                },
                error: function() {
                  return query.error;
                }
              });
              return;
            }
            fun.cache.set(data);
            if (data.setFlash != null) {
              _.forEach(data.setFlash, function(msg) {
                if (app.config.debug) {
                  return console.log(msg.msg);
                }
              });
            }
            return setTimeout((function() {
              var err, _i, _len, _ref1;
              if (description.invalidate != null) {
                _ref1 = description.invalidate;
                for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
                  pointer = _ref1[_i];
                  _this[pointer].cache.invalidate();
                  if (_this.app.config.debug) {
                    console.log("Info: invalidate cache for " + pointer);
                  }
                }
                if (!options.doesNotReload) {
                  _this.app.screens.current.checkDataCacheAndReload();
                }
              }
              if (description.after != null) {
                try {
                  description.after(options, data);
                } catch (_error) {
                  err = _error;
                  if (app.config.debug) {
                    console.log(err);
                  }
                }
              }
              if (options.success != null) {
                return options.success(data, false);
              } else if (_this.app.config.debug) {
                return console.log(data);
              }
            }), 0);
          };
          query.error = function(err, xhr) {
            if (xhr && (xhr.status === 403) && err.setFlash[0].msg === "not_last_session") {
              if (_this.app.config.debug) {
                console.log('Info: need reauth');
              }
              _this.trigger('app:need_reauth');
              return;
            }
            if (xhr && (xhr.status === 403) && (!query.reauth) && (options.reauth !== false)) {
              if (_this.app.config.debug) {
                console.log('Info: reauth');
              }
              query.reauth = true;
              if (options.reauth != null) {
                options.reauth();
              }
              _this.reauth({
                success: function() {
                  return _this.ajax(query);
                },
                error: function() {
                  return query.error;
                }
              });
              return;
            }
            if (xhr && xhr.status === 402) {
              _this.trigger('app:locked');
              return;
            }
            fun.cache.invalidate(err);
            if (options.error != null) {
              options.error(err, xhr);
            } else if (_this.app.config.debug) {
              console.log([query, arguments]);
            }
            if ((options.error == null) && (err.setFlash != null)) {
              return _.forEach(err.setFlash, function(msg) {
                if (app.config.debug) {
                  console.log('error in response: ', msg.msg);
                }
                return app.screens.modal('common/info-popup', {
                  msg: msg.msg
                });
              });
            }
          };
          if (description.before != null) {
            try {
              description.before(options);
            } catch (_error) {
              err = _error;
              query.error(err);
              return;
            }
          }
          if (typeof description.url === 'string') {
            query.url = description.url;
          } else {
            query.url = description.url(options);
          }
          os = app.getDeviceOs();
          version = app.getVersion();
          if (query.url.indexOf('?') === -1) {
            query.url += '?';
          } else {
            query.url += '&';
          }
          query.url += "os=" + os + "&v=" + version;
          if (description.data) {
            query.data = description.data(options);
          }
          return _this.ajax(query);
        };
      })(this);
      server = this;
      fun.cache = {
        _valid: false,
        date: 0,
        lastRes: null,
        isValid: function() {
          var _ref;
          return this._valid && (Date.now() - this.date) < ((_ref = description.cacheValidityInMs) != null ? _ref : server.defaultCacheValidityInMs);
        },
        invalidate: function(err) {
          this._valid = false;
          return this.lastRes = err;
        },
        set: function(data) {
          this._valid = true;
          this.date = Date.now();
          return this.lastRes = data;
        }
      };
      return fun;
    };

    ServerController.prototype.initialize = function(_arg) {
      var description, key, pointer, root, splittedPointer, _i, _len, _ref, _ref1, _ref2;
      this.app = _arg.app;
      this.defaultCacheValidityInMs = (_ref = this.app.config.defaultCacheValidityInMs) != null ? _ref : this.defaultCacheValidityInMs;
      _ref1 = this.requests;
      for (pointer in _ref1) {
        description = _ref1[pointer];
        root = this;
        splittedPointer = pointer.split('.');
        _ref2 = splittedPointer.slice(0, splittedPointer.length - 1);
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          key = _ref2[_i];
          if (root[key] == null) {
            root[key] = {};
          }
          root = root[key];
        }
        if (typeof description === 'string') {
          description = {
            url: description
          };
        } else if (description.url == null) {
          throw new Error("Error: URL not specified for " + pointer);
        }
        root[splittedPointer[splittedPointer.length - 1]] = this.createRequest(description, pointer);
        this[pointer] = this.createRequest(description, pointer);
      }
      if (this.app.config.debug) {
        return this.checkPointersExistance();
      }
    };

    ServerController.prototype.checkPointersExistance = function() {
      var description, fun, invalidatePointer, pointer, _ref, _results;
      _ref = this.requests;
      _results = [];
      for (pointer in _ref) {
        description = _ref[pointer];
        if (description.invalidate != null) {
          _results.push((function() {
            var _i, _len, _ref1, _results1;
            _ref1 = description.invalidate;
            _results1 = [];
            for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
              invalidatePointer = _ref1[_i];
              fun = this[invalidatePointer];
              if ((fun == null) || typeof fun !== 'function') {
                if (app.config.debug) {
                  _results1.push(console.error("Error: undefined pointer " + invalidatePointer + " in app.server.requests." + pointer + ".invalidate"));
                } else {
                  _results1.push(void 0);
                }
              } else {
                _results1.push(void 0);
              }
            }
            return _results1;
          }).call(this));
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };

    ServerController.prototype.invalidateAllCache = function() {
      var description, pointer, _ref, _results;
      _ref = this.requests;
      _results = [];
      for (pointer in _ref) {
        description = _ref[pointer];
        _results.push(this[pointer].cache.invalidate());
      }
      return _results;
    };


    /*
    			Description of all requests.
    			Each request is accessible by app.server.#{key} after initialization.
    			Request description may be in 2 forms:
    				- url only, supposed that it's GET request without parameters
    				- hash
    
    			Hash description fields are:
    				- cache - does responce caching, true by default if doesn't have required field
    				- cacheValidityInMs - how long cache is "safe", after that interval cache is invalide
    				- before hook - called before request, if throw, error goes to options.error, may mutate options
    				- after hook - called after request, if throw, error goes to options.error, may mutate options
    				- method - by default it's 'GET'
    				- url - string or function which takes passed to request options and return url
    			_cost	- required - array of fields names that are required
    				- data - function that takes options passed to request and return data hash
    
    			Also in debug mode, each request function has field .lastRes with last responce.
     */

    ServerController.prototype.requests = {
      auth: {
        cache: false,
        before: function(options) {
          app.server.invalidateAllCache();
          return localStorage.auth = JSON.stringify({
            login: options.login,
            password: options.password
          });
        },
        after: function(options, data) {
          if (app.translations.getLocale() !== data.locale) {
            return app.translations.setLocaleAndFetch(data.locale, function() {
              var _ref, _ref1;
              if ((typeof app !== "undefined" && app !== null ? (_ref = app.menu) != null ? _ref.view : void 0 : void 0) != null) {
                app.menu.view.render();
              }
              if ((typeof app !== "undefined" && app !== null ? (_ref1 = app.shortInfo) != null ? _ref1.view : void 0 : void 0) != null) {
                return app.shortInfo.view.render();
              }
            });
          }
        },
        method: 'POST',
        url: '/users/app_auth.json',
        data: function(_arg) {
          var login, password;
          login = _arg.login, password = _arg.password;
          return {
            'data[User][username]': login,
            'data[User][password]': password
          };
        }
      },
      auth_token: {
        cache: false,
        before: function(options) {
          return app.server.invalidateAllCache();
        },
        after: function(options, data) {
          if (app.translations.getLocale() !== data.locale) {
            return app.translations.setLocaleAndFetch(data.locale, function() {
              var _ref, _ref1;
              if ((typeof app !== "undefined" && app !== null ? (_ref = app.menu) != null ? _ref.view : void 0 : void 0) != null) {
                app.menu.view.render();
              }
              if ((typeof app !== "undefined" && app !== null ? (_ref1 = app.shortInfo) != null ? _ref1.view : void 0 : void 0) != null) {
                return app.shortInfo.view.render();
              }
            });
          }
        },
        method: 'POST',
        url: '/users/app_auth.json',
        data: function(_arg) {
          var token;
          token = _arg.token;
          return {
            'data[token]': token
          };
        }
      },
      'reauth': {
        cache: false,
        before: function(options) {
          var login, password, _ref;
          if (localStorage.auth != null) {
            _ref = JSON.parse(localStorage.auth), login = _ref.login, password = _ref.password;
            options.login = login;
            return options.password = password;
          } else {
            throw "Error: Can't reauth to " + login + " account";
          }
        },
        method: 'POST',
        url: '/users/app_auth.json',
        data: function(_arg) {
          var login, password;
          login = _arg.login, password = _arg.password;
          return {
            'data[User][username]': login,
            'data[User][password]': password
          };
        }
      },
      'logout': {
        before: function() {
          app.server.invalidateAllCache();
          return localStorage.clear();
        },
        cache: false,
        method: 'POST',
        url: '/users/logout.json'
      },
      'user.registrationInfo': {
        url: '/users/register_info.json',
        cacheValidityInMs: 6000 * 1000
      },
      'user.registration': {
        before: function() {
          app.showLoader();
          return $('.js-back').hide();
        },
        after: function() {
          app.hideLoader();
          return $('.js-back').show();
        },
        url: '/users/register.json',
        method: 'POST',
        data: function(_arg) {
          var avatar, city_id, email, passwd, passwd_confirm, ref_id, sex, username;
          username = _arg.username, email = _arg.email, passwd = _arg.passwd, passwd_confirm = _arg.passwd_confirm, avatar = _arg.avatar, sex = _arg.sex, city_id = _arg.city_id, ref_id = _arg.ref_id;
          return {
            'data[User][username]': username,
            'data[User][email]': email,
            'data[User][passwd]': passwd,
            'data[User][passwd_confirm]': passwd_confirm,
            'data[User][avatar]': avatar,
            'data[User][sex]': sex,
            'data[User][city_id]': city_id,
            'data[User][ref_id]': ref_id,
            'data[User][agreement]': 1
          };
        }
      },
      'user.passwordRecovery': {
        url: '/users/forgot_password.json',
        cache: false,
        method: 'POST',
        data: function(_arg) {
          var email;
          email = _arg.email;
          return {
            'data[User][email]': email
          };
        }
      },

      /*
      				Social
       */
      'social.getLoginUrls': {
        cache: false,
        method: 'GET',
        url: '/social/api/getLoginUrl.json'
      },
      'social.getLinkedAccounts': {
        cache: false,
        url: '/social/api/getLinkedAccounts.json',
        method: 'GET'
      },
      'social.register': {
        cache: false,
        url: '/social/api/register.json',
        data: function(_arg) {
          var provider, socialUser, token, user;
          provider = _arg.provider, user = _arg.user, token = _arg.token, socialUser = _arg.socialUser;
          return {
            'data[User]': user,
            'data[token]': token,
            'data[socialUser]': socialUser,
            'data[provider]': provider
          };
        },
        method: 'POST'
      },
      'social.auth': {
        cache: false,
        url: '/social/api/auth.json',
        data: function(_arg) {
          var provider, token, userId;
          provider = _arg.provider, userId = _arg.userId, token = _arg.token;
          return {
            'data[token]': token,
            'data[user_id]': userId,
            'data[provider]': provider
          };
        },
        method: 'POST'
      },
      'social.linkAccount': {
        cache: false,
        url: '/social/api/linkAccount.json',
        data: function(_arg) {
          var provider, socialUser, token;
          provider = _arg.provider, socialUser = _arg.socialUser, token = _arg.token;
          return {
            'data[token]': token,
            'data[socialUser]': socialUser,
            'data[provider]': provider
          };
        },
        method: 'POST'
      },
      'translations': {
        url: function(_arg) {
          var locale;
          locale = _arg.locale;
          if (locale != null) {
            return "/translations/get/" + locale + ".json";
          } else {
            return "/translations/get.json";
          }
        }
      },
      'user.startPushNotifications': {
        url: '/users/start_push_notifications.json',
        cache: false,
        method: 'POST',
        data: function(_arg) {
          var device_platform, device_token;
          device_platform = _arg.device_platform, device_token = _arg.device_token;
          return {
            'data[User][device_platform]': device_platform,
            'data[User][device_token]': device_token
          };
        }
      },
      'user.saveUtcOffset': {
        url: '/users/save_utcOffset.json',
        cache: false,
        method: 'POST',
        data: function(_arg) {
          var utcOffset;
          utcOffset = _arg.utcOffset;
          return {
            'data[User][utc_offset]': utcOffset
          };
        }
      },

      /*
      				User
       */
      'user.info': {
        cache: false,
        url: '/users/infos.json'
      },
      'user.info.short': {
        cacheValidityInMs: 5 * 1000,
        url: '/users/short_infos.json'
      },
      'user.notification_badges': {
        cache: false,
        url: '/users/notification_badges.json'
      },
      'user.profile': {
        cache: false,
        required: ['userId'],
        url: function(_arg) {
          var userId;
          userId = _arg.userId;
          return "/users/short_infos/" + userId + ".json";
        }
      },
      'user.profile.equippedItems': {
        cache: false,
        required: ['userId'],
        url: function(_arg) {
          var userId;
          userId = _arg.userId;
          return "/user_items/equipped/" + userId + ".json";
        }
      },
      'user.info.profession': {
        url: '/users/profession.json'
      },
      'user.info.sport': {
        cache: false,
        url: '/users/sport.json'
      },
      'user.status': {
        url: '/users/get_user_social_status.json'
      },
      'user.blocks': {
        url: '/users/blocks.json',
        cache: true
      },
      'user.updateEnergyTrigger': {
        cache: false,
        url: '/users/updateEnergyTrigger.json',
        method: 'POST',
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'user.levelUp': {
        cache: false,
        url: '/levels/user_bonuses/get.json',
        method: 'POST'
      },
      'user.levelUp.getAdditionBonuses': {
        cache: false,
        required: ['bonusId'],
        method: 'POST',
        url: '/levels/user_bonuses/add.json',
        data: function(_arg) {
          var bonusId;
          bonusId = _arg.bonusId;
          return {
            'data[UserBonus][bonus_id]': bonusId
          };
        }
      },
      'user.checkEvents': {
        cache: false,
        url: '/users/check.json'
      },
      'user.node.longpoll': {
        cache: false,
        reauth: false,
        googleAnalyticsIgnore: true,
        url: function() {
          return "/longpoll?lastTime=0";
        }
      },
      'user.email': {
        cache: false,
        url: '/users/get_email.json'
      },
      'user.changeEmail': {
        url: '/users/change_email.json',
        cache: false,
        method: 'POST',
        data: function(_arg) {
          var email;
          email = _arg.email;
          return {
            'data[User][email]': email
          };
        }
      },
      'user.changePassword': {
        url: '/users/change_password.json',
        cache: false,
        method: 'POST',
        data: function(_arg) {
          var old_password, passwd, passwd_confirm;
          passwd = _arg.passwd, passwd_confirm = _arg.passwd_confirm, old_password = _arg.old_password;
          return {
            'data[User][passwd]': passwd,
            'data[User][passwd_confirm]': passwd_confirm,
            'data[User][old_password]': old_password
          };
        }
      },
      'user.usernameChangeInfo': {
        cache: false,
        url: '/users/get_username_change_info.json'
      },
      'user.changeUsername': {
        url: '/users/change_nickname.json',
        cache: false,
        invalidate: ['user.info'],
        method: 'POST',
        data: function(_arg) {
          var username;
          username = _arg.username;
          return {
            'data[User][username]': username
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'user.changeAvatarPrice': {
        cache: false,
        url: '/users/get_avatar_change_price.json'
      },
      'user.changeAvatar': {
        url: '/users/change_avatar.json',
        cache: false,
        invalidate: ['user.info'],
        method: 'POST',
        data: function(_arg) {
          var avatar, sex;
          avatar = _arg.avatar, sex = _arg.sex;
          return {
            'data[User][avatar]': avatar,
            'data[User][sex]': sex
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'user.languages': {
        url: '/users/get_localeList.json'
      },
      'user.setLanguage': {
        url: '/users/change_user_localization.json',
        cache: false,
        invalidate: ['user.info', 'user.info.short'],
        method: 'POST',
        data: function(_arg) {
          var localization;
          localization = _arg.localization;
          return {
            'data[User][localization]': localization
          };
        }
      },
      'user.get_referrals': {
        url: '/users/get_referrals.json',
        cacheValidityInMs: 300 * 1000
      },
      'user.get_referrals_share_data': {
        cache: true,
        url: '/users/get_referrals_share_data.json'
      },
      'user.search': {
        cache: false,
        required: ['page'],
        url: function(_arg) {
          var name, onlineOnly, page;
          page = _arg.page, name = _arg.name, onlineOnly = _arg.onlineOnly;
          return "/users/search.json?page=" + (page || 1) + "&name=" + (name || '-') + (onlineOnly ? '&online=1' : '');
        }
      },
      'user.redeem_code': {
        cache: false,
        invalidate: ['user.info.short'],
        required: ['code'],
        url: "/users/redeem_code.json",
        method: 'POST',
        data: function(_arg) {
          var code;
          code = _arg.code;
          return {
            'data[RedeemCode][code]': code
          };
        },
        after: function() {
          return app.shortInfo.view.reload();
        }
      },
      'friends.list': {
        cache: false,
        method: 'GET',
        url: function(_arg) {
          var name;
          name = _arg.name;
          return "/user_friends/index.json?name=" + (name || '-');
        }
      },
      'friends.search': {
        cache: false,
        method: 'GET',
        url: function(_arg) {
          var name, page;
          name = _arg.name, page = _arg.page;
          return "/user_friends/search.json?page=" + (page || 1) + "&name=" + (name || '-');
        }
      },
      'friends.search_social': {
        cache: false,
        method: 'POST',
        url: function() {
          return "/user_friends/search_social.json";
        },
        vpageUrl: function(_arg) {
          var provider;
          provider = _arg.provider;
          return "/api/user_friends/search_social/" + provider;
        },
        data: function(_arg) {
          var friendIds, provider;
          provider = _arg.provider, friendIds = _arg.friendIds;
          return {
            'data[provider]': provider,
            'data[friendIds]': friendIds
          };
        }
      },
      'friends.requests': {
        cache: false,
        method: 'GET',
        url: function(_arg) {
          var name, type;
          type = _arg.type, name = _arg.name;
          return "/user_friends/requests.json?type=" + (type || 'all') + "&name=" + (name || '-');
        }
      },
      'friends.requests_count': {
        cache: false,
        method: 'GET',
        url: function(_arg) {
          var type;
          type = _arg.type;
          return "/user_friends/requests_count.json?type=" + (type || 'to');
        }
      },
      'friends.remove_friend': {
        cache: false,
        required: ['friendId'],
        method: 'POST',
        url: '/user_friends/remove_friend.json',
        data: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return {
            'data[UserFriend][friend_id]': friendId
          };
        },
        vpageUrl: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return "/api/user_friends/remove_friend/" + friendId;
        }
      },
      'friends.add_request': {
        cache: false,
        required: ['friendId'],
        method: 'POST',
        url: '/user_friends/add_request.json',
        data: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return {
            'data[UserFriend][friend_id]': friendId
          };
        },
        vpageUrl: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return "/api/user_friends/add_request/" + friendId;
        }
      },
      'friends.accept_request': {
        cache: false,
        invalidate: ['user.notification_badges'],
        required: ['friendId'],
        method: 'POST',
        url: '/user_friends/accept_request.json',
        data: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return {
            'data[UserFriend][friend_id]': friendId
          };
        },
        vpageUrl: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return "/api/user_friends/accept_request/" + friendId;
        },
        after: function() {
          return app.menu.view.reload();
        }
      },
      'friends.reject_request': {
        cache: false,
        required: ['friendId'],
        method: 'POST',
        url: '/user_friends/reject_request.json',
        data: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return {
            'data[UserFriend][friend_id]': friendId
          };
        },
        vpageUrl: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return "/api/user_friends/reject_request/" + friendId;
        }
      },
      'friends.revoke_request': {
        cache: false,
        required: ['friendId'],
        method: 'POST',
        url: '/user_friends/revoke_request.json',
        data: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return {
            'data[UserFriend][friend_id]': friendId
          };
        },
        vpageUrl: function(_arg) {
          var friendId;
          friendId = _arg.friendId;
          return "/api/user_friends/revoke_request/" + friendId;
        }
      },
      'bonus.info': {
        required: ['type', 'id'],
        cacheValidityInMs: 300 * 1000,
        url: function(_arg) {
          var id, type;
          type = _arg.type, id = _arg.id;
          return "/levels/user_bonuses/info/" + type + "/" + id + ".json";
        }
      },
      'fightPoints.info': {
        cache: false,
        url: "/user_fight_skills/fight_skill_inhabitant.json"
      },
      'fightPoints.upLevel': {
        cache: false,
        required: ['fightSkillTypeId'],
        method: 'POST',
        url: '/user_fight_skills/up_level.json',
        data: function(_arg) {
          var fightSkillTypeId;
          fightSkillTypeId = _arg.fightSkillTypeId;
          return {
            'data[UserFightSkill][type_id]': fightSkillTypeId
          };
        },
        vpageUrl: function(_arg) {
          var fightSkillTypeId;
          fightSkillTypeId = _arg.fightSkillTypeId;
          return "/api/user_fight_skills/up_level/" + fightSkillTypeId;
        }
      },

      /*
      				Hospital
       */
      'hospital.service': {
        cacheValidityInMs: 300 * 1000,
        url: '/hospitals/heal.json'
      },
      'hospital.service.healFullHP': {
        cache: false,
        invalidate: ['hospital.service', 'user.info.short'],
        method: 'POST',
        url: '/hospitals/heal_full_hp.json',
        after: function() {
          return app.shortInfo.view.reload();
        }
      },
      'hospital.service.healTrauma': {
        cache: false,
        invalidate: ['hospital.service', 'user.info.short'],
        required: ['traumaId'],
        url: "/hospitals/trauma_heal.json",
        method: 'POST',
        data: function(_arg) {
          var traumaId;
          traumaId = _arg.traumaId;
          return {
            'data[Trauma][id]': traumaId
          };
        },
        after: function() {
          return app.shortInfo.view.reload();
        }
      },

      /*
      				Stadium
       */
      'stadium.train': {
        cache: false,
        required: ['energy', 'skillId'],
        invalidate: ['stadium.trainers', 'user.info.sport', 'hospital.service', 'user.info', 'user.info.short'],
        url: '/sport_activities/start_sport_activity.json',
        method: 'POST',
        vpageUrl: function(_arg) {
          var energy, skillId;
          energy = _arg.energy, skillId = _arg.skillId;
          return "/api/sport_activities/start_sport_activity/" + skillId;
        },
        data: function(_arg) {
          var energy, skillId;
          energy = _arg.energy, skillId = _arg.skillId;
          return {
            'data[SportActivity][energy]': energy,
            'data[SportActivity][sport_skill_type_id]': skillId
          };
        },
        after: function(options) {
          app.shortInfo.changeEnergy(-options.energy);
          return app.shortInfo.view.reload();
        }
      },
      'stadium.trainWithTrainer': {
        cache: false,
        required: ['licenseId', 'programId', 'skillId', 'energy'],
        invalidate: ['stadium.trainers', 'user.info.sport', 'hospital.service', 'user.info'],
        method: 'POST',
        url: '/sport_activities/use_program.json',
        vpageUrl: function(_arg) {
          var energy, licenseId, programId, skillId;
          licenseId = _arg.licenseId, programId = _arg.programId, skillId = _arg.skillId, energy = _arg.energy;
          return "/api/sport_activities/use_program/" + skillId;
        },
        data: function(_arg) {
          var energy, licenseId, programId, skillId;
          licenseId = _arg.licenseId, programId = _arg.programId, skillId = _arg.skillId, energy = _arg.energy;
          return {
            'data[CoachProgram][license_id]': licenseId,
            'data[CoachProgram][id]': programId,
            'data[SportActivity][sport_skill_type_id]': skillId,
            'data[SportActivity][energy]': energy
          };
        },
        after: function(options) {
          app.shortInfo.changeEnergy(-options.energy);
          return app.shortInfo.view.reload();
        }
      },
      'stadium.trainers': {
        url: '/sport_activities/train.json',
        cache: false
      },

      /*
      				Military
       */
      'military.info': '/military/info',
      'military.pve.gangs': '/military/pve/gangs',
      'military.pve.fight': {
        cache: false,
        required: ['complexity', 'rank'],
        invalidate: ['user.info', 'military.pve.gangs', 'military.info', 'hospital.service'],
        method: 'POST',
        url: function(_arg) {
          var complexity, rank;
          complexity = _arg.complexity, rank = _arg.rank;
          return "/military/pve/gangs/" + complexity + "/ranks/" + rank + "/fight";
        },
        vpageUrl: function(_arg) {
          var complexity, rank;
          complexity = _arg.complexity, rank = _arg.rank;
          return "/api/military/pve/gangs/fight/" + complexity + "/" + rank;
        },
        after: function() {
          return app.shortInfo.view.reload();
        }
      },
      'military.pvp.info': '/military/pvp/info',
      'military.pvp.fight': {
        cache: false,
        invalidate: ['user.info', 'military.info', 'military.pvp.info', 'hospital.service'],
        method: 'POST',
        url: '/military/pvp/fight',
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'military.pvp.fight.cancel': {
        cache: false,
        method: 'POST',
        url: '/military/pvp/fight/cancel'
      },
      'military.at.areas': {
        cache: false,
        url: '/military/areas_takeover/areas'
      },
      'military.at.areas.map': {
        cache: false,
        required: ['areaId'],
        url: function(_arg) {
          var areaId;
          areaId = _arg.areaId;
          return "/military/areas_takeover/areas/" + areaId + "/map";
        }
      },
      'military.at.areas.post': {
        cache: false,
        required: ['areaId', 'postId'],
        url: function(_arg) {
          var areaId, postId;
          areaId = _arg.areaId, postId = _arg.postId;
          return "/military/areas_takeover/areas/" + areaId + "/posts/" + postId;
        }
      },
      'military.at.areas.scout': {
        cache: false,
        required: ['areaId', 'postId'],
        invalidate: ['user.info', 'military.info', 'military.pvp.info', 'hospital.service'],
        url: function(_arg) {
          var areaId, postId;
          areaId = _arg.areaId, postId = _arg.postId;
          return "/military/areas_takeover/areas/" + areaId + "/posts/" + postId + "/scout";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'military.at.areasArchive': '/areas_takeover/takeovers/archive.json',
      'military.at.checkActiveTakeover': '/areas_takeover/takeovers/check_takeover.json',
      'military.at.sendClone': {
        cache: false,
        required: ['areaId', 'postId'],
        invalidate: ['user.info', 'military.info', 'military.pvp.info', 'hospital.service'],
        method: 'POST',
        url: function(_arg) {
          var areaId, postId;
          areaId = _arg.areaId, postId = _arg.postId;
          return "/military/areas_takeover/areas/" + areaId + "/posts/" + postId + "/clone";
        },
        data: function(_arg) {
          var tactics;
          tactics = _arg.tactics;
          return {
            tactics: tactics
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'military.at.checkClone': {
        cache: false,
        method: 'POST',
        url: "/military/areas_takeover/areas/posts/clone/check"
      },
      'military.at.roundResult': {
        cache: false,
        invalidate: ['military.at.areasArchive'],
        required: ['roundId'],
        url: function(_arg) {
          var roundId;
          roundId = _arg.roundId;
          return "/military/areas_takeover/rounds/" + roundId + "/result";
        }
      },
      'military.at.postResult': {
        cache: false,
        required: ['roundId', 'postId'],
        url: function(_arg) {
          var postId, roundId;
          roundId = _arg.roundId, postId = _arg.postId;
          return "/military/areas_takeover/rounds/" + roundId + "/posts/" + postId + "/result";
        }
      },
      'military.at.result': {
        cache: false,
        required: ['areaTakeoverId'],
        url: function(_arg) {
          var areaTakeoverId;
          areaTakeoverId = _arg.areaTakeoverId;
          return "/military/areas_takeover/" + areaTakeoverId + "/result";
        }
      },
      'military.at.register': {
        cache: false,
        method: 'POST',
        required: ['areaId'],
        url: '/areas_takeover/bills/add.json',
        data: function(_arg) {
          var areaId;
          areaId = _arg.areaId;
          return {
            'data[AreasTakeoverBill][cities_area_id]': areaId
          };
        }
      },
      'military.districts.get': {
        cache: false,
        url: function() {
          return "/areas_takeover/districts/all.json";
        }
      },
      'military.districts.available_for_takeover': {
        cache: false,
        url: function() {
          return "/areas_takeover/districts/districts_for_takeover.json";
        }
      },
      'military.cloneTactics': {
        cacheValidityInMs: 6000 * 1000,
        url: function() {
          return "/areas_takeover/tactics/clone_tactics.json";
        }
      },
      'military.saveCustomTactics': {
        cache: false,
        invalidate: ['military.cloneTactics'],
        method: 'POST',
        required: ['associationsData'],
        url: '/areas_takeover/tactics/save_custom.json',
        data: function(_arg) {
          var associationsData;
          associationsData = _arg.associationsData;
          return {
            'data[associationsData]': associationsData
          };
        }
      },

      /*
      				Airport
       */
      'airport.flights': {
        cacheValidityInMs: 300 * 1000,
        url: '/airport/flights.json'
      },
      'airport.flyToCity': {
        required: ['cityId'],
        invalidate: ['airport.flights', 'house.info'],
        method: 'POST',
        url: '/users/fly.json',
        data: function(_arg) {
          var cityId;
          cityId = _arg.cityId;
          return {
            'data[User][to_city]': cityId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'airport.price': {
        cacheValidityInMs: 300 * 1000,
        required: ['cityId'],
        url: function(_arg) {
          var cityId;
          cityId = _arg.cityId;
          return "/airport/price/" + cityId + ".json";
        }
      },

      /*
      				Port
       */
      'port': {
        cacheValidityInMs: 300 * 1000,
        url: '/seaports/index.json'
      },
      'port.fish': {
        cache: false,
        invalidate: ['inventory', 'port'],
        url: '/seaports/begin_fishing.json',
        method: 'POST',
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'port.ship.buy': {
        cache: false,
        invalidate: ['port'],
        url: '/seaports/buy_ship.json',
        method: 'POST',
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'port.ship.rename': {
        method: 'POST',
        required: ['shipId', 'name'],
        cache: false,
        invalidate: ['port', 'inventory'],
        url: '/seaports/rename_ship.json',
        data: function(_arg) {
          var name, shipId;
          shipId = _arg.shipId, name = _arg.name;
          return {
            'data[UserShip][id]': shipId,
            'data[UserShip][name]': name
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },

      /*
      				Suggestions
       */
      'suggestions.newSuggestions': {
        cacheValidityInMs: 300 * 1000,
        url: '/suggestions/new_suggestions.json'
      },
      'suggestions.mySuggestions': '/suggestions/my_suggestions.json',
      'suggestions.popularSuggestions': {
        cacheValidityInMs: 300 * 1000,
        url: '/suggestions/popular_suggestions.json'
      },
      'suggestions.post': {
        cache: false,
        invalidate: [],
        url: function(_arg) {
          var suggestionId;
          suggestionId = _arg.suggestionId;
          return "/suggestions/view/" + suggestionId + ".json";
        }
      },
      'suggestions.createSuggestion': {
        cache: false,
        invalidate: ['suggestions.newSuggestions', 'suggestions.mySuggestions', 'suggestions.popularSuggestions'],
        method: 'POST',
        data: function(_arg) {
          var description, title;
          title = _arg.title, description = _arg.description;
          return {
            'data[Suggestion][title]': title,
            'data[Suggestion][description]': description
          };
        },
        url: '/suggestions/add_suggestion.json'
      },
      'suggestions.addComment': {
        required: ['suggestionId', 'message'],
        method: 'POST',
        cache: false,
        invalidate: ['suggestions.newSuggestions', 'suggestions.mySuggestions', 'suggestions.popularSuggestions'],
        url: '/suggestions/add_comment.json',
        data: function(_arg) {
          var message, suggestionId;
          suggestionId = _arg.suggestionId, message = _arg.message;
          return {
            'data[SuggestionComment][suggestion_id]': suggestionId,
            'data[SuggestionComment][body]': message
          };
        }
      },
      'suggestions.comment.edit': {
        required: ['commentId'],
        method: 'GET',
        cache: false,
        url: function(_arg) {
          var commentId;
          commentId = _arg.commentId;
          return "/suggestions/edit_comment/" + commentId + ".json";
        }
      },
      'suggestions.comment.delete': {
        required: ['commentId'],
        invalidate: ['suggestions.newSuggestions', 'suggestions.mySuggestions', 'suggestions.popularSuggestions'],
        method: 'POST',
        cache: false,
        url: function(_arg) {
          var commentId;
          commentId = _arg.commentId;
          return "/suggestions/delete_comment/" + commentId + ".json";
        }
      },
      'suggestions.comment.update': {
        required: ['commentId', 'body'],
        method: 'POST',
        cache: false,
        invalidate: ['suggestions.newSuggestions', 'suggestions.mySuggestions', 'suggestions.popularSuggestions'],
        url: function(_arg) {
          var commentId;
          commentId = _arg.commentId;
          return "/suggestions/edit_comment/" + commentId + ".json";
        },
        data: function(_arg) {
          var body;
          body = _arg.body;
          return {
            'data[SuggestionComment][body]': body
          };
        }
      },
      'suggestions.addLike': {
        cache: false,
        invalidate: ['suggestions.newSuggestions', 'suggestions.mySuggestions', 'suggestions.popularSuggestions', 'suggestions.post'],
        url: function() {
          return "/suggestions/like.json";
        },
        required: ['suggestionId'],
        method: 'POST',
        data: function(_arg) {
          var suggestionId;
          suggestionId = _arg.suggestionId;
          return {
            'data[Suggestion][id]': suggestionId
          };
        }
      },
      'suggestions.addDislike': {
        cache: false,
        invalidate: ['suggestions.newSuggestions', 'suggestions.mySuggestions', 'suggestions.popularSuggestions', 'suggestions.post'],
        url: function() {
          return "/suggestions/dislike.json";
        },
        required: ['suggestionId'],
        method: 'POST',
        data: function(_arg) {
          var suggestionId;
          suggestionId = _arg.suggestionId;
          return {
            'data[Suggestion][id]': suggestionId
          };
        }
      },

      /*
      				Messages
       */
      messages: {
        url: '/messages/message_list.json',
        cache: false
      },
      'messages.fromUser': {
        cache: false,
        invalidate: ['user.notification_badges'],
        required: ['userId', 'page'],
        url: function(_arg) {
          var page, userId;
          userId = _arg.userId, page = _arg.page;
          return "/messages/new_msg/" + userId + "/page:" + page + ".json";
        },
        after: function() {
          return app.menu.view.reload();
        }
      },
      'messages.send': {
        required: ['userId', 'message'],
        method: 'POST',
        invalidate: ['messages', 'messages.fromUser'],
        url: '/messages/new_message.json',
        data: function(_arg) {
          var message, userId;
          userId = _arg.userId, message = _arg.message;
          return {
            'data[Message][receiver_id]': userId,
            'data[Message][body]': message
          };
        }
      },

      /*
      				Cities
       */
      cities: {
        cacheValidityInMs: 300 * 1000,
        url: '/city_hall/cities.json'
      },

      /*
      				Feed
       */
      feed: {
        cacheValidityInMs: 300 * 1000,
        url: '/event_logs/get.json'
      },
      groupFeed: {
        invalidate: ['user.notification_badges'],
        required: ['feedGroup'],
        url: function(_arg) {
          var feedGroup;
          feedGroup = _arg.feedGroup;
          return "/event_logs/get_group_feed/" + feedGroup + ".json";
        },
        cacheValidityInMs: 300 * 1000,
        after: function(options) {
          if (options.feedGroup === 'important') {
            return app.menu.view.reload();
          }
        }
      },
      countGroupEvents: {
        url: "/event_logs/count_group_events.json",
        cache: false
      },

      /*
      				Inventory
       */
      'inventory': {
        cache: false,
        url: '/user_items/storage.json'
      },
      'inventory.unequipped': {
        cache: false,
        url: '/user_items/unequippedStorage.json'
      },
      'inventory.buySlots': {
        cache: false,
        required: ['size'],
        invalidate: ['inventory'],
        url: function() {
          return "/users/inv_size.json";
        },
        method: 'POST',
        data: function(_arg) {
          var size;
          size = _arg.size;
          return {
            'data[UserItem][size]': size
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'inventory.itemInfo': {
        cache: false,
        required: ['itemId'],
        url: function(_arg) {
          var itemId;
          itemId = _arg.itemId;
          return "/user_items/get_info/" + itemId + ".json";
        }
      },
      'inventory.availableItemInfo': {
        cache: false,
        required: ['itemId'],
        url: function(_arg) {
          var itemId;
          itemId = _arg.itemId;
          return "/user_items/get_info/" + itemId + ".json?available_only=1";
        }
      },
      'inventory.putOn': {
        cache: false,
        required: ['itemId', 'slotId'],
        invalidate: ['inventory', 'tradeCenter.itemsToSell'],
        url: function() {
          return "/user_items/put_item_on.json";
        },
        method: 'POST',
        data: function(_arg) {
          var itemId, slotId;
          itemId = _arg.itemId, slotId = _arg.slotId;
          return {
            'data[UserItem][id]': itemId,
            'data[UserItem][slot_id]': slotId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'inventory.useSpecial': {
        cache: false,
        required: ['itemId'],
        method: 'POST',
        invalidate: ['inventory', 'tradeCenter.itemsToSell'],
        url: '/user_items/use_special_item.json',
        data: function(_arg) {
          var itemId;
          itemId = _arg.itemId;
          return {
            'data[UserItem][item_id]': itemId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'inventory.use': {
        cache: false,
        required: ['itemId', 'cityId', 'typeId'],
        method: 'POST',
        invalidate: ['inventory', 'tradeCenter.itemsToSell'],
        url: '/user_items/use_item.json',
        data: function(_arg) {
          var cityId, itemId, typeId;
          itemId = _arg.itemId, cityId = _arg.cityId, typeId = _arg.typeId;
          return {
            'data[UserItem][item_id]': itemId,
            'data[UserItem][city_id]': cityId,
            'data[UserItem][type]': typeId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'inventory.useForm': {
        cache: false,
        required: ['itemId'],
        url: function(_arg) {
          var itemId;
          itemId = _arg.itemId;
          return "/user_items/get_use_form/" + itemId + ".json";
        }
      },
      'inventory.eat': {
        cache: false,
        required: ['itemId'],
        method: 'POST',
        invalidate: ['inventory', 'tradeCenter.itemsToSell'],
        url: '/user_items/eat_user_item.json',
        data: function(_arg) {
          var itemId;
          itemId = _arg.itemId;
          return {
            'data[UserItem][item_id]': itemId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'inventory.remove': {
        cache: false,
        required: ['itemId'],
        method: 'POST',
        invalidate: ['inventory', 'tradeCenter.itemsToSell'],
        url: '/user_items/delete_items.json',
        data: function(_arg) {
          var itemId;
          itemId = _arg.itemId;
          return {
            'data[UserItem][item_id]': itemId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'inventory.putOff': {
        cache: false,
        required: ['itemId'],
        method: 'POST',
        invalidate: ['inventory', 'tradeCenter.itemsToSell'],
        url: '/user_items/put_item_off.json',
        data: function(_arg) {
          var itemId;
          itemId = _arg.itemId;
          return {
            'data[UserItem][item_id]': itemId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'inventory.furniture': {
        url: '/user_items/get_furniture.json'
      },

      /*
      				Trade Center
       */
      'tradeCenter.itemGroups': {
        url: '/exchanges/items_groups_categories.json'
      },
      'tradeCenter.businessGroups': {
        url: '/exchanges/items_groups_categories_business.json'
      },
      'tradeCenter.availableItemGroups': {
        cache: false,
        url: '/exchanges/available_items_groups_categories.json'
      },
      'tradeCenter.availableBusinessGroups': {
        cache: false,
        url: '/exchanges/available_categories_business.json'
      },
      'tradeCenter.availableItems': {
        cache: false,
        required: ['category'],
        url: function(_arg) {
          var category;
          category = _arg.category;
          return "/exchanges/available_items/" + category + ".json";
        }
      },
      'tradeCenter.availableStock': {
        cache: false,
        url: '/stock_exchanges/available_stock.json'
      },
      'tradeCenter.availableCurrency': {
        cache: false,
        url: '/currency/available.json'
      },
      'tradeCenter.stocksByCorporation': {
        cache: false,
        url: function(_arg) {
          var itemName;
          itemName = _arg.itemName;
          if (itemName != null) {
            return "/stock_exchanges/grouped_by_corporation.json?corporationName=" + itemName;
          } else {
            return '/stock_exchanges/grouped_by_corporation.json';
          }
        }
      },
      'tradeCenter.currencyLotsList': {
        cache: false,
        url: function() {
          return "/currency/index.json";
        }
      },
      'tradeCenter.currencyVgLots': {
        cache: false,
        url: function() {
          return "/currency/lots/vg.json";
        }
      },
      'tradeCenter.currencyVdLots': {
        cache: false,
        url: function() {
          return "/currency/lots/vd.json";
        }
      },
      'tradeCenter.lotsList': {
        cache: false,
        required: ['category'],
        url: function(_arg) {
          var category, itemName;
          category = _arg.category, itemName = _arg.itemName;
          if (itemName != null) {
            return "/exchanges/lots_by_type_user/" + category + ".json?itemTypeName=" + itemName;
          } else {
            return "/exchanges/lots_by_type_user/" + category + ".json";
          }
        }
      },
      'tradeCenter.lotsListCityHall': {
        cache: false,
        url: "/city_item_proposals/sell_index.json"
      },
      'tradeCenter.sellToCity': {
        required: ['cityLotId', 'number'],
        cache: false,
        invalidate: ['tradeCenter.lotsListCityHall', 'inventory', 'user.info'],
        url: function(_arg) {
          var cityLotId;
          cityLotId = _arg.cityLotId;
          return "/city_item_proposals/user_buy/" + cityLotId + ".json";
        },
        method: 'POST',
        data: function(_arg) {
          var number;
          number = _arg.number;
          return {
            'data[CityItemProposal][number]': number
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'tradeCenter.itemTypesList': {
        cache: false,
        url: function(_arg) {
          var category;
          category = _arg.category;
          return "/exchanges/items_by_type/" + category + ".json";
        }
      },
      'tradeCenter.lotsListCompany': {
        cache: false,
        url: function(_arg) {
          var category, companyId;
          category = _arg.category, companyId = _arg.companyId;
          return "/exchanges/lots_by_type_company/" + companyId + "/" + category + ".json";
        }
      },
      'tradeCenter.lotsOffer': {
        cache: false,
        url: function(_arg) {
          var currency, direction, itemTypeId, sort;
          currency = _arg.currency, itemTypeId = _arg.itemTypeId, sort = _arg.sort, direction = _arg.direction;
          if (sort == null) {
            sort = "price";
          }
          if (direction == null) {
            direction = "asc";
          }
          return "/exchanges/lot_offers/" + currency + "/" + itemTypeId + "/" + sort + "/" + direction + ".json";
        }
      },
      'tradeCenter.lotsOfferCompany': {
        cache: false,
        url: function(_arg) {
          var companyId, currency, direction, itemTypeId, sort;
          currency = _arg.currency, itemTypeId = _arg.itemTypeId, companyId = _arg.companyId, sort = _arg.sort, direction = _arg.direction;
          if (sort == null) {
            sort = "price";
          }
          if (direction == null) {
            direction = "asc";
          }
          return "/exchanges/lot_offers_company/" + currency + "/" + itemTypeId + "/" + companyId + "/" + sort + "/" + direction + ".json";
        }
      },
      'tradeCenter.lotsOfferShares': {
        cache: false,
        url: function(_arg) {
          var corporationId, currency, direction, sort;
          currency = _arg.currency, corporationId = _arg.corporationId, sort = _arg.sort, direction = _arg.direction;
          if (sort == null) {
            sort = "price";
          }
          if (direction == null) {
            direction = "asc";
          }
          return "/stock_exchanges/lot_offers/" + currency + "/" + corporationId + "/" + sort + "/" + direction + ".json";
        }
      },
      'tradeCenter.userLots': {
        cache: false,
        url: "/exchanges/user_lots.json"
      },
      'tradeCenter.userCurrencyLots': {
        cache: false,
        url: "/currency/user_lots.json"
      },
      'tradeCenter.userStockLots': {
        cache: false,
        url: "/stock_exchanges/lots.json"
      },
      'tradeCenter.itemsToBuy': {
        cache: false,
        url: function(_arg) {
          var categoryId;
          categoryId = _arg.categoryId;
          if (categoryId != null) {
            return "/exchanges/by_type/" + categoryId + ".json";
          } else {
            return '/exchanges/item_buy.json';
          }
        }
      },
      'tradeCenter.itemsToSell': {
        cache: false,
        url: '/exchanges/user_sell.json'
      },
      'tradeCenter.companyItemsToSell': {
        cache: false,
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/exchanges/company_sell/" + companyId + ".json";
        }
      },
      'tradeCenter.corporationItemsToSell': {
        cache: false,
        url: function(_arg) {
          var corporationId;
          corporationId = _arg.corporationId;
          return "/exchanges/corporation_sell/" + corporationId + ".json";
        }
      },
      'tradeCenter.createLot': {
        required: ['itemTypeId', 'amount', 'price', 'currency'],
        cache: false,
        invalidate: ['tradeCenter.availableItems', 'tradeCenter.lotsList', 'tradeCenter.lotsOffer', 'tradeCenter.userLots', 'inventory', 'user.info'],
        url: '/exchanges/add_user_exchange.json',
        method: 'POST',
        data: function(_arg) {
          var amount, currency, itemTypeId, price;
          itemTypeId = _arg.itemTypeId, amount = _arg.amount, price = _arg.price, currency = _arg.currency;
          return {
            'data[Exchange][item_type_id]': itemTypeId,
            'data[Exchange][number]': amount,
            'data[Exchange][price]': price,
            'data[Exchange][currency]': currency
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'tradeCenter.createStockLot': {
        required: ['corporationId', 'amount', 'price', 'currency'],
        cache: false,
        invalidate: ['tradeCenter.availableStock', 'tradeCenter.lotsOffer', 'tradeCenter.userLots', 'inventory', 'user.info'],
        url: '/stock_exchanges/add.json',
        method: 'POST',
        data: function(_arg) {
          var amount, corporationId, currency, price;
          corporationId = _arg.corporationId, amount = _arg.amount, price = _arg.price, currency = _arg.currency;
          return {
            'data[StockExchange][corporation_id]': corporationId,
            'data[StockExchange][number]': amount,
            'data[StockExchange][price]': price,
            'data[StockExchange][currency]': currency
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'tradeCenter.createLotCompany': {
        required: ['itemTypeId', 'amount', 'price', 'currency'],
        cache: false,
        invalidate: ['tradeCenter.companyItemsToSell', 'business.storage', 'business.companyInfo'],
        url: '/exchanges/add_company_exchange.json',
        method: 'POST',
        data: function(_arg) {
          var amount, companyId, currency, itemTypeId, price;
          companyId = _arg.companyId, itemTypeId = _arg.itemTypeId, amount = _arg.amount, price = _arg.price, currency = _arg.currency;
          return {
            'data[Exchange][company_id]': companyId,
            'data[Exchange][item_type_id]': itemTypeId,
            'data[Exchange][number]': amount,
            'data[Exchange][price]': price,
            'data[Exchange][currency]': currency
          };
        }
      },
      'tradeCenter.createLotCorporation': {
        required: ['itemTypeId', 'amount', 'price', 'currency'],
        cache: false,
        invalidate: ['tradeCenter.corporationItemsToSell', 'business.corporationStorage'],
        url: '/exchanges/add_corporation_exchange.json',
        method: 'POST',
        data: function(_arg) {
          var amount, corporationId, currency, itemTypeId, price;
          corporationId = _arg.corporationId, itemTypeId = _arg.itemTypeId, amount = _arg.amount, price = _arg.price, currency = _arg.currency;
          return {
            'data[Exchange][corporation_id]': corporationId,
            'data[Exchange][item_type_id]': itemTypeId,
            'data[Exchange][number]': amount,
            'data[Exchange][price]': price,
            'data[Exchange][currency]': currency
          };
        }
      },
      'tradeCenter.createCurrencyLot': {
        required: ['amount', 'price', 'type'],
        cache: false,
        invalidate: ['tradeCenter.availableCurrency', 'tradeCenter.lotsList', 'tradeCenter.lotsOffer', 'tradeCenter.userLots', 'inventory', 'user.info'],
        url: '/currency/add_exchange.json',
        method: 'POST',
        data: function(_arg) {
          var amount, price, type;
          amount = _arg.amount, price = _arg.price, type = _arg.type;
          return {
            'data[CurrencyExchange][number]': amount,
            'data[CurrencyExchange][price]': price,
            'data[CurrencyExchange][type]': type
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'tradeCenter.buyCurrencyLot': {
        required: ['exchangeId', 'number'],
        cache: false,
        invalidate: ['tradeCenter.currencyVdLots', 'tradeCenter.currencyVgLots', 'tradeCenter.currencyLotsList', 'user.info'],
        url: function() {
          return '/currency/buy.json';
        },
        method: 'POST',
        data: function(_arg) {
          var corporationId, exchangeId, number;
          exchangeId = _arg.exchangeId, number = _arg.number, corporationId = _arg.corporationId;
          return {
            'data[CurrencyExchange][id]': exchangeId,
            'data[CurrencyExchange][number]': number
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'tradeCenter.buyLot': {
        required: ['exchangeId', 'number', 'corporationId'],
        cache: false,
        invalidate: ['tradeCenter.lotsOffer', 'tradeCenter.lotsList', 'user.info', 'inventory', 'inventory.furniture', 'business.corporationStorage'],
        url: function(_arg) {
          var corporationId;
          corporationId = _arg.corporationId;
          if ((corporationId != null) && corporationId !== 0) {
            return '/exchanges/corporation_buy.json';
          } else {
            return '/exchanges/user_buy.json';
          }
        },
        method: 'POST',
        data: function(_arg) {
          var corporationId, exchangeId, number;
          exchangeId = _arg.exchangeId, number = _arg.number, corporationId = _arg.corporationId;
          return {
            'data[Exchange][id]': exchangeId,
            'data[Exchange][number]': number,
            'data[Corporation][id]': corporationId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'tradeCenter.editLot': {
        required: ['exchangeId', 'price', 'currency'],
        cache: false,
        invalidate: ['tradeCenter.lotsOffer', 'tradeCenter.lotsList', 'tradeCenter.userLots'],
        url: '/exchanges/edit_user_exchange.json',
        method: 'POST',
        data: function(_arg) {
          var currency, exchangeId, price;
          exchangeId = _arg.exchangeId, price = _arg.price, currency = _arg.currency;
          return {
            'data[Exchange][id]': exchangeId,
            'data[Exchange][price]': price,
            'data[Exchange][currency]': currency
          };
        }
      },
      'tradeCenter.editCurrencyLot': {
        required: ['exchangeId', 'price'],
        cache: false,
        invalidate: ['tradeCenter.lotsOffer', 'tradeCenter.lotsList', 'tradeCenter.userLots'],
        url: '/currency/edit_exchange.json',
        method: 'POST',
        data: function(_arg) {
          var exchangeId, price;
          exchangeId = _arg.exchangeId, price = _arg.price;
          return {
            'data[CurrencyExchange][id]': exchangeId,
            'data[CurrencyExchange][price]': price
          };
        }
      },
      'tradeCenter.editStockLot': {
        required: ['exchangeId', 'price', 'currency'],
        cache: false,
        invalidate: ['tradeCenter.lotsOffer', 'tradeCenter.lotsList', 'tradeCenter.userLots'],
        url: '/stock_exchanges/edit.json',
        method: 'POST',
        data: function(_arg) {
          var currency, exchangeId, price;
          exchangeId = _arg.exchangeId, price = _arg.price, currency = _arg.currency;
          return {
            'data[StockExchange][id]': exchangeId,
            'data[StockExchange][price]': price,
            'data[StockExchange][currency]': currency
          };
        }
      },
      'tradeCenter.buySharesLot': {
        required: ['exchangeId', 'number'],
        cache: false,
        invalidate: ['tradeCenter.lotsOfferShares', 'tradeCenter.stocksByCorporation', 'user.info.short'],
        url: '/stock_exchanges/buy.json',
        method: 'POST',
        data: function(_arg) {
          var exchangeId, number;
          exchangeId = _arg.exchangeId, number = _arg.number;
          return {
            'data[StockExchange][id]': exchangeId,
            'data[StockExchange][number]': number
          };
        }
      },
      'tradeCenter.buyLotCompany': {
        required: ['exchangeId', 'number', 'companyId'],
        cache: false,
        invalidate: ['tradeCenter.lotsOfferCompany', 'tradeCenter.lotsListCompany', 'business.storage', 'business.companyInfo'],
        url: function(_arg) {
          var companyId, exchangeId;
          companyId = _arg.companyId, exchangeId = _arg.exchangeId;
          return "/exchanges/company_buy/" + companyId + "/" + exchangeId + ".json";
        },
        method: 'POST',
        data: function(_arg) {
          var number;
          number = _arg.number;
          return {
            'data[Exchange][number]': number
          };
        }
      },

      /*
      				Work
       */
      'work.current': {
        cache: false,
        url: '/users/user_work.json'
      },
      'work.current.resign': {
        required: ['workerId'],
        cache: false,
        invalidate: ['work.current', 'work.vacancies', 'work.vacancies.forProfession', 'user.info.profession'],
        method: 'POST',
        url: '/company_workers/resign_from_work.json',
        data: function(_arg) {
          var workerId;
          workerId = _arg.workerId;
          return {
            'data[CompanyWorker][worker_id]': workerId
          };
        }
      },
      'work.vacancies': {
        url: '/vacancies/index.json',
        cacheValidityInMs: 10 * 1000
      },
      'work.vacancies.forProfession': {
        url: '/vacancies/index.json',
        required: ['professionId'],
        cache: false,
        method: 'POST',
        googleAnalyticsIgnore: true,
        data: function(_arg) {
          var professionId;
          professionId = _arg.professionId;
          return {
            'data[CompanyVacancy][profession_type_id]': professionId
          };
        }
      },
      'work.vacancies.accept': {
        required: ['vacancyId'],
        invalidate: ['work.current', 'user.info.profession', 'work.vacancies.forProfession'],
        cache: false,
        url: function() {
          return "/vacancies/work_vacancy.json";
        },
        method: 'POST',
        data: function(_arg) {
          var vacancyId;
          vacancyId = _arg.vacancyId;
          return {
            'data[CompanyVacancy][id]': vacancyId
          };
        }
      },
      'work.licenses': {
        cacheValidityInMs: 30 * 1000,
        url: '/libraries/licenses.json'
      },
      'work.licenses.info': {
        cache: false,
        url: '/libraries/licences_info.json'
      },
      'work.licenses.updateSettings': {
        required: ['licenseId', 'currency', 'price'],
        invalidate: ['work.licenses', 'work.licenses.info'],
        method: 'POST',
        cache: false,
        url: '/sport_activities/update_program.json',
        data: function(_arg) {
          var currency, licenseId, price;
          licenseId = _arg.licenseId, currency = _arg.currency, price = _arg.price;
          return {
            'data[CoachProgram][licence_id]': licenseId,
            'data[CoachProgram][price]': price,
            'data[CoachProgram][currency]': currency
          };
        }
      },
      'work.licenses.buyDoctorLicense': {
        required: ['licenseId'],
        cache: false,
        invalidate: ['work.licenses', 'work.licenses.info'],
        url: function() {
          return "/libraries/buy_medical_license.json";
        },
        method: 'POST',
        data: function(_arg) {
          var licenseId;
          licenseId = _arg.licenseId;
          return {
            'data[DoctorLicenseType][id]': licenseId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'work.licenses.buyTrainerLicense': {
        required: ['licenseId'],
        cache: false,
        invalidate: ['work.licenses', 'work.licenses.info'],
        url: function() {
          return "/libraries/buy_license.json";
        },
        method: 'POST',
        data: function(_arg) {
          var licenseId;
          licenseId = _arg.licenseId;
          return {
            'data[GrantType][id]': licenseId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'work.doctorLicense.start': {
        cache: false,
        invalidate: ['work.licenses.info'],
        method: 'POST',
        url: '/hospitals/start_license.json'
      },
      'work.doctorLicense.stop': {
        cache: false,
        invalidate: ['work.licenses.info'],
        method: 'POST',
        url: '/hospitals/stop_license.json'
      },
      'work.doctorLicense.renew': {
        cache: false,
        invalidate: ['work.licenses.info'],
        method: 'POST',
        url: '/hospitals/renew.json'
      },
      'work.trainerLicense.start': {
        required: ['licenseId'],
        invalidate: ['work.licenses.info'],
        method: 'POST',
        cache: false,
        url: '/sport_activities/update_program.json',
        data: function(_arg) {
          var licenseId;
          licenseId = _arg.licenseId;
          return {
            'data[CoachProgram][licence_id]': licenseId,
            'data[CoachProgram][active]': true
          };
        }
      },
      'work.trainerLicense.stop': {
        required: ['licenseId'],
        invalidate: ['work.licenses.info'],
        method: 'POST',
        cache: false,
        url: '/sport_activities/update_program.json',
        data: function(_arg) {
          var licenseId;
          licenseId = _arg.licenseId;
          return {
            'data[CoachProgram][licence_id]': licenseId,
            'data[CoachProgram][active]': false
          };
        }
      },
      'work.trainerLicense.renew': {
        cache: false,
        invalidate: ['work.licenses.info'],
        method: 'POST',
        url: '/sport_activities/renew.json'
      },
      'work.work': {
        required: ['energy', 'companyId'],
        cache: false,
        invalidate: ['work.current', 'user.info.profession'],
        method: 'POST',
        url: '/users/begin_work.json',
        data: function(_arg) {
          var companyId, energy;
          energy = _arg.energy, companyId = _arg.companyId;
          return {
            'data[User][energy]': energy,
            'data[Company][id]': companyId
          };
        },
        after: function(options) {
          app.menu.view.reload();
          app.shortInfo.changeEnergy(-options.energy);
          return app.shortInfo.view.reload();
        }
      },
      'work.beginWork': {
        required: ['energy', 'companyId'],
        invalidate: ['business.companyInfo', 'user.info', 'user.info.short'],
        cache: false,
        method: 'POST',
        url: '/users/begin_work_master.json',
        data: function(_arg) {
          var companyId, energy;
          energy = _arg.energy, companyId = _arg.companyId;
          return {
            'data[User][energy]': energy,
            'data[Company][id]': companyId
          };
        },
        after: function(options) {
          app.menu.view.reload();
          app.shortInfo.changeEnergy(-options.energy);
          return app.shortInfo.view.reload();
        }
      },

      /*
      				Bussines
       */
      'business': {
        cacheValidityInMs: 30 * 1000,
        url: '/companies/user_companies_list.json'
      },
      'business.companyList': {
        cache: false,
        url: '/companies/user_companies_list.json'
      },
      'business.corporationList': {
        cache: false,
        url: '/corporations/corporation_list.json'
      },
      'business.companyInfo': {
        required: ['companyId'],
        cacheValidityInMs: 30 * 1000,
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/companies/info/" + companyId + ".json";
        }
      },
      'business.сompanyWorkersInfo': {
        cache: false,
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/company_workers/workers_info/" + companyId + ".json";
        }
      },
      'business.сompanyWorkersList': {
        cache: false,
        required: ['companyId'],
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/company_workers/list_workers/" + companyId + ".json";
        }
      },
      'business.companyForeignWorkers': {
        cache: false,
        required: ['companyId'],
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/company_foreign_workers/available/" + companyId + ".json";
        }
      },
      'business.hireForeignWorkers': {
        cache: false,
        invalidate: ['business.сompanyWorkersInfo', 'business.сompanyWorkersList', 'business'],
        required: ['companyId', 'workerId', 'quantity'],
        method: 'POST',
        url: function(_arg) {
          var companyId, quantity, workerId;
          companyId = _arg.companyId, workerId = _arg.workerId, quantity = _arg.quantity;
          return "/company_foreign_workers/add/" + companyId + "/" + workerId + "/" + quantity + ".json";
        }
      },
      'business.saveVacancy': {
        cache: false,
        invalidate: ['business.companyInfo', 'business.сompanyWorkersInfo'],
        required: ['companyId', 'salary', 'level', 'is_hiring'],
        method: 'POST',
        data: function(_arg) {
          var companyId, is_hiring, level, salary;
          companyId = _arg.companyId, salary = _arg.salary, level = _arg.level, is_hiring = _arg.is_hiring;
          return {
            'data[CompanyVacancy][company_id]': companyId,
            'data[CompanyVacancy][salary]': salary,
            'data[CompanyVacancy][level]': level,
            'data[CompanyVacancy][is_hiring]': is_hiring
          };
        },
        url: "/vacancies/save_vacancy.json"
      },
      'business.addFunds': {
        cache: false,
        invalidate: ['business.companyInfo'],
        required: ['companyId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, companyId;
          companyId = _arg.companyId, amount = _arg.amount;
          return {
            'data[Company][id]': companyId,
            'data[Company][amount_add]': amount
          };
        },
        url: "/companies/add_funds.json",
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'business.company.transfer': {
        cache: false,
        invalidate: ['business.corporationInfo', 'business.companyList'],
        required: ['corporationId', 'companyId'],
        method: 'POST',
        data: function(_arg) {
          var companyId, corporationId;
          corporationId = _arg.corporationId, companyId = _arg.companyId;
          return {
            'data[Corporation][id]': corporationId,
            'data[Company][id]': companyId
          };
        },
        url: "/companies/transfer.json"
      },
      'business.corporative_company.addFunds': {
        cache: false,
        invalidate: ['business.companyInfo'],
        required: ['companyId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, companyId;
          companyId = _arg.companyId, amount = _arg.amount;
          return {
            'data[Company][id]': companyId,
            'data[Company][amount_add]': amount
          };
        },
        url: "/corporation_companies/add_funds.json",
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'business.proposeDividents': {
        cache: false,
        invalidate: ['business.corporationInfo', 'business.corporationVotes'],
        required: ['amount', 'currency', 'corporationId'],
        method: 'POST',
        data: function(_arg) {
          var amount, corporationId, currency;
          amount = _arg.amount, currency = _arg.currency, corporationId = _arg.corporationId;
          return {
            'data[Corporation][dividend_per_share]': amount,
            'data[Corporation][currency]': currency,
            'data[Corporation][id]': corporationId
          };
        },
        url: "/corporations/propose_dividends.json"
      },
      'business.proposeEmmision': {
        cache: false,
        invalidate: ['business.corporationInfo', 'business.corporationVotes'],
        required: ['corporationId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, corporationId;
          corporationId = _arg.corporationId, amount = _arg.amount;
          return {
            'data[Corporation][id]': corporationId,
            'data[Corporation][emission]': amount
          };
        },
        url: "/corporations/propose_emission.json"
      },
      'business.proposeCorpRename': {
        cache: false,
        invalidate: ['business.corporationInfo', 'business.corporationVotes', 'business.corporationList'],
        required: ['corporationId', 'name_ru', 'name_en'],
        method: 'POST',
        data: function(_arg) {
          var corporationId, name_en, name_ru;
          corporationId = _arg.corporationId, name_ru = _arg.name_ru, name_en = _arg.name_en;
          return {
            'data[Corporation][id]': corporationId,
            'data[Corporation][new_name_ru]': name_ru,
            'data[Corporation][new_name_en]': name_en
          };
        },
        url: "/corporations/rename_corporation.json"
      },
      'business.proposeChangeManagerUp': {
        cache: false,
        invalidate: ['business.corporationInfo', 'business.corporationVotes'],
        required: ['corporationId', 'userId'],
        method: 'POST',
        data: function(_arg) {
          var corporationId, userId;
          corporationId = _arg.corporationId, userId = _arg.userId;
          return {
            'data[Corporation][id]': corporationId,
            'data[Corporation][stockholder]': userId
          };
        },
        url: "/corporations/change_manager_up.json"
      },
      'business.proposeChangeManagerDown': {
        cache: false,
        invalidate: ['business.corporationInfo', 'business.corporationVotes'],
        required: ['corporationId', 'userId'],
        method: 'POST',
        data: function(_arg) {
          var corporationId, userId;
          corporationId = _arg.corporationId, userId = _arg.userId;
          return {
            'data[Corporation][id]': corporationId,
            'data[Corporation][manager]': userId
          };
        },
        url: "/corporations/change_manager_down.json"
      },
      'business.proposeCorpCompanyClose': {
        cache: false,
        invalidate: ['business.corporationInfo', 'business.corporationVotes', 'business.corporationList'],
        required: ['corporationId', 'companyId'],
        method: 'POST',
        url: function(_arg) {
          var companyId, corporationId;
          corporationId = _arg.corporationId, companyId = _arg.companyId;
          return "/corporation_companies/close/" + corporationId + "/" + companyId + ".json";
        }
      },
      'business.proposeVotePositive': {
        cache: false,
        invalidate: ['business.corporationInfo', 'business.corporationVotes', 'business.corporationList'],
        required: ['solutionId', 'corporationId'],
        method: 'POST',
        url: function(_arg) {
          var corporationId, solutionId;
          solutionId = _arg.solutionId, corporationId = _arg.corporationId;
          return "/corporations/vote_positive/" + solutionId + "/" + corporationId + ".json";
        }
      },
      'business.proposeVoteNegative': {
        cache: false,
        invalidate: ['business.corporationInfo', 'business.corporationVotes', 'business.corporationList'],
        required: ['solutionId', 'corporationId'],
        method: 'POST',
        url: function(_arg) {
          var corporationId, solutionId;
          solutionId = _arg.solutionId, corporationId = _arg.corporationId;
          return "/corporations/vote_negative/" + solutionId + "/" + corporationId + ".json";
        }
      },
      'business.getCorpRenamePrice': {
        cacheValidityInMs: 3000 * 1000,
        url: "/corporations/get_rename_price.json"
      },
      'business.getEmissionPrice': {
        cacheValidityInMs: 3000 * 1000,
        url: "/corporations/get_emission_price.json"
      },
      'business.editCompanyName': {
        cache: false,
        invalidate: ['business.companyInfo'],
        required: ['companyId', 'name'],
        method: 'POST',
        data: function(_arg) {
          var companyId, name;
          companyId = _arg.companyId, name = _arg.name;
          return {
            'data[Company][id]': companyId,
            'data[Company][name]': name
          };
        },
        url: "/companies/edit_company_name.json"
      },
      'business.takeFunds': {
        cache: false,
        invalidate: ['business.companyInfo'],
        required: ['companyId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, companyId;
          companyId = _arg.companyId, amount = _arg.amount;
          return {
            'data[Company][id]': companyId,
            'data[Company][amount_take]': amount
          };
        },
        url: "/companies/take_funds.json"
      },
      'business.corporative_company.takeFunds': {
        cache: false,
        invalidate: ['business.companyInfo'],
        required: ['companyId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, companyId;
          companyId = _arg.companyId, amount = _arg.amount;
          return {
            'data[Company][id]': companyId,
            'data[Company][amount_take]': amount
          };
        },
        url: "/corporation_companies/take_funds.json"
      },
      'business.upLevel': {
        cache: false,
        invalidate: ['business', 'business.companyInfo', 'business.сompanyWorkersInfo'],
        required: ['companyId'],
        method: 'POST',
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/companies/up_level/" + companyId + ".json";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'business.corporative_company.upLevel': {
        cache: false,
        invalidate: ['business', 'business.companyInfo', 'business.сompanyWorkersInfo', 'business.corporationInfo'],
        required: ['companyId'],
        method: 'POST',
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/corporation_companies/up_level/" + companyId + ".json";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'business.upStorageLevel': {
        cache: false,
        invalidate: ['business.companyInfo', 'business.storage', 'user.info.short'],
        required: ['companyId'],
        method: 'POST',
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/companies/up_storage_level/" + companyId + ".json";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'business.corporative_company.upStorageLevel': {
        cache: false,
        invalidate: ['business.companyInfo', 'business.storage', 'user.info.short'],
        required: ['companyId'],
        method: 'POST',
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/corporation_companies/up_storage_level/" + companyId + ".json";
        }
      },
      'business.deleteWorker': {
        cache: false,
        invalidate: ['business.сompanyWorkersInfo', 'business.сompanyWorkersList', 'business.companyInfo', 'business'],
        required: ['workerId'],
        method: 'POST',
        url: function(_arg) {
          var workerId;
          workerId = _arg.workerId;
          return "/company_workers/delete_worker/" + workerId + ".json";
        }
      },
      'business.deleteForeignWorker': {
        cache: false,
        invalidate: ['business.сompanyWorkersInfo', 'business.сompanyWorkersList'],
        required: ['companyId', 'workerId', 'quantity'],
        method: 'POST',
        url: function(_arg) {
          var companyId, quantity, workerId;
          companyId = _arg.companyId, workerId = _arg.workerId, quantity = _arg.quantity;
          return "/company_foreign_workers/delete/" + companyId + "/" + workerId + "/" + quantity + ".json";
        }
      },
      'business.storage': {
        cache: false,
        required: ['companyId'],
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/company_items/storage/" + companyId + ".json";
        }
      },
      'business.moveItemsToCompany': {
        cache: false,
        invalidate: ['business.companyInfo', 'business.storage'],
        required: ['companyId', 'itemTypeId', 'quantity'],
        method: 'POST',
        url: function(_arg) {
          var companyId, itemTypeId, quantity;
          companyId = _arg.companyId, itemTypeId = _arg.itemTypeId, quantity = _arg.quantity;
          return "/user_items/move_items_to_company/" + companyId + "/" + itemTypeId + "/" + quantity + ".json";
        }
      },
      'business.moveItemsFromCorporation': {
        cache: false,
        invalidate: ['business.companyInfo', 'business.storage', 'business.corporationStorage.byCompany'],
        required: ['companyId', 'itemTypeId', 'quantity'],
        method: 'POST',
        url: function(_arg) {
          var companyId, itemTypeId, quantity;
          companyId = _arg.companyId, itemTypeId = _arg.itemTypeId, quantity = _arg.quantity;
          return "/corporation_items/move_items_to_company/" + companyId + "/" + itemTypeId + "/" + quantity + ".json";
        }
      },
      'business.moveItemsToUser': {
        cache: false,
        invalidate: ['business.companyInfo', 'business.storage', 'inventory', 'inventory.furniture'],
        required: ['companyId', 'itemTypeId', 'quantity'],
        method: 'POST',
        url: function(_arg) {
          var companyId, itemTypeId, quantity;
          companyId = _arg.companyId, itemTypeId = _arg.itemTypeId, quantity = _arg.quantity;
          return "/company_items/move_items_to_user/" + companyId + "/" + itemTypeId + "/" + quantity + ".json";
        }
      },
      'business.moveItemsToCorporation': {
        cache: false,
        invalidate: ['business.companyInfo', 'business.storage', 'business.corporationStorage.byCompany'],
        required: ['companyId', 'itemTypeId', 'quantity'],
        method: 'POST',
        url: function(_arg) {
          var companyId, itemTypeId, quantity;
          companyId = _arg.companyId, itemTypeId = _arg.itemTypeId, quantity = _arg.quantity;
          return "/company_items/move_items_to_corporation/" + companyId + "/" + itemTypeId + "/" + quantity + ".json";
        }
      },
      'business.moveItemsFromCityToCompany': {
        cache: false,
        invalidate: ['business.companyInfo', 'business.storage', 'cityHall.storage'],
        required: ['companyId', 'itemTypeId', 'quantity'],
        method: 'POST',
        url: function(_arg) {
          var companyId, itemTypeId, quantity;
          companyId = _arg.companyId, itemTypeId = _arg.itemTypeId, quantity = _arg.quantity;
          return "/city_items/move_items_to_company/" + companyId + "/" + itemTypeId + "/" + quantity + ".json";
        }
      },
      'business.moveItemsToCity': {
        cache: false,
        invalidate: ['business.companyInfo', 'business.storage', 'cityHall.storage'],
        required: ['companyId', 'itemTypeId', 'quantity'],
        method: 'POST',
        url: function(_arg) {
          var companyId, itemTypeId, quantity;
          companyId = _arg.companyId, itemTypeId = _arg.itemTypeId, quantity = _arg.quantity;
          return "/company_items/move_items_to_city/" + companyId + "/" + itemTypeId + "/" + quantity + ".json";
        }
      },
      'business.corporationInfo': {
        cacheValidityInMs: 300 * 1000,
        required: ['corporationId'],
        url: function(_arg) {
          var corporationId;
          corporationId = _arg.corporationId;
          return "/corporations/corporation_office/" + corporationId + ".json";
        }
      },
      'business.corporationVotes': {
        cache: false,
        required: ['corporationId'],
        url: function(_arg) {
          var corporationId;
          corporationId = _arg.corporationId;
          return "/corporations/corporation_votes/" + corporationId + ".json";
        }
      },
      'business.corporationStorage': {
        cache: false,
        required: ['corporationId'],
        url: function(_arg) {
          var corporationId;
          corporationId = _arg.corporationId;
          return "/corporation_items/storage/" + corporationId + ".json";
        }
      },
      'business.corporationStorage.byCompany': {
        cache: false,
        required: ['companyId'],
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/corporation_items/storage_by_company/" + companyId + ".json";
        }
      },
      'business.shareHolders': {
        cacheValidityInMs: 300 * 1000,
        required: ['corporationId'],
        url: function(_arg) {
          var corporationId;
          corporationId = _arg.corporationId;
          return "/corporations/corporation_stockholders/" + corporationId + ".json";
        }
      },
      'business.searchManager': {
        cache: false,
        required: ['page'],
        url: function(_arg) {
          var name, page;
          page = _arg.page, name = _arg.name;
          return "/companies/search_manager.json?page=" + (page || 1) + "&name=" + (name || '-');
        }
      },
      'business.corporative_company.searchManager': {
        cache: false,
        required: ['companyId'],
        url: function(_arg) {
          var companyId, name, page;
          page = _arg.page, companyId = _arg.companyId, name = _arg.name;
          return "/corporation_companies/search_manager.json?company_id=" + companyId + "&page=" + (page || 1) + "&name=" + (name || '-');
        }
      },
      'business.setManager': {
        cache: false,
        invalidate: ['business.сompanyWorkersInfo'],
        required: ['managerId', 'companyId'],
        method: 'POST',
        data: function(_arg) {
          var companyId, managerId;
          managerId = _arg.managerId, companyId = _arg.companyId;
          return {
            'data[Company][manager_id]': managerId,
            'data[Company][id]': companyId
          };
        },
        url: "/companies/set_manager.json"
      },
      'business.corporative_company.setManager': {
        cache: false,
        invalidate: ['business.сompanyWorkersInfo'],
        required: ['managerId', 'companyId'],
        method: 'POST',
        data: function(_arg) {
          var companyId, managerId;
          managerId = _arg.managerId, companyId = _arg.companyId;
          return {
            'data[Company][manager_id]': managerId,
            'data[Company][id]': companyId
          };
        },
        url: "/corporation_companies/set_manager.json"
      },
      'business.setProduction': {
        cache: false,
        invalidate: ['business.companyInfo'],
        required: ['companyId', 'itemId'],
        method: 'POST',
        data: function(_arg) {
          var companyId, itemId;
          companyId = _arg.companyId, itemId = _arg.itemId;
          return {
            'data[Company][id]': companyId,
            'data[Company][current_production]': itemId
          };
        },
        url: "/companies/set_production.json"
      },
      'business.getProductionList': {
        cache: false,
        invalidate: ['business.companyInfo', 'business'],
        required: ['companyId'],
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/companies/production_list/" + companyId + ".json";
        }
      },
      'business.createCompany': {
        cache: false,
        invalidate: ['business.companyList'],
        required: ['type', 'currency', 'name'],
        method: 'POST',
        data: function(_arg) {
          var currency, name, type;
          type = _arg.type, currency = _arg.currency, name = _arg.name;
          return {
            'data[CompanyType][type]': type,
            'data[CompanyType][currency]': currency,
            'data[CompanyType][name]': name
          };
        },
        url: "/companies/create_new.json",
        after: function() {
          return app.shortInfo.view.reload();
        }
      },
      'business.createCorporationCompany': {
        cache: false,
        required: ['corporationId', 'type', 'currency', 'name'],
        invalidate: ['business.corporationInfo', 'business.corporationList'],
        method: 'POST',
        data: function(_arg) {
          var corporationId, currency, name, type;
          corporationId = _arg.corporationId, type = _arg.type, currency = _arg.currency, name = _arg.name;
          return {
            'data[CompanyType][corporation_master]': corporationId,
            'data[CompanyType][id]': type,
            'data[CompanyType][currency]': currency,
            'data[CompanyType][name]': name
          };
        },
        url: "/corporation_companies/create.json"
      },
      'business.createCorporation': {
        cache: false,
        invalidate: ['business.corporationList'],
        required: ['name_ru', 'name_en', 'logo'],
        method: 'POST',
        data: function(_arg) {
          var logo, name_en, name_ru;
          name_ru = _arg.name_ru, name_en = _arg.name_en, logo = _arg.logo;
          return {
            'data[Corporation][name_ru]': name_ru,
            'data[Corporation][name_en]': name_en,
            'data[Corporation][logo]': logo
          };
        },
        url: "/corporations/create.json"
      },
      'business.corporationInvestVd': {
        cache: false,
        invalidate: ['business.corporationInfo'],
        required: ['corporationId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, corporationId;
          corporationId = _arg.corporationId, amount = _arg.amount;
          return {
            'data[Corporation][id]': corporationId,
            'data[Corporation][vd_invest]': amount
          };
        },
        url: "/corporations/invest_vd.json",
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'business.corporationInvestVg': {
        cache: false,
        invalidate: ['business.corporationInfo'],
        required: ['corporationId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, corporationId;
          corporationId = _arg.corporationId, amount = _arg.amount;
          return {
            'data[Corporation][id]': corporationId,
            'data[Corporation][vg_invest]': amount
          };
        },
        url: "/corporations/invest_vg.json",
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'business.itemInfo': {
        cache: false,
        required: ['itemTypeId'],
        url: function(_arg) {
          var itemTypeId;
          itemTypeId = _arg.itemTypeId;
          return "/company_items/get_info/" + itemTypeId + ".json";
        }
      },
      'business.company.effects': {
        cache: false,
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          if (companyId != null) {
            return "/companies/effects/" + companyId + ".json";
          } else {
            return "/companies/effects.json";
          }
        }
      },
      'corporation.itemInfo': {
        cache: false,
        required: ['itemTypeId'],
        url: function(_arg) {
          var itemTypeId;
          itemTypeId = _arg.itemTypeId;
          return "/corporation_items/get_info/" + itemTypeId + ".json";
        }
      },

      /*
      				Quests
       */
      'quests': {
        cache: false,
        url: '/quests/quests/user_quests.json'
      },
      'quests.info': {
        cacheValidityInMs: 300 * 1000,
        required: ['questId'],
        url: function(_arg) {
          var questId;
          questId = _arg.questId;
          return "/quests/quests/info/" + questId + ".json";
        },
        gaPostfix: function() {
          return 'postfix';
        }
      },
      'quests.takeQuest': {
        cache: false,
        required: ['questId'],
        invalidate: ['quests', 'quests.info', 'inventory'],
        method: 'POST',
        url: function(_arg) {
          var questId;
          questId = _arg.questId;
          return "/quests/quests/take/" + questId + ".json";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'quests.completeQuest': {
        cache: false,
        required: ['questId'],
        invalidate: ['quests', 'quests.info', 'inventory'],
        method: 'POST',
        url: function(_arg) {
          var questId;
          questId = _arg.questId;
          return "/quests/quests/complete/" + questId + ".json";
        },
        vpageUrl: function(_arg) {
          var questId;
          questId = _arg.questId;
          return "/api/quests/quests/complete/" + questId;
        },
        after: function() {
          app.quests.clearCache();
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'quests.check_completed': {
        cache: false,
        required: ['cid'],
        url: function(_arg) {
          var cid;
          cid = _arg.cid;
          return "/quests/quests/check_completed.json?cid=" + cid;
        },
        vpageUrl: function(_arg) {
          var cid;
          cid = _arg.cid;
          return "/api/quests/quests/check_completed/" + cid;
        }
      },

      /*
      			events
       */
      'events.ot': {
        cache: false,
        url: "/prestige_wars/view.json"
      },
      'events.ot.silent': {
        cacheValidityInMs: 300 * 1000,
        url: "/prestige_wars/silent_view.json"
      },
      'events.ot.kick': {
        cache: false,
        required: ['teamId'],
        invalidate: ['events.ot', 'house.info'],
        url: function(_arg) {
          var teamId;
          teamId = _arg.teamId;
          return "/prestige_wars/kick.json";
        },
        method: 'POST',
        data: function(_arg) {
          var teamId;
          teamId = _arg.teamId;
          return {
            'data[PrestigeWarTeam][id]': teamId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'events.bb': {
        cache: false,
        url: '/big_fights/view.json'
      },
      'events.bb.silent': {
        cacheValidityInMs: 300 * 1000,
        url: '/big_fights/silent_view.json'
      },
      'events.bb.kick': {
        cache: false,
        required: ['bbId'],
        invalidate: ['events.bb', 'house.info'],
        url: function(_arg) {
          var bbId;
          bbId = _arg.bbId;
          return "/big_fights/kick.json";
        },
        method: 'POST',
        data: function(_arg) {
          var bbId;
          bbId = _arg.bbId;
          return {
            'data[BigFight][id]': bbId
          };
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'events.election.silent': {
        cacheValidityInMs: 120 * 1000,
        url: '/city_elections/silent_view.json'
      },

      /*
      				CityHall
       */
      'cityHall': {
        cacheValidityInMs: 30 * 1000,
        url: '/city_hall/info.json'
      },
      'cityHall.cups': {
        cacheValidityInMs: 60 * 1000,
        url: '/city_hall/cups.json'
      },
      'cityHall.titles': {
        cacheValidityInMs: 300 * 1000,
        url: '/city_hall/titles.json'
      },
      'cityHall.government': {
        cacheValidityInMs: 300 * 1000,
        url: '/city_hall/goverment.json'
      },
      'cityHall.bills': {
        cache: false,
        url: '/city_bills/all.json'
      },
      'cityHall.areasTakeover.bills': {
        cache: false,
        url: '/areas_takeover/bills/all.json'
      },
      'cityHall.voteForBill': {
        invalidate: ['cityHall.bills', 'cityHall'],
        required: ['billId'],
        method: 'POST',
        url: function(_arg) {
          var billId;
          billId = _arg.billId;
          return "/city_bills/vote_positive/" + billId + ".json";
        }
      },
      'cityHall.areasTakeover.vote': {
        invalidate: ['cityHall.areasTakeover.bills', 'cityHall'],
        cache: false,
        required: ['billId', 'vote'],
        method: 'POST',
        data: function(_arg) {
          var billId, vote;
          billId = _arg.billId, vote = _arg.vote;
          return {
            'data[AreasTakeoverBill][id]': billId,
            'data[AreasTakeoverBill][vote]': vote
          };
        },
        url: "/areas_takeover/bills/vote.json"
      },
      'cityHall.voteAgainstBill': {
        invalidate: ['cityHall.bills', 'cityHall'],
        cache: false,
        required: ['billId'],
        method: 'POST',
        url: function(_arg) {
          var billId;
          billId = _arg.billId;
          return "/city_bills/vote_negative/" + billId + ".json";
        }
      },
      'cityHall.itemsBills': {
        url: '/city_hall/city_items_consideration.json'
      },
      'cityHall.voteForItemBill': {
        invalidate: ['cityHall.itemsBills', 'cityHall'],
        required: ['billId'],
        method: 'POST',
        url: function(_arg) {
          var billId;
          billId = _arg.billId;
          return "/city_item_proposal_votes/vote_positive/" + billId + ".json";
        }
      },
      'cityHall.voteAgainstItemBill': {
        invalidate: ['cityHall.itemsBills', 'cityHall'],
        cache: false,
        required: ['billId'],
        method: 'POST',
        url: function(_arg) {
          var billId;
          billId = _arg.billId;
          return "/city_item_proposal_votes/vote_negative/" + billId + ".json";
        }
      },
      'cityHall.companies': {
        cacheValidityInMs: 300 * 1000,
        url: '/state_companies/all.json'
      },
      'cityHall.createCompany': {
        cache: false,
        invalidate: ['cityHall.companies'],
        required: ['type', 'currency', 'name'],
        method: 'POST',
        data: function(_arg) {
          var currency, name, type;
          type = _arg.type, currency = _arg.currency, name = _arg.name;
          return {
            'data[CompanyType][type]': type,
            'data[CompanyType][currency]': currency,
            'data[CompanyType][name]': name
          };
        },
        url: "/state_companies/create_new.json"
      },
      'cityHall.company.upStorageLevel': {
        cache: false,
        required: ['companyId'],
        method: 'POST',
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/state_companies/up_storage_level/" + companyId + ".json";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'cityHall.storage.itemInfo': {
        cache: false,
        required: ['itemTypeId'],
        url: function(_arg) {
          var itemTypeId;
          itemTypeId = _arg.itemTypeId;
          return "/city_items/get_item_info/" + itemTypeId + ".json";
        }
      },
      'cityHall.billList': {
        cache: false,
        url: '/city_bills/bill_list.json'
      },
      'cityHall.newBill': {
        invalidate: ['cityHall', 'cityHall.bills'],
        required: ['billId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, billId;
          billId = _arg.billId, amount = _arg.amount;
          return {
            'data[CityValue][id]': billId,
            'data[CityValue][value]': amount
          };
        },
        url: "/city_bills/add.json"
      },
      'cityHall.companyInfo': {
        required: ['companyId'],
        url: function(_arg) {
          var companyId;
          companyId = _arg.companyId;
          return "/companies/info/" + companyId + ".json";
        }
      },
      'cityHall.donate': {
        cache: false,
        invalidate: ['cityHall'],
        required: ['cityId', 'amount', 'currency'],
        method: 'POST',
        data: function(_arg) {
          var amount, cityId, currency;
          cityId = _arg.cityId, amount = _arg.amount, currency = _arg.currency;
          return {
            'data[CityHall][id]': cityId,
            'data[CityHall][amount]': amount,
            'data[CityHall][currency]': currency
          };
        },
        url: "/city_hall/donate_money.json",
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'cityHall.addFunds': {
        invalidate: ['business.companyInfo', 'cityHall'],
        required: ['companyId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, companyId;
          companyId = _arg.companyId, amount = _arg.amount;
          return {
            'data[Company][id]': companyId,
            'data[StateCompany][amount_add]': amount
          };
        },
        url: "/state_companies/add_funds.json"
      },
      'cityHall.takeFunds': {
        invalidate: ['business.companyInfo', 'cityHall'],
        required: ['companyId', 'amount'],
        method: 'POST',
        data: function(_arg) {
          var amount, companyId;
          companyId = _arg.companyId, amount = _arg.amount;
          return {
            'data[Company][id]': companyId,
            'data[StateCompany][amount_take]': amount
          };
        },
        url: "/state_companies/take_funds.json"
      },
      'cityHall.evolutionActive': {
        cacheValidityInMs: 30 * 1000,
        url: '/city_evolutions/active.json'
      },
      'cityHall.evolutionTree': {
        cacheValidityInMs: 300 * 1000,
        url: '/city_evolutions/tree.json'
      },
      'cityHall.evolutionInfo': {
        required: ['evolutionId'],
        method: 'GET',
        url: function(_arg) {
          var evolutionId;
          evolutionId = _arg.evolutionId;
          return "/city_evolutions/info/" + evolutionId + ".json";
        }
      },
      'cityHall.evolutionVotes': {
        cache: false,
        url: '/city_evolution_votes/show.json'
      },
      'cityHall.evolutionStartVoting': {
        cache: false,
        invalidate: ['cityHall.evolutionActive', 'cityHall.evolutionTree', 'cityHall.evolutionVotes'],
        required: ['evolutionId'],
        method: 'POST',
        data: function(_arg) {
          var evolutionId;
          evolutionId = _arg.evolutionId;
          return {
            'data[Evolution][id]': evolutionId
          };
        },
        url: '/city_evolution_votes/start_voting.json'
      },
      'cityHall.evolutionVote': {
        cache: false,
        invalidate: ['cityHall.evolutionActive', 'cityHall.evolutionTree', 'cityHall.evolutionVotes'],
        required: ['cityEvolutionId', 'vote'],
        method: 'POST',
        data: function(_arg) {
          var cityEvolutionId, vote;
          cityEvolutionId = _arg.cityEvolutionId, vote = _arg.vote;
          return {
            'data[CityEvolutionVote][city_evolution_id]': cityEvolutionId,
            'data[CityEvolutionVote][vote]': vote
          };
        },
        url: '/city_evolution_votes/add.json'
      },
      'cityHall.buyout': {
        required: ['itemTypeId', 'amount', 'price', 'currency'],
        cache: false,
        invalidate: [],
        url: '/city_item_proposals/add.json',
        method: 'POST',
        data: function(_arg) {
          var amount, currency, itemTypeId, price;
          itemTypeId = _arg.itemTypeId, amount = _arg.amount, price = _arg.price, currency = _arg.currency;
          return {
            'data[CityItemProposal][item_type_id]': itemTypeId,
            'data[CityItemProposal][need]': amount,
            'data[CityItemProposal][price]': price,
            'data[CityItemProposal][currency]': currency
          };
        }
      },
      'cityHall.mayorElection.info': {
        cacheValidityInMs: 30 * 1000,
        invalidate: [],
        url: '/city_mayor_elections/info.json'
      },
      'cityHall.mayorElection.candidates': {
        cacheValidityInMs: 30 * 1000,
        invalidate: [],
        url: '/city_mayor_elections/candidate_list.json'
      },
      'cityHall.snapElection.vote': {
        cache: false,
        invalidate: ['cityHall.government'],
        required: ['type'],
        method: 'POST',
        data: function(_arg) {
          var type;
          type = _arg.type;
          return {
            'data[Election][type]': type
          };
        },
        url: '/city_elections/snap_election.json'
      },
      'cityHall.mayorElectionAddCandidate': {
        cache: false,
        invalidate: ['cityHall.mayorElection.candidates'],
        method: 'POST',
        url: '/city_mayor_elections/add.json'
      },
      'cityHall.mayorElection.vote': {
        cache: false,
        invalidate: ['cityHall.mayorElection.candidates'],
        required: ['candidateId'],
        method: 'POST',
        data: function(_arg) {
          var candidateId;
          candidateId = _arg.candidateId;
          return {
            'data[CityMayorElection][candidate_id]': candidateId
          };
        },
        url: '/city_mayor_elections/vote.json'
      },
      'cityHall.cityItemProposals': {
        cache: false,
        method: 'GET',
        url: '/city_item_proposals/show.json'
      },
      'cityHall.deleteCityItemProposal': {
        cache: false,
        required: ['cityItemProposalId'],
        invalidate: ['cityHall.cityItemProposals'],
        method: 'POST',
        url: function(_arg) {
          var cityItemProposalId;
          cityItemProposalId = _arg.cityItemProposalId;
          return "/city_item_proposals/delete_proposal/" + cityItemProposalId + ".json";
        }
      },
      'cityHall.pauseCityItemProposal': {
        cache: false,
        required: ['cityItemProposalId'],
        invalidate: ['cityHall.cityItemProposals'],
        method: 'POST',
        url: function(_arg) {
          var cityItemProposalId;
          cityItemProposalId = _arg.cityItemProposalId;
          return "/city_item_proposals/pause/" + cityItemProposalId + ".json";
        }
      },
      'cityHall.storage': {
        cache: false,
        url: "/city_items/storage.json"
      },
      'cityHall.effects': {
        cacheValidityInMs: 30 * 1000,
        url: "/city_hall/effects.json"
      },

      /*
      				News
       */
      'news.userSubscriptions': {
        cache: false,
        url: '/newspapers/read_subscriptions.json'
      },
      'news.latest': {
        cacheValidityInMs: 30 * 1000,
        url: '/newspaper_posts/latest.json'
      },
      'news.allNews': {
        cacheValidityInMs: 30 * 1000,
        url: '/newspaper_posts/all.json'
      },
      'news.recommendations': {
        cacheValidityInMs: 30 * 1000,
        url: '/newspaper_posts/all_recommendations.json'
      },
      'news.all_in_one_request': {
        cacheValidityInMs: 30 * 1000,
        url: '/newspaper_posts/all_in_one_request.json'
      },
      'news.newspaper': {
        cacheValidityInMs: 30 * 1000,
        url: function(_arg) {
          var newspaperSlug;
          newspaperSlug = _arg.newspaperSlug;
          return "/newspaper_posts/index/" + newspaperSlug + ".json";
        }
      },
      'news.post': {
        cache: false,
        invalidate: ['news.unreadPosts', 'news.unreadFamousPosts', 'news.unreadPostsMenu', 'news.allNews', 'news.recommendations', 'news.newspaper', 'news.userSubscriptions', 'news.latestUnreadPost', 'news.all_in_one_request'],
        url: function(_arg) {
          var postId;
          postId = _arg.postId;
          return "/newspaper_posts/view_post/" + postId + ".json";
        }
      },
      'news.unreadPostsMenu': {
        cacheValidityInMs: 300 * 1000,
        url: '/newspaper_posts/unread_count.json'
      },
      'news.unreadPosts': {
        cache: false,
        url: '/newspaper_posts/unread_subscription_count.json'
      },
      'news.unreadFamousPosts': {
        cache: false,
        url: '/newspaper_posts/unread_famous_count.json'
      },
      'news.latestPost': {
        cache: false,
        url: "/newspapers/latest_subscriptions_post.json"
      },
      'news.latestUnreadPost': {
        cacheValidityInMs: 300 * 1000,
        url: "/newspapers/latest_unread_post.json"
      },
      'news.userNewspaper': {
        url: "/newspapers/mynewspaper.json"
      },
      'news.getOpenPrice': {
        cacheValidityInMs: 300 * 1000,
        url: "/newspapers/get_open_price.json"
      },
      'news.openNewspaper': {
        cache: false,
        invalidate: ['news.userNewspaper'],
        required: ['newspaperName'],
        method: 'POST',
        data: function(_arg) {
          var newspaperName;
          newspaperName = _arg.newspaperName;
          return {
            'data[Newspaper][name]': newspaperName
          };
        },
        url: "/newspapers/create_newspaper.json"
      },
      'news.createArticle': {
        before: function() {
          return app.showLoader();
        },
        after: function() {
          return app.hideLoader();
        },
        cache: false,
        invalidate: ['news.userNewspaper'],
        method: 'POST',
        data: function(_arg) {
          var body, mainQuote, shortBody, title;
          title = _arg.title, shortBody = _arg.shortBody, mainQuote = _arg.mainQuote, body = _arg.body;
          return {
            'data[NewspaperPost][title]': title,
            'data[NewspaperPost][short_body]': shortBody,
            'data[NewspaperPost][main_quote]': mainQuote,
            'data[NewspaperPost][body]': body
          };
        },
        url: "/newspaper_posts/create_post.json"
      },
      'news.editArticle': {
        cache: false,
        invalidate: ['news.userNewspaper'],
        method: 'POST',
        data: function(_arg) {
          var body, mainQuote, postId, shortBody, title;
          postId = _arg.postId, title = _arg.title, shortBody = _arg.shortBody, mainQuote = _arg.mainQuote, body = _arg.body;
          return {
            'data[NewspaperPost][id]': postId,
            'data[NewspaperPost][title]': title,
            'data[NewspaperPost][short_body]': shortBody,
            'data[NewspaperPost][main_quote]': mainQuote,
            'data[NewspaperPost][body]': body
          };
        },
        url: "/newspaper_posts/edit_post.json"
      },
      'news.editNewspaper': {
        cache: false,
        invalidate: ['news.userNewspaper'],
        method: 'POST',
        data: function(_arg) {
          var name;
          name = _arg.name;
          return {
            'data[Newspaper][name]': name
          };
        },
        url: "/newspapers/edit.json"
      },
      'news.deleteNewspaper': {
        cache: false,
        invalidate: ['news.userNewspaper'],
        method: 'POST',
        url: "/newspapers/delete.json"
      },
      'news.add_like': {
        cache: false,
        invalidate: ['news.userNewspaper', 'news.userSubscriptions', 'news.allNews', 'news.recommendations', 'news.latestUnreadPost', 'news.unreadPostsMenu', 'news.unreadFamousPosts', 'news.unreadPosts', 'news.all_in_one_request'],
        method: 'POST',
        url: function(_arg) {
          var postId;
          postId = _arg.postId;
          return "/newspaper_posts/add_like/" + postId + ".json";
        }
      },
      'news.addComment': {
        cache: false,
        invalidate: ['news.userNewspaper', 'news.userSubscriptions', 'news.allNews', 'news.recommendations'],
        required: ['postId', 'body'],
        method: 'POST',
        data: function(_arg) {
          var body, postId;
          postId = _arg.postId, body = _arg.body;
          return {
            'data[NewspaperPostComment][newspaper_post_id]': postId,
            'data[NewspaperPostComment][body]': body
          };
        },
        url: "/newspaper_post_comments/add_comment.json"
      },
      'news.comment.delete': {
        cache: false,
        required: ['commentId'],
        invalidate: ['news.userNewspaper', 'news.userSubscriptions', 'news.allNews', 'news.recommendations', 'news.post'],
        method: 'POST',
        url: function(_arg) {
          var commentId;
          commentId = _arg.commentId;
          return "/newspaper_post_comments/delete_comment/" + commentId + ".json";
        }
      },
      'news.comment.edit': {
        cache: false,
        required: ['commentId'],
        method: 'GET',
        url: function(_arg) {
          var commentId;
          commentId = _arg.commentId;
          return "/newspaper_post_comments/edit_comment/" + commentId + ".json";
        }
      },
      'news.comment.update': {
        cache: false,
        invalidate: ['news.userNewspaper', 'news.userSubscriptions', 'news.allNews', 'news.recommendations', 'news.post'],
        required: ['commentId', 'body'],
        method: 'POST',
        data: function(_arg) {
          var body;
          body = _arg.body;
          return {
            'data[NewspaperPostComment][body]': body
          };
        },
        url: function(_arg) {
          var commentId;
          commentId = _arg.commentId;
          return "/newspaper_post_comments/edit_comment/" + commentId + ".json";
        }
      },
      'news.subscribe': {
        cache: false,
        invalidate: ['news.userSubscriptions', 'news.allNews', 'news.recommendations'],
        method: 'POST',
        url: function(_arg) {
          var newspaperId;
          newspaperId = _arg.newspaperId;
          return "/newspapers/subscribe/" + newspaperId + ".json";
        }
      },
      'news.unsubscribe': {
        cache: false,
        invalidate: ['news.userSubscriptions', 'news.allNews', 'news.recommendations'],
        method: 'POST',
        url: function(_arg) {
          var subscriptionId;
          subscriptionId = _arg.subscriptionId;
          return "/newspapers/delete_subscription/" + subscriptionId + ".json";
        }
      },
      'news.postSearch': {
        cache: false,
        required: ['title'],
        url: function(_arg) {
          var title;
          title = _arg.title;
          return "/newspaper_posts/post_search_ajax/" + title + ".json";
        }
      },

      /*
       			Parties
       */
      'party.list': {
        cacheValidityInMs: 300 * 1000,
        url: '/parties/party_list.json'
      },
      'party.info': {
        cache: false,
        url: function(_arg) {
          var partyId;
          partyId = _arg.partyId;
          if (partyId != null) {
            return "/parties/info/" + partyId + ".json";
          } else {
            return "/parties/info.json";
          }
        }
      },
      'party.create.price': {
        cacheValidityInMs: 300 * 1000,
        url: '/parties/price.json'
      },
      'party.create': {
        cache: false,
        invalidate: ['party.list'],
        method: 'POST',
        required: ['name', 'description', 'logo'],
        data: function(_arg) {
          var description, logo, name;
          name = _arg.name, description = _arg.description, logo = _arg.logo;
          return {
            'data[Party][name]': name,
            'data[Party][party_info]': description,
            'data[Party][logo]': logo
          };
        },
        url: function() {
          return "/parties/create.json";
        }
      },
      'party.update': {
        cache: false,
        invalidate: ['party.list', 'party.info'],
        method: 'POST',
        required: ['name', 'description', 'auto', 'logo'],
        data: function(_arg) {
          var auto, description, logo, name;
          name = _arg.name, description = _arg.description, auto = _arg.auto, logo = _arg.logo;
          return {
            'data[Party][name]': name,
            'data[Party][party_info]': description,
            'data[Party][auto_approve]': auto,
            'data[Party][logo]': logo
          };
        },
        url: '/parties/edit.json'
      },
      'party.disband': {
        cache: false,
        invalidate: ['party.list'],
        method: 'POST',
        url: function() {
          return "/parties/disband.json";
        }
      },
      'party.unfriendly': {
        cache: false,
        url: function(_arg) {
          var name, party, partyId, search;
          partyId = _arg.partyId, name = _arg.name;
          party = partyId != null ? "/" + partyId : "";
          search = name != null ? "/" + name : "";
          return "/parties/unfriendly" + party + search + ".json";
        }
      },
      'party.friends': {
        cache: false,
        url: function(_arg) {
          var partyId;
          partyId = _arg.partyId;
          if (partyId != null) {
            return "/parties/friends/" + partyId + ".json";
          } else {
            return "/parties/friends.json";
          }
        }
      },
      'party.friends.remove': {
        cache: false,
        invalidate: ['party.friends', 'party.unfriendly'],
        method: 'POST',
        require: ['partyId'],
        data: function(_arg) {
          var partyId;
          partyId = _arg.partyId;
          return {
            'data[Party][id]': partyId
          };
        },
        url: function() {
          return "/parties/delete_friend.json";
        }
      },
      'party.friends.add': {
        cache: false,
        invalidate: ['party.friends', 'party.unfriendly'],
        method: 'POST',
        require: ['partyId'],
        data: function(_arg) {
          var partyId;
          partyId = _arg.partyId;
          return {
            'data[Party][id]': partyId
          };
        },
        url: function() {
          return "/parties/add_friend.json";
        }
      },
      'party.members': {
        cacheValidityInMs: 30 * 1000,
        url: function(_arg) {
          var partyId, userName;
          partyId = _arg.partyId, userName = _arg.userName;
          if (partyId != null) {
            if (userName != null) {
              return "/parties/members/" + partyId + ".json?userName=" + userName;
            } else {
              return "/parties/members/" + partyId + ".json";
            }
          } else {
            return "/parties/members.json";
          }
        }
      },
      'party.leave': {
        cache: false,
        invalidate: ['party.list'],
        method: 'POST',
        url: function() {
          return "/parties/leave_party.json";
        }
      },
      'party.requests': {
        cacheValidityInMs: 30 * 1000,
        url: function() {
          return "/parties/requests.json";
        }
      },
      'party.requests.count': {
        url: function() {
          return "/parties/requests_count.json";
        }
      },
      'party.request.decline': {
        cache: false,
        method: 'POST',
        invalidate: ['party.list', 'party.requests', 'party.requests.count'],
        required: ['requestId'],
        data: function(_arg) {
          var requestId;
          requestId = _arg.requestId;
          return {
            'data[PartyRequest][id]': requestId
          };
        },
        url: function() {
          return "/parties/decline_request.json";
        }
      },
      'party.request.accept': {
        cache: false,
        method: 'POST',
        required: ['requestId'],
        invalidate: ['party.list', 'party.requests', 'party.requests.count'],
        data: function(_arg) {
          var requestId;
          requestId = _arg.requestId;
          return {
            'data[PartyRequest][id]': requestId
          };
        },
        url: function() {
          return "/parties/accept_request.json";
        }
      },
      'party.join': {
        cache: false,
        method: 'POST',
        required: ['partyId'],
        invalidate: ['party.list'],
        data: function(_arg) {
          var partyId;
          partyId = _arg.partyId;
          return {
            'data[PartyRequest][party_id]': partyId
          };
        },
        url: '/parties/join.json'
      },
      'party.level.up': {
        cache: false,
        method: 'POST',
        required: ['partyId'],
        invalidate: ['party.info', 'party.treasure'],
        data: function(_arg) {
          var partyId;
          partyId = _arg.partyId;
          return {
            'data[Party][id]': partyId
          };
        },
        url: '/parties/level_up.json'
      },
      'party.level.up.price': {
        cacheValidityInMs: 30 * 1000,
        method: 'GET',
        required: ['partyId'],
        url: function(_arg) {
          var partyId;
          partyId = _arg.partyId;
          return "/parties/level_up_price/" + partyId + ".json";
        }
      },
      'party.treasure': {
        cache: false,
        url: function() {
          return "/parties/treasure.json";
        }
      },
      'party.treasure.donate': {
        cache: false,
        method: 'POST',
        required: ['amount', 'currency', 'partyId'],
        invalidate: ['party.treasure'],
        data: function(_arg) {
          var amount, currency, partyId;
          partyId = _arg.partyId, amount = _arg.amount, currency = _arg.currency;
          return {
            'data[Party][id]': partyId,
            'data[Party][amount]': amount,
            'data[Party][currency]': currency
          };
        },
        url: '/parties/donate.json',
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'party.parliamentary': {
        cache: false,
        url: function() {
          return "/parliament/parliamentaries.json";
        }
      },
      'party.member': {
        cache: false,
        required: ['memberId'],
        url: function(_arg) {
          var memberId;
          memberId = _arg.memberId;
          return "/parties/member/" + memberId + ".json";
        }
      },
      'party.member.remove': {
        cache: false,
        required: ['memberId'],
        invalidate: ['party.members'],
        method: 'POST',
        data: function(_arg) {
          var memberId;
          memberId = _arg.memberId;
          return {
            'data[PartyMember][id]': memberId
          };
        },
        url: function() {
          return "/parties/remove_member.json";
        }
      },
      'party.member.remove_from_office': {
        cache: false,
        required: ['memberId'],
        invalidate: ['party.members'],
        method: 'POST',
        data: function(_arg) {
          var memberId;
          memberId = _arg.memberId;
          return {
            'data[PartyMember][id]': memberId
          };
        },
        url: function() {
          return "/parties/remove_from_office.json";
        }
      },
      'party.member.set.master': {
        cache: false,
        required: ['memberId'],
        invalidate: ['party.members'],
        method: 'POST',
        data: function(_arg) {
          var memberId;
          memberId = _arg.memberId;
          return {
            'data[PartyMember][id]': memberId
          };
        },
        url: function() {
          return "/parties/set_master.json";
        }
      },
      'party.member.set.submaster': {
        cache: false,
        required: ['memberId'],
        invalidate: ['party.members'],
        method: 'POST',
        data: function(_arg) {
          var memberId;
          memberId = _arg.memberId;
          return {
            'data[PartyMember][id]': memberId
          };
        },
        url: function() {
          return "/parties/set_submaster.json";
        }
      },
      'party.member.parliament.add': {
        cache: false,
        required: ['memberId'],
        invalidate: ['party.parliamentary'],
        method: 'POST',
        data: function(_arg) {
          var memberId;
          memberId = _arg.memberId;
          return {
            'data[PartyMember][id]': memberId
          };
        },
        url: function() {
          return "/parliament/add.json";
        }
      },
      'party.member.parliament.remove': {
        cache: false,
        required: ['userId'],
        invalidate: ['party.parliamentary'],
        method: 'POST',
        data: function(_arg) {
          var userId;
          userId = _arg.userId;
          return {
            'data[User][id]': userId
          };
        },
        url: function() {
          return "/parliament/remove.json";
        }
      },
      'party.parliament.reorder': {
        cache: false,
        required: ['ids'],
        invalidate: ['party.parliamentary'],
        method: 'POST',
        data: function(_arg) {
          var ids;
          ids = _arg.ids;
          return {
            'data[list]': ids
          };
        },
        url: function() {
          return "/parliament/sort.json";
        }
      },
      'party.parliament.add': {
        invalidate: ['parliament.election.candidates', 'party.parliamentary'],
        method: 'POST',
        url: function() {
          return "/parliament/add_request.json";
        }
      },
      'party.parliament.remove': {
        invalidate: ['parliament.election.candidates', 'party.parliamentary'],
        method: 'POST',
        url: function() {
          return "/parliament/remove_request.json";
        }
      },
      'party.rights.get': {
        cache: false,
        required: ['memberId'],
        url: function(_arg) {
          var memberId;
          memberId = _arg.memberId;
          return "/party_depeties/get/" + memberId + ".json";
        }
      },
      'party.rights.change': {
        cache: false,
        required: ['memberId', 'permission', 'action'],
        invalidate: ['party.rights.get'],
        method: 'POST',
        data: function(_arg) {
          var action, memberId, permission;
          memberId = _arg.memberId, permission = _arg.permission, action = _arg.action;
          return {
            'data[PartyMember][id]': memberId,
            'data[Rights][type]': permission,
            'data[Rights][action]': action
          };
        },
        url: function() {
          return "/party_depeties/change.json";
        }
      },
      'party.rights.remove.all': {
        cache: false,
        required: ['memberId'],
        invalidate: ['party.rights.get'],
        method: 'POST',
        data: function(_arg) {
          var memberId;
          memberId = _arg.memberId;
          return {
            'data[PartyMember][id]': memberId
          };
        },
        url: function() {
          return "/party_depeties/remove_from_user.json";
        }
      },
      'parliament.election.candidates': {
        url: function() {
          return "/city_elections/candidates.json";
        }
      },
      'parliament.election.result': {
        url: function() {
          return "/city_elections/result.json";
        }
      },
      'parliament.election.vote': {
        cache: false,
        required: ['partyId'],
        method: 'POST',
        invalidate: ['parliament.election.candidates'],
        data: function(_arg) {
          var partyId;
          partyId = _arg.partyId;
          return {
            'data[Party][id]': partyId
          };
        },
        url: function() {
          return "/city_elections/vote.json";
        }
      },
      'house.info': {
        cacheValidityInMs: 30 * 1000,
        url: function() {
          return "/user_homes/info.json";
        }
      },
      'house.buy': {
        cache: false,
        method: 'POST',
        invalidate: ['house.info', 'inventory', 'inventory.furniture'],
        data: function(_arg) {
          var homeTypeId;
          homeTypeId = _arg.homeTypeId;
          return {
            'data[UserHomeType][id]': homeTypeId
          };
        },
        url: function() {
          return "/user_homes/buy_home.json";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'house.putFurniture': {
        cache: false,
        method: 'POST',
        invalidate: ['house.info', 'inventory', 'inventory.furniture'],
        data: function(_arg) {
          var homeId, itemId, placeSlot;
          itemId = _arg.itemId, homeId = _arg.homeId, placeSlot = _arg.placeSlot;
          return {
            'data[UserItem][id]': itemId,
            'data[UserHome][id]': homeId,
            'data[UserHome][slot]': placeSlot
          };
        },
        url: function() {
          return "/user_homes/put_item_to_flat.json";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'house.removeFurniture': {
        cache: false,
        method: 'POST',
        invalidate: ['house.info', 'inventory', 'inventory.furniture'],
        data: function(_arg) {
          var homeId, placeSlot;
          homeId = _arg.homeId, placeSlot = _arg.placeSlot;
          return {
            'data[UserHome][id]': homeId,
            'data[UserHome][slot]': placeSlot
          };
        },
        url: function() {
          return "/user_homes/put_item_from_flat.json";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'house.levelUpFurnitureSlots': {
        cache: false,
        method: 'POST',
        invalidate: ['house.info'],
        required: ['UserHomeId'],
        data: function(_arg) {
          var UserHomeId;
          UserHomeId = _arg.UserHomeId;
          return {
            'data[UserHome][id]': UserHomeId
          };
        },
        url: function() {
          return "/user_homes/levelup_furniture_slots.json";
        },
        after: function() {
          app.menu.view.reload();
          return app.shortInfo.view.reload();
        }
      },
      'shop.list': {
        cache: false,
        method: 'GET',
        url: "/shop/index.json"
      },
      'shop.check_can_buy': {
        cache: false,
        method: 'GET',
        required: ['id'],
        url: function(_arg) {
          var id, quantity;
          id = _arg.id, quantity = _arg.quantity;
          return "/shop/check_can_buy.json?id=" + id + "&quantity=" + (quantity || 1);
        }
      },
      'shop.buy': {
        cache: false,
        method: 'POST',
        url: "/shop/buy.json",
        required: ['id'],
        data: function(_arg) {
          var id, quantity;
          id = _arg.id, quantity = _arg.quantity;
          return {
            'data[ShopGoods][id]': id,
            'data[ShopGoods][quantity]': quantity || 1
          };
        }
      }
    };

    return ServerController;

  })(Marionette.Controller);
  return ServerController;
});
