var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['marionette'], function(Marionette) {
  var TutorialController;
  TutorialController = (function(_super) {
    __extends(TutorialController, _super);

    function TutorialController() {
      this._onItemEaten = __bind(this._onItemEaten, this);
      this._onFishingCompleted = __bind(this._onFishingCompleted, this);
      this._onFight = __bind(this._onFight, this);
      this._onItemPurchased = __bind(this._onItemPurchased, this);
      this._onCategorySelected = __bind(this._onCategorySelected, this);
      this._onFullHealed = __bind(this._onFullHealed, this);
      this._onTraumaHealed = __bind(this._onTraumaHealed, this);
      this._onTrained = __bind(this._onTrained, this);
      this._onQuestCompleted = __bind(this._onQuestCompleted, this);
      this._onJobWorked = __bind(this._onJobWorked, this);
      this._onJobHired = __bind(this._onJobHired, this);
      this._onQuestTaken = __bind(this._onQuestTaken, this);
      this._startInventoryEatTutorial = __bind(this._startInventoryEatTutorial, this);
      this._startFishingTutorial = __bind(this._startFishingTutorial, this);
      this._startTreatmentTutorial = __bind(this._startTreatmentTutorial, this);
      this._startGangFightTutorial = __bind(this._startGangFightTutorial, this);
      this._startTradeCenterTutorial = __bind(this._startTradeCenterTutorial, this);
      this._startTraumaTutorial = __bind(this._startTraumaTutorial, this);
      this._startTrainingTutorial = __bind(this._startTrainingTutorial, this);
      this._startJobTutorial = __bind(this._startJobTutorial, this);
      this._startQuestTutorial = __bind(this._startQuestTutorial, this);
      this.finish = __bind(this.finish, this);
      this.start = __bind(this.start, this);
      return TutorialController.__super__.constructor.apply(this, arguments);
    }

    TutorialController.prototype.TUTORIAL_QUEST = 'quest';

    TutorialController.prototype.TUTORIAL_JOB = 'job';

    TutorialController.prototype.TUTORIAL_TRAINING = 'training';

    TutorialController.prototype.TUTORIAL_TRAUMA = 'trauma';

    TutorialController.prototype.TUTORIAL_TRADECENTER = 'tradecenter';

    TutorialController.prototype.TUTORIAL_GANGFIGHT = 'gangfight';

    TutorialController.prototype.TUTORIAL_TREATMENT = 'treatment';

    TutorialController.prototype.TUTORIAL_FISHING = 'fishing';

    TutorialController.prototype.TUTORIAL_INVENTORY_EAT = 'inventory_eat';

    TutorialController.prototype._completedTutorials = [];

    TutorialController.prototype.initialize = function(_arg) {
      this.app = _arg.app;
      this._tutorials = [this.TUTORIAL_QUEST, this.TUTORIAL_JOB, this.TUTORIAL_TRAINING, this.TUTORIAL_TRADECENTER, this.TUTORIAL_GANGFIGHT, this.TUTORIAL_FISHING, this.TUTORIAL_INVENTORY_EAT];
      this._startedTutorials = [];
      this._completedTutorials = [];
      this._tutorialCallbacks = {};
      this._tutorialCallbacks[this.TUTORIAL_QUEST] = this._startQuestTutorial;
      this._tutorialCallbacks[this.TUTORIAL_JOB] = this._startJobTutorial;
      this._tutorialCallbacks[this.TUTORIAL_TRAINING] = this._startTrainingTutorial;
      this._tutorialCallbacks[this.TUTORIAL_TRAUMA] = this._startTraumaTutorial;
      this._tutorialCallbacks[this.TUTORIAL_TRADECENTER] = this._startTradeCenterTutorial;
      this._tutorialCallbacks[this.TUTORIAL_GANGFIGHT] = this._startGangFightTutorial;
      this._tutorialCallbacks[this.TUTORIAL_TREATMENT] = this._startTreatmentTutorial;
      this._tutorialCallbacks[this.TUTORIAL_FISHING] = this._startFishingTutorial;
      this._tutorialCallbacks[this.TUTORIAL_INVENTORY_EAT] = this._startInventoryEatTutorial;
      this._totalTutorialsCount = Object.keys(this._tutorialCallbacks).length;
      return this._tradeCenterItemTypes = ['armorBody', 'armorHead', 'armorLegs', 'armorBoots', 'closeRangeWeapon', 'weapon', 'ammunition', 'jewelry', 'clothes'];
    };

    TutorialController.prototype.start = function() {
      this._bindEvents();
      return this.app.modalDialog.screen('tutor');
    };

    TutorialController.prototype.finish = function() {
      return this._unbindEvents();
    };

    TutorialController.prototype.completeTutorial = function(tutorial) {
      if (this._completedTutorials.indexOf(tutorial) === -1) {
        this._completedTutorials.push(tutorial);
        if (this._completedTutorials.length >= this._totalTutorialsCount) {
          return this.finish();
        }
      }
    };

    TutorialController.prototype.checkCompleted = function(tutorial) {
      return !(this._completedTutorials.indexOf(tutorial) === -1);
    };

    TutorialController.prototype.checkStarted = function(tutorial) {
      return !(this._startedTutorials.indexOf(tutorial) === -1);
    };

    TutorialController.prototype.checkInProgress = function(tutorial) {
      return this.checkStarted(tutorial) && !this.checkCompleted(tutorial);
    };

    TutorialController.prototype.getNextTutorial = function() {
      var tutorial, _i, _len, _ref;
      _ref = this._tutorials;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        tutorial = _ref[_i];
        if (this._completedTutorials.indexOf(tutorial) === -1) {
          return tutorial;
        }
      }
      return false;
    };

    TutorialController.prototype.startNextTutorial = function() {
      var next;
      next = this.getNextTutorial();
      if (next && this._tutorialCallbacks.hasOwnProperty(next)) {
        return this._tutorialCallbacks[next]();
      }
    };

    TutorialController.prototype._startQuestTutorial = function() {
      this._startedTutorials.push(this.TUTORIAL_QUEST);
      return this.app.modalDialog.screen('tutor/quests-1');
    };

    TutorialController.prototype._startJobTutorial = function() {
      this._startedTutorials.push(this.TUTORIAL_JOB);
      return this.app.modalDialog.screen('tutor/job');
    };

    TutorialController.prototype._startTrainingTutorial = function() {
      this._startedTutorials.push(this.TUTORIAL_TRAINING);
      return this.app.modalDialog.screen('tutor/train-1');
    };

    TutorialController.prototype._startTraumaTutorial = function() {
      this._startedTutorials.push(this.TUTORIAL_TRAUMA);
      return this.app.modalDialog.screen('tutor/injury-1');
    };

    TutorialController.prototype._startTradeCenterTutorial = function() {
      this._startedTutorials.push(this.TUTORIAL_TRADECENTER);
      return this.app.modalDialog.screen('tutor/trade-center-1');
    };

    TutorialController.prototype._startGangFightTutorial = function() {
      this._startedTutorials.push(this.TUTORIAL_GANGFIGHT);
      return this.app.modalDialog.screen('tutor/fight-1');
    };

    TutorialController.prototype._startTreatmentTutorial = function() {
      this._startedTutorials.push(this.TUTORIAL_TREATMENT);
      return this.app.modalDialog.screen('tutor/treatment-1');
    };

    TutorialController.prototype._startFishingTutorial = function() {
      this._startedTutorials.push(this.TUTORIAL_FISHING);
      return this.app.modalDialog.screen('tutor/port-1');
    };

    TutorialController.prototype._startInventoryEatTutorial = function() {
      this._startedTutorials.push(this.TUTORIAL_INVENTORY_EAT);
      return this.app.modalDialog.screen('tutor/eat-1');
    };

    TutorialController.prototype._bindEvents = function() {
      app.vent.on('job:hired', this._onJobHired);
      app.vent.on('job:worked', this._onJobWorked);
      app.vent.on('quests:quest_taken', this._onQuestTaken);
      app.vent.on('quests:quest_completed', this._onQuestCompleted);
      app.vent.on('stadium:trained', this._onTrained);
      app.vent.on('hospital:full_healed', this._onFullHealed);
      app.vent.on('hospital:trauma_healed', this._onTraumaHealed);
      app.vent.on('trade-center:category_selected', this._onCategorySelected);
      app.vent.on('trade-center:item_purchased', this._onItemPurchased);
      app.vent.on('military-base:gangs_fought', this._onFight);
      app.vent.on('port:fishing_completed', this._onFishingCompleted);
      return app.vent.on('inventory:item_eaten', this._onItemEaten);
    };

    TutorialController.prototype._unbindEvents = function() {
      app.vent.off('job:hired', this._onJobHired);
      app.vent.off('job:worked', this._onJobWorked);
      app.vent.off('quests:quest_taken', this._onQuestTaken);
      app.vent.off('quests:quest_completed', this._onQuestCompleted);
      app.vent.off('stadium:trained', this._onTrained);
      app.vent.off('hospital:full_healed', this._onFullHealed);
      app.vent.off('hospital:trauma_healed', this._onTraumaHealed);
      app.vent.off('trade-center:item_purchased', this._onItemPurchased);
      app.vent.off('military-base:gangs_fought', this._onFight);
      app.vent.off('port:fishing_completed', this._onFishingCompleted);
      return app.vent.off('inventory:item_eaten', this._onItemEaten);
    };

    TutorialController.prototype._onQuestTaken = function(event) {
      if (event.data.cid === 'tutorial_job' && !this.checkCompleted(this.TUTORIAL_JOB)) {
        this.completeTutorial(this.TUTORIAL_QUEST);
        this._startJobTutorial();
      }
      if (event.data.cid === 'tutorial_training' && !this.checkCompleted(this.TUTORIAL_TRAINING)) {
        this._startTrainingTutorial();
      }
      if (event.data.cid === 'tutorial_tradecenter' && !this.checkCompleted(this.TUTORIAL_TRADECENTER)) {
        this._startTradeCenterTutorial();
      }
      if (event.data.cid === 'tutorial_gangfight' && !this.checkCompleted(this.TUTORIAL_GANGFIGHT)) {
        this._startGangFightTutorial();
      }
      if (event.data.cid === 'tutorial_fishing' && !this.checkCompleted(this.TUTORIAL_FISHING)) {
        return this._startFishingTutorial();
      }
    };

    TutorialController.prototype._onJobHired = function() {
      if (!this.checkCompleted(this.TUTORIAL_JOB)) {
        return app.modalDialog.screen('tutor/job-4');
      }
    };

    TutorialController.prototype._onJobWorked = function() {
      if (!this.checkCompleted(this.TUTORIAL_JOB)) {
        return app.modalDialog.screen('tutor/job-6');
      }
    };

    TutorialController.prototype._onQuestCompleted = function(event) {
      if (event.data.cid === 'tutorial_job' && !this.checkCompleted(this.TUTORIAL_JOB)) {
        this.completeTutorial(this.TUTORIAL_JOB);
      }
      if (event.data.cid === 'tutorial_fishing' && !this.checkCompleted(this.TUTORIAL_INVENTORY_EAT)) {
        return this._startInventoryEatTutorial();
      }
    };

    TutorialController.prototype._onTrained = function(event) {
      if (!this.checkCompleted(this.TUTORIAL_TRAINING)) {
        this.completeTutorial(this.TUTORIAL_TRAINING);
      }
      if (event.injured && !this.checkCompleted(this.TUTORIAL_TRAUMA)) {
        return this._startTraumaTutorial();
      }
    };

    TutorialController.prototype._onTraumaHealed = function() {
      if (this.checkInProgress(this.TUTORIAL_TRAUMA)) {
        this.completeTutorial(this.TUTORIAL_TRAUMA);
        return app.modalDialog.screen('tutor/injury-4');
      }
    };

    TutorialController.prototype._onFullHealed = function() {
      if (this.checkInProgress(this.TUTORIAL_TREATMENT)) {
        this.completeTutorial(this.TUTORIAL_TREATMENT);
        return app.modalDialog.screen('tutor/treatment-4');
      }
    };

    TutorialController.prototype._onCategorySelected = function(event) {
      if (this.checkInProgress(this.TUTORIAL_TRADECENTER) && this._tradeCenterItemTypes.indexOf(event.type) !== -1) {
        return app.screens.once('view:ready', function() {
          return app.modalDialog.screen('tutor/trade-center-5');
        });
      }
    };

    TutorialController.prototype._onItemPurchased = function(event) {
      var type;
      type = event.data.type_alias;
      if (this._tradeCenterItemTypes.indexOf(type) !== -1 && this.checkInProgress(this.TUTORIAL_TRADECENTER)) {
        this.completeTutorial(this.TUTORIAL_TRADECENTER);
        return app.modalDialog.screen('tutor/trade-center-6');
      }
    };

    TutorialController.prototype._onFight = function(event) {
      var treatmentStarted;
      treatmentStarted = false;
      if (this.checkInProgress(this.TUTORIAL_GANGFIGHT)) {
        this.completeTutorial(this.TUTORIAL_GANGFIGHT);
        if (event.data.result.healthLoss < 0) {
          treatmentStarted = true;
          this._startTreatmentTutorial();
        } else if (event.data.result.traumas.length > 0 && !checkCompleted(this.TUTORIAL_TRAUMA)) {
          this._startTraumaTutorial();
        } else {
          app.modalDialog.screen('tutor/fight-6');
        }
        return;
      }
      if (event.data.result.traumas.length > 0 && !checkCompleted(this.TUTORIAL_TRAUMA) && !treatmentStarted) {
        return this._startTraumaTutorial();
      }
    };

    TutorialController.prototype._onFishingCompleted = function() {
      if (this.checkInProgress(this.TUTORIAL_FISHING)) {
        this.completeTutorial(this.TUTORIAL_FISHING);
        return app.modalDialog.screen('tutor/port-4');
      }
    };

    TutorialController.prototype._onItemEaten = function() {
      if (this.checkInProgress(this.TUTORIAL_INVENTORY_EAT)) {
        return this.completeTutorial(this.TUTORIAL_INVENTORY_EAT);
      }
    };

    return TutorialController;

  })(Marionette.Controller);
  return TutorialController;
});
