var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['marionette'], function(Marionette) {
  var UserEventsController;
  UserEventsController = (function(_super) {
    __extends(UserEventsController, _super);

    function UserEventsController() {
      this.nodeConnect = __bind(this.nodeConnect, this);
      this.restartNodeConnect = __bind(this.restartNodeConnect, this);
      return UserEventsController.__super__.constructor.apply(this, arguments);
    }

    UserEventsController.prototype.initialize = function(_arg) {
      this.app = _arg.app;
      this.startedRequest = false;
      return this.startedNodeRequest = false;
    };

    UserEventsController.prototype.restartNodeConnect = function(app) {
      app.userEvents.startedNodeRequest = false;
      return app.userEvents.nodeConnect(app);
    };

    UserEventsController.prototype.nodeConnect = function(app) {
      var errorCalled, started;
      if (!app.userEvents.startedNodeRequest) {
        app.userEvents.startedNodeRequest = true;
        started = Date.now();
        errorCalled = false;
        return app.server.user.node.longpoll({
          success: (function(_this) {
            return function(data) {
              app.userEvents.restartNodeConnect(app);
              if (data.data != null) {
                if (data.data.type === 'ot_notify') {
                  app.userEvents.hasPrestigeWar();
                }
                if (data.data.type === 'bb_notify') {
                  app.userEvents.hasBigFight();
                }
                if (data.data.type === 'levelup_notify') {
                  app.userEvents.levelUp();
                }
                if (data.data.type === 'mayor_election_notify') {
                  app.userEvents.mayorElection();
                }
                if (data.data.type === 'parliament_election_notify') {
                  app.userEvents.mayorElection();
                }
                if (data.data.type === 'energy_notify') {
                  setTimeout(function() {
                    return app.userEvents.energyUpdated(data);
                  }, 0);
                }
                if (data.data.type === 'areas_takeovers_rounds_notify') {
                  app.userEvents.areasTakeoversRounds(data.data);
                }
                if (data.data.type === 'User.messages.UnreadCount.update') {
                  app.trigger(data.data.type, data.data);
                }
                if (data.data.type === 'User.Friends.RequestCount.update') {
                  app.trigger(data.data.type, data.data);
                }
                if (data.data.type === 'User.Feed.newMessageCount.update') {
                  app.trigger(data.data.type, data.data);
                }
                if (data.data.type === 'quest_finished') {
                  return app.trigger(data.data.type, data.data);
                }
              }
            };
          })(this),
          error: (function(_this) {
            return function(error) {
              var duration, minInterval;
              if (!errorCalled) {
                errorCalled = true;
                minInterval = 5000;
                duration = Date.now() - started;
                if (duration < minInterval) {
                  return setTimeout((function() {
                    return app.userEvents.restartNodeConnect(app);
                  }), minInterval - duration);
                } else {
                  return app.userEvents.restartNodeConnect(app);
                }
              }
            };
          })(this)
        });
      }
    };

    UserEventsController.prototype.levelUp = function() {
      if (!this.app.screens.check('common/level-up-first-popup')) {
        return this.app.screens.modal('common/level-up-first-popup');
      }
    };

    UserEventsController.prototype.hasPrestigeWar = function() {
      this.app.server.events.ot.silent.cache.invalidate();
      return this.reloadMenu();
    };

    UserEventsController.prototype.hasBigFight = function() {
      this.app.server.events.bb.silent.cache.invalidate();
      return this.reloadMenu();
    };

    UserEventsController.prototype.mayorElection = function() {
      this.app.server.events.election.silent.cache.invalidate();
      return this.reloadMenu();
    };

    UserEventsController.prototype.energyUpdated = function(data) {
      return this.trigger("energy:updated", data.data.level);
    };

    UserEventsController.prototype.reloadMenu = function() {
      this.app.menu.view.reload();
      return this.app.shortInfo.view.reload();
    };

    UserEventsController.prototype.areasTakeoversRounds = function(data) {
      var roundId, _i, _len, _ref, _results;
      _ref = data.roundsIds;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        roundId = _ref[_i];
        _results.push(this.app.screens.modal('military-base/at-round-result-popup', {
          roundId: roundId
        }));
      }
      return _results;
    };

    return UserEventsController;

  })(Marionette.Controller);
  return UserEventsController;
});
