var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['underscore', 'backbone'], function(_, Backbone) {
  var Translation, Translations;
  Translation = (function(_super) {
    __extends(Translation, _super);

    Translation.prototype.defaults = function() {
      return {
        id: null,
        locale: null,
        variable: null,
        translation: null
      };
    };

    function Translation(options) {
      Translation.__super__.constructor.call(this, options);
    }

    return Translation;

  })(Backbone.Model);
  Translations = (function(_super) {
    __extends(Translations, _super);

    function Translations() {
      return Translations.__super__.constructor.apply(this, arguments);
    }

    Translations.prototype.model = Translation;

    Translations.prototype.localeToLn = {
      'rus': 'ru',
      'eng': 'en',
      'pol': 'pl'
    };

    Translations.prototype.initialize = function(models, options) {
      var recentLocale;
      this.app = options.app;
      recentLocale = localStorage.getItem('recent_locale');
      if (recentLocale) {
        return this.locale = this.recentLocale;
      }
    };

    Translations.prototype.fetch = function(options) {
      var collection, locale;
      collection = this;
      locale = this.locale != null ? this.locale : 'eng';
      return $.ajax('scripts/translations/' + locale + '.js', {
        success: function(data) {
          var translationsData, translationsLastUpdate, url;
          translationsLastUpdate = data['translationsLastUpdate'];
          translationsData = data['translations'];
          collection.reset(translationsData);
          url = app.config.serverURLProtocol + '://' + app.config.serverURL + '/translations/get/' + locale + '.json';
          return $.ajax(url, {
            type: 'POST',
            data: {
              'translationsLastUpdate': translationsLastUpdate
            },
            success: function(data) {
              collection.add(data, {
                merge: true
              });
              if (options.success) {
                return options.success(collection, data, options);
              }
            },
            error: function(xhr, textStatus, errorThrown) {
              if (options.error) {
                return options.error();
              }
            }
          });
        },
        error: function(jqXHR, textStatus, errorThrown) {
          return options.error();
        },
        dataType: 'json'
      });
    };

    Translations.prototype.url = function() {
      return this.app.config.serverURLProtocol + '://' + this.app.config.serverURL + (this.locale != null ? "/translations/get/" + this.locale + ".json" : "/translations/get.json");
    };

    Translations.prototype.setLocale = function(locale) {
      this.locale = locale;
      return localStorage.setItem('recent_locale', locale);
    };

    Translations.prototype.getLocale = function() {
      return this.locale;
    };

    Translations.prototype.getLn = function() {
      if (this.localeToLn[this.locale] != null) {
        return this.localeToLn[this.locale];
      } else {
        return $localeToLn['eng'];
      }
    };

    Translations.prototype.setLocaleAndFetch = function(locale, callback) {
      this.setLocale(locale);
      return this.fetch({
        success: (function(_this) {
          return function(collection, response, options) {
            if (callback != null) {
              return callback();
            }
          };
        })(this),
        error: (function(_this) {
          return function(collection, response, options) {
            if (callback != null) {
              return callback();
            }
          };
        })(this)
      });
    };

    Translations.prototype.tr = function(variable, locale) {
      var translation;
      if (locale == null) {
        locale = null;
      }
      translation = this.findWhere({
        variable: variable,
        locale: (locale != null ? locale : this.getLocale())
      });
      if (translation != null) {
        return translation.get('translation');
      } else {
        return variable;
      }
    };

    return Translations;

  })(Backbone.Collection);
  return Translations;
});
