var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['jquery', 'services/social/base'], function($, BaseProvider) {
  var VKProvider;
  VKProvider = (function(_super) {
    __extends(VKProvider, _super);

    function VKProvider(type, config) {
      this._showAuthPopup = __bind(this._showAuthPopup, this);
      this._tokenRequest = __bind(this._tokenRequest, this);
      VKProvider.__super__.constructor.call(this, type, config);
      this._storageKey = 'social_data_vk';
      this._tokenUri = 'https://oauth.vk.com/authorize';
      this._methodUri = 'https://api.vk.com/method/';
      this._tokenRedirectUri = 'https://oauth.vk.com/blank.html';
      this._scopeMapping = {};
      this._scopeMapping[this.SCOPE_EMAIL] = 'email';
      this._scopeMapping[this.SCOPE_FRIENDS] = 'friends';
      this._scopeMapping[this.SCOPE_WALL] = 'wall';
      this._scopeMapping[this.SCOPE_MESSAGES] = 'messages';
      this._scopeMapping[this.SCOPE_OFFLINE] = 'offline';
      this._scopeBitsMapping = {};
      this._scopeBitsMapping[this.SCOPE_EMAIL] = 4194304;
      this._scopeBitsMapping[this.SCOPE_FRIENDS] = 2;
      this._scopeBitsMapping[this.SCOPE_WALL] = 8192;
      this._scopeBitsMapping[this.SCOPE_MESSAGES] = 4096;
      this._scopeBitsMapping[this.SCOPE_OFFLINE] = 65536;
      this._forceTokenData = {
        'revoke': '1'
      };
      this._init(config);
    }

    VKProvider.prototype.share = function(data) {
      var uri;
      uri = 'http://vk.com/share.php';
      return this._showPopup(uri, data);
    };

    VKProvider.prototype.wallPost = function(data) {
      if (this._checkScopeGranted(this.SCOPE_WALL) === false) {
        return this.grantScopeRequest(this.SCOPE_WALL).then(this.wallPost, this._onError);
      }
      data = {
        owner_id: this._session.user_id,
        access_token: this._session.token
      };
      return this._methodCall('wall.post', data);
    };

    VKProvider.prototype._loadFriendIds = function(deferred) {
      var data, self;
      data = {
        user_id: this._session.user_id,
        access_token: this._session.token,
        fields: 'nickname,sex,country'
      };
      self = this;
      return this._methodCall('friends.get', data).then(function(data) {
        var friendIds, friends, resultData;
        resultData = {
          status: 'error'
        };
        if ((data != null) && (data != null ? data.error : void 0)) {
          self._setError(data.error.code, data.error.message);
          resultData.error = self.getError();
        } else if (data) {
          friends = data.response;
          friendIds = friends.filter(function(n) {
            return !n.deactivated;
          }).map(function(n) {
            return n.user_id;
          });
          resultData.status = 'success';
          resultData.friendIds = friendIds;
        }
        if (resultData.status === 'success') {
          return deferred.resolve(resultData);
        } else {
          return deferred.reject(resultData);
        }
      }, self._getXHRErrorHandler(deferred));
    };

    VKProvider.prototype._loadUserData = function(deferred) {
      var data, self;
      data = {
        user_ids: this._session.user_id,
        fields: 'sex,bdate,city,country,contacts',
        access_token: this._session.token
      };
      self = this;
      return this._methodCall('users.get', data).then(function(data) {
        var response, resultData, userData;
        resultData = {
          status: 'error'
        };
        if ((data != null) && (data != null ? data.error : void 0)) {
          self._setError(data.error.code, data.error.message);
          resultData.error = self.getError();
        } else if (data != null) {
          response = data.response[0];
          userData = {
            user_id: (response != null ? response.id : void 0) ? response.id : self._session.user_id,
            email: (response != null ? response.email : void 0) ? response.email : self._session.email,
            first_name: response.first_name,
            last_name: response.last_name,
            full_name: (response.first_name + ' ' + response.last_name).trim(),
            birth_date: null,
            sex: (response != null ? response.sex : void 0) && response.sex === 1 ? 'female' : 'male'
          };
          resultData.status = 'success';
          resultData.user = userData;
          self._storeUserData(userData);
        } else {
          self._setError('FATAL_ERROR', 'Failed to load userData');
          resultData.error = self.getError();
        }
        if (resultData.status === 'success') {
          return deferred.resolve(resultData);
        } else {
          return deferred.reject(resultData);
        }
      }, self._getXHRErrorHandler(deferred));
    };

    VKProvider.prototype._loadGrantedScope = function(deferred) {
      var data, self;
      data = {
        user_id: this._session.user_id,
        access_token: this._token
      };
      self = this;
      return this._methodCall('account.getAppPermissions', data).then(function(data) {
        var bit, resultData, resultMask, scopeList, vkBit, vkMask, _ref;
        resultData = {
          status: 'error'
        };
        if ((data != null) && (data != null ? data.error : void 0)) {
          self._setError(data.error.code, data.error.message);
          resultData.error = self.getError();
        } else if (data != null) {
          scopeList = [];
          resultMask = 0;
          vkMask = data.response;
          _ref = self._scopeBitsMapping;
          for (bit in _ref) {
            vkBit = _ref[bit];
            if (vkMask & vkBit) {
              resultMask = resultMask | bit;
              scopeList.push(self._scopeMapping[bit]);
            }
          }
          self._tokenVerified = true;
          self._session.scopeMask = resultMask;
          self._saveSessionData(self._session);
          resultData.status = 'success';
          resultData.scopeList = scopeList;
        }
        if (resultData.status === 'success') {
          return deferred.resolve(resultData);
        } else {
          return deferred.reject(resultData);
        }
      }, self._getXHRErrorHandler(deferred));
    };

    VKProvider.prototype._tokenRequest = function(scopeMask, force) {
      var data;
      data = this._getTokenRequestData(scopeMask, force);
      return this._showAuthPopup(this._tokenUri, data).then(this._afterAuth, this._onError).then(this._getCurrentUserData);
    };

    VKProvider.prototype._prepareRequest = function(url, params) {
      var self;
      self = this;
      params['callback'] = '__';
      url = url + '?' + $.param(params);
      return $.ajax({
        url: url,
        dataType: "text"
      }).then(function(data) {
        var e;
        if (data) {
          data = data.substr(params['callback'].length + 1);
          data = data.substr(0, data.length - 2);
          try {
            data = JSON.parse(data);
            return data;
          } catch (_error) {
            e = _error;
            return null;
          }
        } else {
          return null;
        }
      });
    };

    VKProvider.prototype._showAuthPopup = function(uri, data) {
      var child, deferred, self, url;
      deferred = $.Deferred();
      url = uri + (uri.indexOf('?') !== -1 ? '&' : '?') + $.param(data);
      self = this;
      child = window.open(url, '_blank');
      if (child && window.isCordova === false) {
        self.__popupIntervalId = window.setInterval(function() {
          var tokenData;
          if (child.location.pathname === '/blank.html' && child.location.hostname === 'oauth.vk.com') {
            tokenData = self._parseTokenDataFromHash(child.location.hash.substr(1));
            clearInterval(self.__popupIntervalId);
            child.close();
            deferred.resolve(tokenData);
            return;
          }
          if (child.closed === true) {
            clearInterval(self.__popupIntervalId);
            if (deferred.state() === 'pending') {
              return deferred.reject(null);
            }
          }
        }, 500);
      } else if (child && window.isCordova === true) {
        child.addEventListener('loadstop', function(event) {
          var tokenData;
          if (event.url.indexOf('/blank.html') !== -1 && event.url.indexOf('oauth.vk.com') !== -1) {
            tokenData = self._parseTokenDataFromHash(event.url.split('#')[1]);
            child.close();
            deferred.resolve(tokenData);
          }
        });
        child.addEventListener('exit', function(event) {
          if (deferred.state() === 'pending') {
            return deferred.reject(null);
          }
        });
      } else {
        deferred.reject(null);
      }
      return deferred;
    };

    VKProvider.prototype._parseTokenDataFromHash = function(str) {
      var data, keyVal, pair, pairs, _i, _len;
      data = {};
      pairs = str.split('&');
      for (_i = 0, _len = pairs.length; _i < _len; _i++) {
        pair = pairs[_i];
        keyVal = pair.split('=');
        data[keyVal[0]] = keyVal[1];
      }
      return data;
    };

    return VKProvider;

  })(BaseProvider);
  return VKProvider;
});
