define(['app', 'views/item-view', 'underscore', 'text!templates/airport/popup.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    className: 'military-base-layout',
    required: ['cityId'],
    data: {
      price: {
        pointer: 'airport.price',
        cityId: function() {
          return this.options.cityId;
        }
      }
    },
    events: {
      'click .js-fly': 'fly'
    },
    fly: function(event) {
      this.lockUI();
      return app.server.airport.flyToCity({
        cityId: this.options.cityId,
        success: (function(_this) {
          return function(data) {
            app.translations.fetch();
            app.translations.setLocale(data.locale);
            if (!data.error) {
              return app.screens.modal('common/success-popup', {
                msg: data.setFlash[0].msg || app.tr("Flight went successfully!")
              });
            }
          };
        })(this)
      });
    }
  });
});
