var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['underscore', 'views/item-view', 'text!templates/auto_login.tmpl'], function(_, ItemView, template) {
  var AutoLoginView;
  AutoLoginView = (function(_super) {
    __extends(AutoLoginView, _super);

    function AutoLoginView() {
      this.auth_token = __bind(this.auth_token, this);
      this.auth = __bind(this.auth, this);
      return AutoLoginView.__super__.constructor.apply(this, arguments);
    }

    AutoLoginView.prototype.className = 'sign-in-layout';

    AutoLoginView.prototype.template = template;

    AutoLoginView.prototype.initialize = function(options) {
      AutoLoginView.__super__.initialize.call(this, options);
      return this.autoLogin();
    };

    AutoLoginView.prototype.autoLogin = function() {
      var login, password, _ref;
      if (localStorage.auth != null) {
        _ref = JSON.parse(localStorage.auth), login = _ref.login, password = _ref.password;
        return this.auth(login, password);
      } else if (localStorage.auth_token != null) {
        return this.auth_token();
      } else {
        return this.app.screens.main('login');
      }
    };

    AutoLoginView.prototype.auth = function(login, password) {
      return this.app.server.auth({
        login: login,
        password: password,
        success: (function(_this) {
          return function(data) {
            _this.app.setUserId(data.userId);
            _this.app.vent.trigger('auth:login', {
              user_id: data.userId
            });
            _this.app.screens.main('quests');
            _this.app.menu.init();
            _this.app.shortInfo.init();
            return _this.app.pushNotifications.init();
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            var _ref, _ref1;
            if (data.isConnectionError) {
              _this.app.screens.modal('common/info-popup', {
                msg: _this.app.tr("Failed to connect to server"),
                btnText: _this.app.tr("Try again"),
                callback: function() {
                  return _this.autoLogin();
                }
              });
              return;
            }
            if (((_ref = data.setFlash) != null ? _ref[0].msg : void 0) === "INCORRECT_CLIENT_VERSION") {
              app.screens.main('app_incorrect_version');
              return;
            }
            localStorage.clear();
            _this.app.screens.modal('common/info-popup', {
              msg: ((_ref1 = data.setFlash) != null ? _ref1[0].msg : void 0) || _this.app.tr("Incorrect login or password")
            });
            return _this.app.screens.main('login');
          };
        })(this)
      });
    };

    AutoLoginView.prototype.auth_token = function() {
      return this.app.server.auth_token({
        token: localStorage.auth_token,
        success: (function(_this) {
          return function(data) {
            _this.app.setUserId(data.userId);
            _this.app.vent.trigger('auth:login', {
              user_id: data.userId
            });
            if (_this.options.first_login) {
              _this.app.screens.once('view:ready', function() {
                return app.tutorial.start();
              });
            }
            _this.app.screens.main('quests');
            _this.app.menu.init();
            _this.app.shortInfo.init();
            return _this.app.pushNotifications.init();
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            var _ref;
            localStorage.removeItem('auth_token');
            _this.app.screens.modal('common/info-popup', {
              msg: ((_ref = data.setFlash) != null ? _ref[0].msg : void 0) || _this.app.tr("Session expired")
            });
            return _this.app.screens.main('login');
          };
        })(this)
      });
    };

    return AutoLoginView;

  })(ItemView);
  return AutoLoginView;
});
