define(['app', 'views/item-view', 'underscore', 'text!templates/business.tmpl', 'views/components/currency', 'views/components/clusterize-helper'], function(app, ItemView, _, template, formatCurrency, ClusterizeHelper) {
  return ItemView.extend({
    template: template,
    data: {
      'business': 'business.companyList'
    },
    events: {
      'click .js-goto-company': 'gotoCompany'
    },
    gotoCompany: function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/common', {
        companyId: companyId
      });
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    }
  });
});
