var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/business/add-funds.tmpl'], function(app, ItemView, _, template) {
  var AddFunds;
  AddFunds = (function(_super) {
    __extends(AddFunds, _super);

    function AddFunds() {
      return AddFunds.__super__.constructor.apply(this, arguments);
    }

    AddFunds.prototype.template = template;

    AddFunds.prototype.events = {
      'click .js-apply': 'addFunds',
      'change .js-amount': 'changeAmount'
    };

    AddFunds.prototype.changeAmount = function(event) {
      var amount;
      amount = this.$el.find('.js-amount').val();
      if (isNaN(amount)) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("The amount may consist only of digits")
        });
      } else {
        return this.$el.find('.js-saved-amount').html(amount);
      }
    };

    AddFunds.prototype.addFunds = function(event) {
      var amount, companyId;
      this.lockUI();
      amount = this.$el.find('.js-amount').val();
      companyId = this.options.companyId;
      if (amount === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the sum")
        });
      } else if (isNaN(amount)) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("The amount can only consist of digits")
        });
      } else if (amount <= 0) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("The amount must be greater than zero")
        });
      } else {
        return app.server.business.addFunds({
          companyId: companyId,
          amount: amount,
          success: function(data) {
            if (!data.error) {
              return app.screens.modal('common/success-popup', {
                msg: data.setFlash[0].msg || app.tr("The payment was made!"),
                amount: amount
              }, app.screens.back());
            }
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      }
    };

    return AddFunds;

  })(ItemView);
  return AddFunds;
});
