define(['app', 'views/item-view', 'underscore', 'text!templates/business/change-production.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      'productionList': {
        pointer: 'business.getProductionList',
        companyId: function() {
          return this.options.companyId;
        }
      }
    },
    events: {
      'click .js-set-product': 'setProduction'
    },
    setProduction: function(event) {
      var companyId, itemId;
      this.lockUI();
      itemId = event.currentTarget.getAttribute('data-item-id');
      companyId = this.options.companyId;
      return app.server.business.setProduction({
        companyId: companyId,
        itemId: itemId,
        success: function(data) {
          return app.screens.modal('common/success-popup', {
            msg: data.setFlash[0].msg || app.tr("Changes has been done")
          }, app.screens.back());
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    }
  });
});
