var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/business/common.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var BusinessCommonView;
  BusinessCommonView = (function(_super) {
    __extends(BusinessCommonView, _super);

    function BusinessCommonView() {
      this.initialize = __bind(this.initialize, this);
      return BusinessCommonView.__super__.constructor.apply(this, arguments);
    }

    BusinessCommonView.prototype.template = template;

    BusinessCommonView.prototype.data = {
      companyInfo: {
        pointer: 'business.companyInfo',
        companyId: function() {
          return this.options.companyId;
        }
      },
      info: 'user.info.short',
      effects: {
        pointer: 'business.company.effects',
        companyId: function() {
          return this.options.companyId;
        }
      },
      'business': 'business.corporationList'
    };

    BusinessCommonView.prototype.events = {
      'click .js-goto-employees': 'gotoEmployees',
      'click .js-goto-storage': 'gotoStorage',
      'click .js-add-funds': 'addFunds',
      'click .js-take-funds': 'takeFunds',
      'click .js-begin-work': 'beginWork',
      'click .js-settings': 'settings',
      'click .js-change-prod': 'changeProd',
      'click .c-btn-group__button': 'changeEnergy',
      'click .js-effects': 'showEffects'
    };

    BusinessCommonView.prototype.changeEnergy = function(event) {
      var activeStateClass, btn, buttons, disabledStateClass, el, _i, _len;
      btn = event.currentTarget;
      buttons = btn.parentNode.querySelectorAll('.c-btn-group__button');
      activeStateClass = 'c-btn-group__button--active';
      disabledStateClass = 'c-btn-group__button--disabled';
      if (!$(btn).hasClass(disabledStateClass)) {
        for (_i = 0, _len = buttons.length; _i < _len; _i++) {
          el = buttons[_i];
          if (el.classList) {
            el.classList.remove(activeStateClass);
          } else {
            el.activeStateClass = el.activeStateClass.replace(new RegExp('(^|\\b)' + activeStateClass.split(' ').join('|') + '(\\b|$)', 'gi'), ' ');
          }
        }
        if (btn.classList) {
          return btn.classList.add(activeStateClass);
        } else {
          return btn.activeStateClass += ' ' + activeStateClass;
        }
      }
    };

    BusinessCommonView.prototype.initialize = function(options) {
      this.options = options;
      this.listenTo(app.userEvents, "energy:updated", this.updateEnergyField);
      this.listenTo(app.userEvents, "popup:closed", this.setMaxButton);
      if ((this.options.activeEnergy != null) === false) {
        this.options.activeEnergy = 50;
      }
      this.setMaxButton();
      return BusinessCommonView.__super__.initialize.call(this, this.options);
    };


    /*
    			This method triggers then energy is updated
     */

    BusinessCommonView.prototype.updateEnergyField = function(newEnergy) {
      this.invalidateCacheAndReload();
      return this.buttonsEnergyState();
    };

    BusinessCommonView.prototype.setMaxButton = function() {
      var btn, btnEnergyValue, buttons, maxValue, valuesArr, _i, _len, _results;
      buttons = this.el.querySelectorAll('.c-btn-group--energy .c-btn-group__button');
      valuesArr = this.buttonsEnergyState();
      maxValue = Math.max.apply(this, valuesArr);
      _results = [];
      for (_i = 0, _len = buttons.length; _i < _len; _i++) {
        btn = buttons[_i];
        btnEnergyValue = parseInt(btn.querySelector('.js-energy-value').innerHTML);
        if (btnEnergyValue === maxValue) {
          $(btn).addClass('c-btn-group__button--active');
          _results.push(this.options.activeEnergy = maxValue);
        } else {
          _results.push($(btn).removeClass('c-btn-group__button--active'));
        }
      }
      return _results;
    };


    /*
    			Set state for energy buttons depends on energy value
     */

    BusinessCommonView.prototype.buttonsEnergyState = function() {
      var btn, btnEnergyValue, buttons, experienceEl, redZone, valuesArr, _i, _len, _ref;
      if (((_ref = this._data) != null ? _ref.info : void 0) != null) {
        buttons = this.el.querySelectorAll('.c-btn-group--energy .c-btn-group__button');
        redZone = parseInt(this._data.info.user.User.energy);
        experienceEl = this.el.querySelector('.js-experience-value');
        valuesArr = [0];
        this.maxValue = 0;
        for (_i = 0, _len = buttons.length; _i < _len; _i++) {
          btn = buttons[_i];
          btnEnergyValue = parseInt(btn.querySelector('.js-energy-value').innerHTML);
          if (btnEnergyValue > redZone) {
            $(btn).addClass('c-btn-group__button--disabled');
          } else {
            $(btn).removeClass('c-btn-group__button--disabled');
            valuesArr.push(btnEnergyValue);
            if (btnEnergyValue > this.maxValue) {
              this.maxValue = btnEnergyValue;
            }
          }
        }
        return valuesArr;
      }
    };

    BusinessCommonView.prototype.addFunds = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/add-funds', {
        companyId: companyId
      });
    };

    BusinessCommonView.prototype.takeFunds = function(event) {
      var companyId, withdrawTax;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      withdrawTax = event.currentTarget.getAttribute('data-withdraw-tax');
      return app.screens.dialog('business/withdraw', {
        companyId: companyId,
        withdrawTax: withdrawTax
      });
    };

    BusinessCommonView.prototype.gotoEmployees = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('business/employees', {
        companyId: companyId
      });
    };

    BusinessCommonView.prototype.gotoStorage = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('business/storage', {
        companyId: companyId
      });
    };

    BusinessCommonView.prototype.beginWork = function(event) {
      var companyId, energy;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      energy = parseInt(this.$el.find('.c-btn-group__button--active .js-energy-value').text());
      if ((this.maxValue != null) && this.maxValue < energy) {
        energy = this.maxValue;
        this.setMaxButton();
      }
      this.options.activeEnergy = energy;
      if (isNaN(energy)) {
        app.screens.modal('common/info-popup', {
          msg: app.tr("Not enough energy")
        });
        return;
      }
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Are you sure you want to work in your company?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.work.beginWork({
              companyId: companyId,
              energy: energy,
              success: function(data) {
                var options;
                options = {
                  data: data,
                  repeat: {
                    method: _this.beginWork,
                    context: _this,
                    event: event
                  }
                };
                return app.screens.modal('job/job-done', options);
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    BusinessCommonView.prototype.settings = function(event) {
      var companyId, menu;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      menu = new Backbone.Collection([
        {
          id: 1,
          title: app.tr('Rename company')
        }, {
          id: 2,
          title: app.tr('Transfer company to corporation')
        }
      ]);
      return app.screens.dialog('common/select-dialog', {
        collection: menu,
        callback: (function(_this) {
          return function(itemId) {
            if (itemId === "1") {
              return app.screens.dialog('business/rename-company', {
                companyId: companyId
              });
            } else {
              return app.screens.dialog('business/transfer-company', {
                companyId: companyId
              });
            }
          };
        })(this)
      });
    };

    BusinessCommonView.prototype.changeProd = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/change-production', {
        companyId: companyId
      });
    };

    BusinessCommonView.prototype.onDomRefresh = function() {
      this.buttonsEnergyState();
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    BusinessCommonView.prototype.showEffects = function(event) {
      var companyId;
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('maria/city-effects', {
        companyId: companyId
      });
    };

    return BusinessCommonView;

  })(ItemView);
  return BusinessCommonView;
});
