var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/business/corporations.tmpl', 'views/components/clusterize-helper'], function(app, ItemView, _, template, ClusterizeHelper) {
  var CorporationsView;
  CorporationsView = (function(_super) {
    __extends(CorporationsView, _super);

    function CorporationsView() {
      return CorporationsView.__super__.constructor.apply(this, arguments);
    }

    CorporationsView.prototype.template = template;

    CorporationsView.prototype.data = {
      'business': 'business.corporationList'
    };

    CorporationsView.prototype.events = {
      'click .js-goto-corporation': 'gotoCorporation',
      'click .js-create-corporation': 'createCorporation'
    };

    CorporationsView.prototype.gotoCorporation = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.dialog('business/capital', {
        corporationId: corporationId
      });
    };

    CorporationsView.prototype.createCorporation = function(event) {
      this.lockUI();
      return app.quests.doIfCompleted('social_passport', function() {
        return app.screens.dialog('business/create-corporation');
      });
    };

    CorporationsView.prototype.onDomRefresh = function() {
      return ClusterizeHelper(this.$el);
    };

    return CorporationsView;

  })(ItemView);
  return CorporationsView;
});
