var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/business/create-corporation.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var CreateCorporationView;
  CreateCorporationView = (function(_super) {
    __extends(CreateCorporationView, _super);

    function CreateCorporationView() {
      this.selectAndUploadImage = __bind(this.selectAndUploadImage, this);
      return CreateCorporationView.__super__.constructor.apply(this, arguments);
    }

    CreateCorporationView.prototype.template = template;

    CreateCorporationView.prototype.className = 'no-bg-image';

    CreateCorporationView.prototype.events = {
      'click .js-create-company': 'createCompany',
      'click .js-select-image': 'selectAndUploadImage'
    };

    CreateCorporationView.prototype.data = {
      business: 'business'
    };

    CreateCorporationView.prototype.onDomRefresh = function() {
      var _ref;
      [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
      if (((_ref = this._data) != null ? _ref.business : void 0) != null) {
        return $('#party-logo').data("src", app.config.serverURLProtocol + '://' + app.config.serverURL + '/attachments/corporations/' + this._data.business.new_corporation_info.default_picture);
      }
    };

    CreateCorporationView.prototype.createCompany = function(event) {
      var logo, name_en, name_ru;
      this.lockUI();
      logo = this.$el.find('#party-logo').data('src');
      name_ru = this.$el.find('.name_ru').val();
      name_en = this.$el.find('.name_en').val();
      if (name_ru === "" || name_en === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("All fields are required")
        });
      } else {
        return app.server.business.createCorporation({
          name_ru: name_ru,
          name_en: name_en,
          logo: logo,
          success: function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Corporation was created")
            }, app.screens.back());
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      }
    };

    CreateCorporationView.prototype.selectAndUploadImage = function(event) {
      var uploadPhoto;
      uploadPhoto = function(imageURI) {
        var ft, options, to;
        options = new FileUploadOptions;
        options.fileKey = 'file';
        options.fileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);
        options.mimeType = 'image/jpeg';
        options.chunkedMode = false;
        to = encodeURI(app.config.serverURLProtocol + '://' + app.config.serverURL + '/corporations/upload.json');
        ft = new FileTransfer;
        return ft.upload(imageURI, to, function(r) {
          var json;
          json = JSON.parse(r.response);
          if ((json != null ? json.image : void 0) != null) {
            $('#party-logo').attr('src', app.config.serverURLProtocol + '://' + app.config.serverURL + '/attachments/corporations/' + json.image);
            return $('#party-logo').data("src", app.config.serverURLProtocol + '://' + app.config.serverURL + '/attachments/corporations/' + json.image);
          }
        }, function(error) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("Something went wrong")
          });
        }, options);
      };
      return navigator.camera.getPicture(uploadPhoto, (function(message) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Image is not chosen")
        });
      }), {
        quality: 50,
        destinationType: navigator.camera.DestinationType.FILE_URI,
        sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY
      });
    };

    return CreateCorporationView;

  })(ItemView);
  return CreateCorporationView;
});
