define(['app', 'views/item-view', 'underscore', 'text!templates/business/employees-list.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      сompanyWorkersList: {
        pointer: 'business.сompanyWorkersList',
        companyId: function() {
          return this.options.companyId;
        }
      }
    },
    events: {
      'click .js-delete-worker': 'deleteWorker',
      'click .js-delete-foreign-worker': 'deleteForeignWorker'
    },
    deleteWorker: function(event) {
      this.lockUI();
      return app.server.business.deleteWorker({
        workerId: event.currentTarget.getAttribute('data-worker-id'),
        success: function(data) {
          return app.screens.modal('common/success-popup', {
            msg: data.setFlash[0].msg || app.tr("Worker fired")
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    },
    deleteForeignWorker: function(event) {
      var companyId;
      this.lockUI();
      companyId = this.options.companyId;
      return app.server.business.deleteForeignWorker({
        companyId: companyId,
        workerId: event.currentTarget.getAttribute('data-foreign-worker-type-id'),
        quantity: 1,
        success: function(data) {
          return app.screens.modal('common/success-popup', {
            msg: data.setFlash[0].msg || app.tr("Worker fired")
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    }
  });
});
