var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/business/hiring-migrants.tmpl'], function(app, ItemView, _, template) {
  var HiringMigrantsView;
  HiringMigrantsView = (function(_super) {
    __extends(HiringMigrantsView, _super);

    function HiringMigrantsView() {
      return HiringMigrantsView.__super__.constructor.apply(this, arguments);
    }

    HiringMigrantsView.prototype.template = template;

    HiringMigrantsView.prototype.data = {
      companyForeignWorkers: {
        pointer: 'business.companyForeignWorkers',
        companyId: function() {
          return this.options.companyId;
        }
      }
    };

    HiringMigrantsView.prototype.events = {
      'click .js-hire-worker': 'hireForeignWorker'
    };

    HiringMigrantsView.prototype.hireForeignWorker = function(event) {
      this.lockUI();
      return app.server.business.hireForeignWorkers({
        workerId: event.currentTarget.getAttribute('data-worker-id'),
        companyId: event.currentTarget.getAttribute('data-company-id'),
        quantity: 1,
        success: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("The employee is hired")
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };


    /*
    			Center cloud
     */

    HiringMigrantsView.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    HiringMigrantsView.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return HiringMigrantsView;

  })(ItemView);
  return HiringMigrantsView;
});
