define(['app', 'views/item-view', 'underscore', 'text!templates/business/initiative-manager-2.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'submit .c-search-bar form': 'managerSearch',
      'click .js-set-manager': 'setManager'
    },
    managerSearch: function(event) {
      event.preventDefault();
      return app.server.business.searchManager({
        companyId: this.options.companyId,
        name: this.$el.find('.c-search-bar__input').val(),
        success: (function(_this) {
          return function(data) {
            _this.options.users = data.users;
            return _this.reload();
          };
        })(this),
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data || app.tr("Something went wrong")
          });
        }
      });
    },
    setManager: function(event) {
      var companyId, managerId;
      this.lockUI();
      companyId = this.options.companyId;
      managerId = event.currentTarget.getAttribute('data-manager-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Are you sure you want assign a new manager?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.business.setManager({
              companyId: companyId,
              managerId: managerId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Appointed new manager")
                }, app.screens.back());
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    }
  });
});
