var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/common/level-up-first-popup.tmpl'], function(app, ItemView, _, template) {
  var LevelUpFirstPopup;
  LevelUpFirstPopup = (function(_super) {
    __extends(LevelUpFirstPopup, _super);

    function LevelUpFirstPopup() {
      return LevelUpFirstPopup.__super__.constructor.apply(this, arguments);
    }

    LevelUpFirstPopup.prototype.template = template;

    LevelUpFirstPopup.prototype.data = {
      bonuses: 'user.levelUp'
    };

    LevelUpFirstPopup.prototype.events = {
      'click .js-apply': 'selectAdditionBonuses',
      'click .js-bonus-info': 'showBonusInfo',
      'click .js-opened-info': 'showOpenedInfo'
    };

    LevelUpFirstPopup.prototype.selectAdditionBonuses = function(event) {
      this.lockUI();
      app.screens.back();
      if (Object.keys(this._data.bonuses.additionBonuses).length > 0) {
        return app.screens.modal('common/level-up-addition-bonuses');
      }
    };

    LevelUpFirstPopup.prototype.showOpenedInfo = function(event) {
      var openedId;
      this.lockUI();
      openedId = parseInt(event.currentTarget.getAttribute('data-opened-id'));
      return app.screens.modal('bonus/opened-info', {
        bonusId: openedId
      });
    };

    LevelUpFirstPopup.prototype.showBonusInfo = function(event) {
      var bonusId;
      this.lockUI();
      bonusId = parseInt(event.currentTarget.getAttribute('data-bonus-id'));
      return app.screens.modal('bonus/bonus-info', {
        bonusId: bonusId
      });
    };

    LevelUpFirstPopup.prototype.onDomRefresh = function() {
      return this.$el.find('.c-popup__height').css('max-height', $('.js-current-screen').height() - 300);
    };

    return LevelUpFirstPopup;

  })(ItemView);
  return LevelUpFirstPopup;
});
