define([], function() {
  var Strings;
  Strings = {};
  Strings.tr = function(text, locale) {
    if (locale == null) {
      locale = null;
    }
    return app.tr(text, locale);
  };
  Strings.avatar = function(str) {
    var avatar;
    avatar = str != null ? String(str).split('.')[0] + '.png' : '0.png';
    return "./images/avatars/" + avatar;
  };
  Strings.minAvatar = function(str) {
    var avatarMin;
    avatarMin = str != null ? String(str).split('.')[0].split('_')[0] + '_avatar.png' : '0_min.png';
    return "./images/avatars/" + avatarMin;
  };
  Strings.truncate = function(str, length) {
    if (str.length > length) {
      return str.substr(0, length - 1) + '&#133';
    }
    return str;
  };
  Strings.levenshtein = function(s1, s2, ignoreCase) {
    var a, b, buf, c, ch, cost, cutHalf, flip, i, ii, ii2, insertCost, j, l1, l2, minCost, minD, minI, removeCost, replaceCost, _i, _j, _k;
    ignoreCase = ignoreCase || false;
    l1 = s1.length;
    l2 = s2.length;
    replaceCost = 1;
    insertCost = 1;
    removeCost = 1;
    cutHalf = flip = Math.max(l1, l2);
    minCost = Math.min(removeCost, insertCost, replaceCost);
    minD = Math.max(minCost, (l1 - l2) * removeCost);
    minI = Math.max(minCost, (l2 - l1) * insertCost);
    buf = new Array((cutHalf * 2) - 1);
    for (i = _i = 0; 0 <= l2 ? _i <= l2 : _i >= l2; i = 0 <= l2 ? ++_i : --_i) {
      buf[i] = i * minD;
    }
    for (i = _j = 0; 0 <= l1 ? _j < l1 : _j > l1; i = 0 <= l1 ? ++_j : --_j) {
      ch = s1[i];
      buf[flip] = (i + 1) * minI;
      ii = flip;
      ii2 = cutHalf - flip;
      for (j = _k = 0; 0 <= l2 ? _k < l2 : _k > l2; j = 0 <= l2 ? ++_k : --_k) {
        if (ch === s2[j] || (ignoreCase && ch.toLowerCase() === s2[j].toLowerCase())) {
          cost = 0;
        } else {
          cost = replaceCost;
        }
        a = buf[ii2 + 1] + removeCost;
        b = buf[ii] + insertCost;
        c = buf[ii2] + cost;
        buf[ii + 1] = Math.min(a, b, c);
        ++ii;
        ++ii2;
      }
      flip = cutHalf - flip;
    }
    return buf[l2 + cutHalf - flip];
  };
  Strings.matchName = function(orignal, test, maxDiff) {
    var diff;
    maxDiff = maxDiff || 0;
    if (test.length < orignal.length) {
      orignal = orignal.substr(0, test.length);
    }
    diff = this.levenshtein(orignal, test, true);
    return diff <= maxDiff && (test.length > diff * 2);
  };
  Strings.replace = function(params, input) {
    var key, result, val;
    result = input;
    for (key in params) {
      val = params[key];
      result = result.replace(key, val, 'g');
    }
    return result;
  };
  return Strings;
});
