var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/business/common.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var CorporationCommonView;
  CorporationCommonView = (function(_super) {
    __extends(CorporationCommonView, _super);

    function CorporationCommonView() {
      this.initialize = __bind(this.initialize, this);
      return CorporationCommonView.__super__.constructor.apply(this, arguments);
    }

    CorporationCommonView.prototype.template = template;

    CorporationCommonView.prototype.data = {
      companyInfo: {
        pointer: 'business.companyInfo',
        companyId: function() {
          return this.options.companyId;
        }
      },
      info: 'user.info.short',
      effects: {
        pointer: 'business.company.effects',
        companyId: function() {
          return this.options.companyId;
        }
      }
    };

    CorporationCommonView.prototype.events = {
      'click .js-goto-employees': 'gotoEmployees',
      'click .js-goto-storage': 'gotoStorage',
      'click .js-add-funds': 'addFunds',
      'click .js-take-funds': 'takeFunds',
      'click .js-begin-work': 'beginWork',
      'click .js-settings': 'settings',
      'click .js-change-prod': 'changeProd',
      'click .c-btn-group__button': 'changeEnergy',
      'click .js-effects': 'showEffects'
    };

    CorporationCommonView.prototype.initialize = function(options) {
      this.options = options;
      this.options.activeEnergy = 50;
      return CorporationCommonView.__super__.initialize.call(this, this.options);
    };

    CorporationCommonView.prototype.changeEnergy = function(event) {
      var activeStateClass, btn, buttons, el, _i, _len;
      btn = event.currentTarget;
      buttons = btn.parentNode.querySelectorAll('.c-btn-group__button');
      activeStateClass = 'c-btn-group__button--active';
      for (_i = 0, _len = buttons.length; _i < _len; _i++) {
        el = buttons[_i];
        if (el.classList) {
          el.classList.remove(activeStateClass);
        } else {
          el.activeStateClass = el.activeStateClass.replace(new RegExp('(^|\\b)' + activeStateClass.split(' ').join('|') + '(\\b|$)', 'gi'), ' ');
        }
      }
      if (btn.classList) {
        return btn.classList.add(activeStateClass);
      } else {
        return btn.activeStateClass += ' ' + activeStateClass;
      }
    };

    CorporationCommonView.prototype.addFunds = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('corporative_companies/add-funds', {
        companyId: companyId
      });
    };

    CorporationCommonView.prototype.takeFunds = function(event) {
      var companyId, withdrawTax;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      withdrawTax = event.currentTarget.getAttribute('data-withdraw-tax');
      return app.screens.dialog('corporative_companies/withdraw', {
        companyId: companyId,
        withdrawTax: withdrawTax
      });
    };

    CorporationCommonView.prototype.gotoEmployees = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('corporative_companies/employees', {
        companyId: companyId
      });
    };

    CorporationCommonView.prototype.gotoStorage = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('corporative_companies/storage', {
        companyId: companyId
      });
    };

    CorporationCommonView.prototype.beginWork = function(event) {
      var companyId, energy;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      energy = parseInt(this.el.querySelector('.c-btn-group__button--active .js-energy-value').innerHTML);
      this.options.activeEnergy = energy;
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr(' Are you shore you want to work in your company?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.work.beginWork({
              companyId: companyId,
              energy: energy,
              success: function(data) {
                var options;
                options = {
                  data: data,
                  repeat: {
                    method: _this.beginWork,
                    context: _this,
                    event: event
                  }
                };
                return app.screens.modal('job/job-done', options);
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    CorporationCommonView.prototype.settings = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/settings', {
        companyId: companyId
      });
    };

    CorporationCommonView.prototype.changeProd = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/change-production', {
        companyId: companyId
      });
    };

    CorporationCommonView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    CorporationCommonView.prototype.showEffects = function(event) {
      var companyId;
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('maria/city-effects', {
        companyId: companyId
      });
    };

    return CorporationCommonView;

  })(ItemView);
  return CorporationCommonView;
});
