define(['app', 'views/item-view', 'underscore', 'text!templates/events/bb.tmpl', 'views/components/currency', 'jquery.countdown'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    className: 'events bgc-violet bb',
    data: {
      bb: {
        pointer: 'events.bb'
      }
    },
    events: {
      'click .js-kick': 'clickKick'
    },
    clickKick: function(event) {
      var bbId, canFight, message;
      canFight = app.isAvailable(this._data.bb.currentLevel, 'UserBigFight');
      if (!canFight) {
        message = app.tr('You can participate from level') + ' ' + app.availableFrom('UserBigFight');
        app.screens.modal('common/info-popup', {
          msg: message
        });
        return;
      }
      this.lockUI();
      if ((this.kicked != null) && this.kicked) {
        return;
      } else {
        this.kicked = true;
      }
      bbId = event.currentTarget.getAttribute('data-bb-id');
      return app.server.events.bb.kick({
        bbId: bbId,
        success: (function(_this) {
          return function(data) {
            var options;
            options = {
              data: data,
              repeat: {
                method: _this.clickKick,
                context: _this,
                event: event
              }
            };
            _this.kicked = false;
            return app.screens.modal('events/bb-popup', options);
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            _this.kicked = false;
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg
            });
          };
        })(this)
      });
    },
    onDataLoadError: function(data) {
      return this.app.screens.modal('events/low-level-popup', {
        msg: app.tr("You have insufficient level")
      });
    },

    /*
    			Center cloud
     */
    centerCloud: function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    },
    onDomRefresh: function() {
      var date, showedTime, time, _ref;
      this.centerCloud();
      [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
      if (((_ref = this._data) != null ? _ref.bb : void 0) != null) {
        time = (new Date()).getTime();
        if (this._data.bb.bigFight.BigFight.is_announce) {
          showedTime = this._data.bb.bigFight.BigFight.time_to_start;
        } else {
          showedTime = this._data.bb.bigFight.BigFight.time_to_end;
        }
        date = new Date(time + showedTime * 1000);
        return $('div#bb-countdown').countdown(date, function(event) {
          return $(this).text(event.strftime('%D %H:%M:%S'));
        });
      } else {
        return $('div#bb-countdown').text('');
      }
    }
  });
});
