define(['app', 'views/item-view', 'underscore', 'text!templates/events/ot.tmpl', 'views/components/currency', 'jquery.countdown'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: _.template(template),
    name: 'events/ot',
    className: 'events ot',
    data: {
      ot: {
        pointer: 'events.ot'
      }
    },
    events: {
      'click .btn-score': 'clickKick'
    },
    clickKick: function(event) {
      var name, teamId;
      this.lockUI();
      if ((this.kicked != null) && this.kicked) {
        return;
      } else {
        this.kicked = true;
      }
      name = $(event.currentTarget).closest('.js-variant').find('.city-name').text();
      teamId = event.currentTarget.getAttribute('data-team-id');
      return app.server.events.ot.kick({
        teamId: teamId,
        success: (function(_this) {
          return function(data) {
            var options;
            _this.kicked = false;
            options = {
              data: data,
              name: name,
              repeat: {
                method: _this.clickKick,
                context: _this,
                event: event
              }
            };
            return app.screens.modal('events/ot-popup', options);
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            _this.kicked = false;
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg
            });
          };
        })(this)
      });
    },
    onDataLoadError: function() {
      return this.app.screens.modal('events/low-level-popup', {
        msg: app.tr("You have insufficient level")
      });
    },

    /*
    			Center cloud
     */
    centerCloud: function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    },
    onDomRefresh: function() {
      var date, showedTime, time, _ref;
      this.centerCloud();
      [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
      if (((_ref = this._data) != null ? _ref.ot : void 0) != null) {
        time = (new Date()).getTime();
        if (this._data.ot.PrestigeWar.is_announce) {
          showedTime = this._data.ot.PrestigeWar.time_to_start;
        } else {
          showedTime = this._data.ot.PrestigeWar.time_to_end;
        }
        date = new Date(time + showedTime * 1000);
        return $('div#ot-countdown').countdown(date, function(event) {
          return $(this).text(event.strftime('%D %H:%M:%S'));
        });
      } else {
        return $('div#ot-countdown').text('');
      }
    }
  });
});
