var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/feed.tmpl', 'views/components/clusterize-helper'], function(app, ItemView, _, template, ClusterizeHelper) {
  var NewsFeedView;
  NewsFeedView = (function(_super) {
    __extends(NewsFeedView, _super);

    function NewsFeedView() {
      this.updateMessagesNewCount = __bind(this.updateMessagesNewCount, this);
      return NewsFeedView.__super__.constructor.apply(this, arguments);
    }

    NewsFeedView.prototype.template = template;

    NewsFeedView.prototype.defaultTab = 'news';

    NewsFeedView.prototype.data = {
      feed: {
        pointer: 'groupFeed',
        feedGroup: function() {
          return this.options.group || this.defaultTab;
        }
      }
    };

    NewsFeedView.prototype.events = {
      'click .js-feed': 'feedClick',
      'click .js-feed-tab': 'onFeedTabClick'
    };

    NewsFeedView.prototype.tabs = [
      {
        group: 'news',
        title: app.tr('News')
      }, {
        group: 'important',
        title: app.tr('Important')
      }, {
        group: 'personal',
        title: app.tr('Private')
      }, {
        group: 'party',
        title: app.tr('Party')
      }, {
        group: 'business',
        title: app.tr('Business')
      }, {
        group: 'city',
        title: app.tr('City')
      }
    ];

    NewsFeedView.prototype.addListeners = function() {
      NewsFeedView.__super__.addListeners.apply(this, arguments);
      return app.on('User.Feed.newMessageCount.update', this.updateMessagesNewCount);
    };

    NewsFeedView.prototype.updateMessagesNewCount = function(args) {
      if (!this._data.feed) {
        return;
      }
      this._data.feed.feedNewMessagesCount = args.data.body.value;
      if (args.data.body.value > 0) {
        this.$el.find('.message_count').show();
      } else {
        this.$el.find('.message_count').hide();
      }
      return this.$el.find('.message_count').html(args.data.body.value);
    };

    NewsFeedView.prototype.feedClick = function(event) {
      var feedGroup, postId;
      this.lockUI();
      feedGroup = event.currentTarget.getAttribute('data-group');
      if (feedGroup === 'newspaper_city' || feedGroup === 'newspaper_global' || feedGroup === 'newspaper_subscription') {
        postId = event.currentTarget.getAttribute('data-info');
        if (postId !== "") {
          return app.screens.dialog('news/article', {
            postId: postId
          });
        }
      }
    };

    NewsFeedView.prototype.serializeData = function() {
      var data, tab, tabs, _i, _len;
      data = NewsFeedView.__super__.serializeData.apply(this, arguments);
      tabs = this.tabs;
      if (data.feed && data.feed.counters) {
        for (_i = 0, _len = tabs.length; _i < _len; _i++) {
          tab = tabs[_i];
          tab.eventsCount = data.feed.counters[tab.group] || 0;
        }
      }
      data.tabs = tabs;
      data.activeTab = this.options.group || this.defaultTab;
      return data;
    };

    NewsFeedView.prototype.onDomRefresh = function() {
      return ClusterizeHelper(this.$el);
    };

    NewsFeedView.prototype.onFeedTabClick = function(event) {
      var group;
      group = event.currentTarget.dataset.group;
      if (group) {
        return app.screens.tab('feed', {
          group: group
        });
      }
    };

    return NewsFeedView;

  })(ItemView);
  return NewsFeedView;
});
