var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/friends/base', 'text!templates/friends.tmpl', 'text!templates/friends/blocks/friends-list.tmpl'], function(app, FriendsBaseView, template, listTemplate) {
  var FriendsView;
  FriendsView = (function(_super) {
    __extends(FriendsView, _super);

    function FriendsView() {
      return FriendsView.__super__.constructor.apply(this, arguments);
    }

    FriendsView.prototype.className = 'friends-layout';

    FriendsView.prototype.template = template;

    FriendsView.prototype.listTemplate = listTemplate;

    FriendsView.prototype.data = {
      list: 'friends.list'
    };

    FriendsView.prototype.events = {
      'change .js-name': 'onNameChange',
      'click .js-remove': 'onRemoveClick',
      'click .js-profile': 'onProfileClick'
    };

    FriendsView.prototype._groups = [
      {
        name: app.tr('Online'),
        fn: function(n) {
          return n && n.User.online;
        }
      }, {
        name: app.tr('Offline'),
        fn: function(n) {
          return n && !n.User.online;
        }
      }
    ];

    FriendsView.prototype.onProfileClick = function(event) {
      var hasProfile, userId;
      this.lockUI();
      userId = event.currentTarget.getAttribute('data-id');
      hasProfile = event.currentTarget.getAttribute('data-has-profile') === 'true';
      if (hasProfile) {
        return app.screens.dialog('users/profile', {
          userId: userId
        });
      }
    };

    FriendsView.prototype.onRemoveClick = function(event) {
      var friendId, self;
      event.stopPropagation();
      self = this;
      app.showLoader();
      self.lockUI();
      friendId = event.currentTarget.getAttribute('data-id');
      return app.server.friends.remove_friend({
        friendId: friendId,
        success: function(data) {
          var _ref;
          self.unlockUI();
          app.hideLoader();
          if (!data.error) {
            self._removeFriend(friendId);
            self._renderList();
          }
          return app.screens.modal('common/info-popup', {
            msg: (data != null ? (_ref = data.setFlash[0]) != null ? _ref.msg : void 0 : void 0) || app.tr('Server error')
          });
        },
        error: function(data) {
          var _ref;
          self.unlockUI();
          app.hideLoader();
          return app.screens.modal('common/info-popup', {
            msg: (data != null ? (_ref = data.setFlash[0]) != null ? _ref.msg : void 0 : void 0) || app.tr('Server error')
          });
        }
      });
    };

    FriendsView.prototype._removeFriend = function(id) {
      var friend, _i, _len, _ref;
      id = Number(id);
      _ref = this._data.list.friends;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        friend = _ref[_i];
        if (friend.User.id === id) {
          this._data.list.friends.splice(_i, 1);
          return;
        }
      }
    };

    FriendsView.prototype.preprocessData = function(data) {
      if (!data.list) {
        return data;
      }
      data.requests_count = data.list.requests_count;
      data.totalCount = data.list.friends.length;
      data.groups = this._groupList(this._filterList(data.list.friends));
      return data;
    };

    return FriendsView;

  })(FriendsBaseView);
  return FriendsView;
});
