var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'marionette', 'views/item-view', 'underscore', 'views/components/strings-helper'], function(app, Marionette, ItemView, _, Strings) {
  var FriendsBaseView;
  FriendsBaseView = (function(_super) {
    __extends(FriendsBaseView, _super);

    function FriendsBaseView() {
      return FriendsBaseView.__super__.constructor.apply(this, arguments);
    }

    FriendsBaseView.prototype._name = null;

    FriendsBaseView.prototype.initialize = function() {
      var self;
      FriendsBaseView.__super__.initialize.apply(this, arguments);
      self = this;
      self.listTemplate = _.template(self.listTemplate);
      return self.on('render', function() {
        return self._renderList();
      });
    };

    FriendsBaseView.prototype.onNameChange = function(event) {
      var name;
      name = event.currentTarget.value;
      name = name.replace(/[^\w\.]/g, '').trim();
      event.currentTarget.value = name;
      if (name.length > 2 || !name) {
        this._name = name;
        return this._renderList();
      }
    };

    FriendsBaseView.prototype._filterList = function(list) {
      var filteredList, friend, _i, _len;
      if (this._name && this._name.length > 2) {
        filteredList = [];
        for (_i = 0, _len = list.length; _i < _len; _i++) {
          friend = list[_i];
          if (Strings.matchName(friend.User.username, this._name, 1)) {
            filteredList.push(friend);
          }
        }
        return filteredList;
      } else {
        return list;
      }
    };

    FriendsBaseView.prototype._groupList = function(list) {
      var group, groups, item, _i, _j, _k, _len, _len1, _len2, _ref, _ref1;
      if (!this._groups) {
        return {
          "default": list
        };
      }
      groups = {};
      _ref = this._groups;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        group = _ref[_i];
        groups[group.name] = [];
      }
      if (!list || !list.length) {
        return groups;
      }
      for (_j = 0, _len1 = list.length; _j < _len1; _j++) {
        item = list[_j];
        _ref1 = this._groups;
        for (_k = 0, _len2 = _ref1.length; _k < _len2; _k++) {
          group = _ref1[_k];
          if (group.fn(item)) {
            groups[group.name].push(item);
          }
        }
      }
      return groups;
    };

    FriendsBaseView.prototype._renderList = function() {
      var data, listContainer;
      listContainer = this.el.querySelector('#list-container');
      if (!listContainer) {
        return;
      }
      data = this.mixinTemplateHelpers(this.serializeData({}));
      return listContainer.innerHTML = Marionette.Renderer.render(this.listTemplate, data);
    };

    return FriendsBaseView;

  })(ItemView);
  return FriendsBaseView;
});
