define(['app', 'views/item-view', 'underscore', 'text!templates/hospital.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    className: 'hospital-layout',
    template: template,
    data: {
      service: 'hospital.service'
    },
    events: {
      'click .js-heal-full-hp': 'healFullHP',
      'click .js-heal-trauma': 'healTrauma'
    },
    healFullHP: function(event) {
      this.lockUI();
      return app.server.hospital.service.healFullHP({
        success: function(data) {
          var _ref;
          app.vent.trigger('hospital:full_healed', {
            data: data
          });
          return app.screens.modal('common/info-popup', {
            msg: ((_ref = data.setFlash) != null ? _ref[0].msg : void 0) || app.tr("You have been cured")
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    },
    healTrauma: function(event) {
      var traumaId;
      this.lockUI();
      traumaId = event.currentTarget.getAttribute('data-trauma-id');
      return app.server.hospital.service.healTrauma({
        traumaId: traumaId,
        success: function(data) {
          var _ref;
          app.vent.trigger('hospital:trauma_healed', {
            data: data
          });
          return app.screens.modal('common/info-popup', {
            msg: ((_ref = data.setFlash) != null ? _ref[0].msg : void 0) || app.tr("You have been cured")
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    }
  });
});
