var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['underscore', 'jquery', 'marionette', 'app', 'moment', 'views/components/vertical-swipe', 'velocity-ui', 'views/components/strings-helper', 'views/components/tabs-scroller', 'bounce'], function(_, $, Marionette, app, moment, VerticalSwipe, velocity, StringsHelper, TabsScroller, Bounce) {
  var VCItemView;
  VCItemView = (function(_super) {
    __extends(VCItemView, _super);

    function VCItemView() {
      this.onDataLoaded = __bind(this.onDataLoaded, this);
      this.render = __bind(this.render, this);
      this.initialize = __bind(this.initialize, this);
      this.templateHelpers = __bind(this.templateHelpers, this);
      return VCItemView.__super__.constructor.apply(this, arguments);
    }

    VCItemView.prototype.lockedUI = false;

    VCItemView.prototype._isReady = false;

    VCItemView.prototype._isLoadCompleted = false;

    VCItemView.prototype.showOnlyAfterLoadData = false;

    VCItemView.prototype.templateHelpers = function() {
      return {
        moment: moment,
        tr: StringsHelper.tr,
        minAvatar: StringsHelper.minAvatar,
        avatar: StringsHelper.avatar,
        truncate: StringsHelper.truncate
      };
    };

    VCItemView.prototype.initialize = function(options) {
      var err, oldOnDomRefresh;
      this.options = options;
      this.app = app;
      if (this.options.id != null) {
        this.id = this.options.id;
      }
      if (this.options.type != null) {
        this.type = this.options.type;
      }
      this.onBack = this.options.onBack;
      this.onClose = this.options.onClose;
      if (typeof this.template !== 'function') {
        if (this.app.config.debug) {
          try {
            this.template = _.template(this.template);
          } catch (_error) {
            err = _error;
            if (app.config.debug) {
              console.error("Error: template initialization error in " + this.id + " screen");
              console.error(err);
            }
          }
        } else {
          this.template = _.template(this.template);
        }
      }
      this.events = _.extend(this.events, VCItemView.prototype.events);
      this.addListeners();
      if (typeof this.required === "function" ? this.required(this.app.config.debug) : void 0) {
        this.checkRequired();
      }
      if (this.data != null) {
        this.loadData();
      }
      oldOnDomRefresh = this.onDomRefresh;
      this.on('render', this._triggerReady);
      this.on('dom:refresh', this.canvasInnerLayout);
      this.listenTo(app.vent, 'swipe:reload', (function(_this) {
        return function() {
          if (app.screens.current.cid === _this.cid) {
            return _this.reload();
          }
        };
      })(this));
      this.sendGAView();
    };

    VCItemView.prototype.render = function() {
      if (this.showOnlyAfterLoadData && (this.data != null)) {
        if (this._isLoadCompleted) {
          return VCItemView.__super__.render.apply(this, arguments);
        }
      } else {
        return VCItemView.__super__.render.apply(this, arguments);
      }
    };

    VCItemView.prototype._triggerReady = function() {
      if (!this._isReady && (!this.data || this._isLoadCompleted)) {
        return this.trigger('ready', this);
      }
    };

    VCItemView.prototype.addListeners = function() {
      return this.on('render', this.unlockUI);
    };

    VCItemView.prototype.showDataLoadProgressBar = function() {
      return app.showLoader();
    };

    VCItemView.prototype.hideDataLoadProgressBar = function() {
      return app.hideLoader();
    };

    VCItemView.prototype.reload = function(callback) {
      if (this.app.config.debug) {
        console.log("Info: reload " + this.id + " screen due to files change");
      }
      if (this.data != null) {
        return this.loadData();
      } else {
        return this.render();
      }
    };

    VCItemView.prototype.checkDataCacheAndReload = function() {
      var key, pointer, value, _ref, _ref1;
      if (this.data != null) {
        _ref = this.data;
        for (key in _ref) {
          value = _ref[key];
          pointer = (_ref1 = value.pointer) != null ? _ref1 : value;
          if ((this.app.server[pointer] != null) && !this.app.server[pointer].cache.isValid()) {
            this.loadData();
            if (this.app.config.debug) {
              console.log("Info: reload screen " + this.id + " due to data invalidation");
            }
            return;
          }
        }
      }
    };

    VCItemView.prototype.invalidateCacheAndReload = function() {
      var key, pointer, value, _ref, _ref1;
      if (this.data != null) {
        _ref = this.data;
        for (key in _ref) {
          value = _ref[key];
          pointer = (_ref1 = value.pointer) != null ? _ref1 : value;
          this.app.server[pointer].cache.invalidate();
        }
        if (this.app.config.debug) {
          console.log("Info: invalidate data and reload screen " + this.id);
        }
        this.loadData();
      }
    };

    VCItemView.prototype.events = {

      /*
      				Used to open screens/dialogs without arguments, just add .js-goto-main/dialog/modal/tab class to element
      				and specify data-screen-id attribute. Usefull for tabs.
       */
      'click .js-goto-main': function(event) {
        var screenId;
        app.showLoader();
        this.lockUI();
        screenId = event.currentTarget.getAttribute('data-screen-id');
        return app.screens.main(screenId);
      },
      'click .js-goto-screen': function(event) {
        var options, screenId;
        if (this.app.config.debug) {
          console.error("Error: .js-goto-screen is deprecated, use .js-goto-main or .js-goto-tab instead");
        }
        screenId = event.currentTarget.getAttribute('data-screen-id');
        options = event.currentTarget.getAttribute('data-screen-options');
        if (options != null) {
          return app.screens.main(screenId, {
            screen_options: options
          });
        } else {
          return app.screens.main(screenId);
        }
      },
      'click .js-goto-tab': function(event) {
        var options, screenId;
        this.lockUI();
        screenId = event.currentTarget.getAttribute('data-screen-id');
        options = event.currentTarget.getAttribute('data-screen-options');
        if (options != null) {
          return app.screens.tab(screenId, {
            screen_options: options
          });
        } else {
          return app.screens.tab(screenId);
        }
      },
      'click .js-goto-dialog': function(event) {
        var options, screenId;
        this.lockUI();
        screenId = event.currentTarget.getAttribute('data-screen-id');
        options = event.currentTarget.getAttribute('data-screen-options');
        if (options != null) {
          return app.screens.dialog(screenId, {
            screen_options: options
          });
        } else {
          return app.screens.dialog(screenId);
        }
      },
      'click .js-goto-modal': function(event) {
        var options, screenId;
        this.lockUI();
        screenId = event.currentTarget.getAttribute('data-screen-id');
        options = event.currentTarget.getAttribute('data-screen-options');
        if (options != null) {
          return app.screens.modal(screenId, {
            screen_options: options
          });
        } else {
          return app.screens.modal(screenId);
        }
      },

      /*
      				Used for back buttons in screens to go back or open menu.
      				If screen is dialog(opened with app.screens.dialog()) - it opens previous screens in screens stack.
      				If screen is main(opened with app.screens.main()) - it opens menu.
       */
      'click .js-close': function(event) {
        this.lockUI();
        if (this.type === 'dialog' || this.type === 'modal') {
          app.screens.close();
          if (this.options.onClose != null) {
            return this.options.onClose();
          }
        }
      },
      'click .js-back': 'jsBack',
      'click .js-repeat': function(event) {
        this.jsBack(event);
        this.lockUI();
        return this.options.repeat.method.call(this.options.repeat.context, this.options.repeat.event);
      },
      'click .js-open-menu': function() {
        if (this.app.config.debug) {
          console.log("Warning: .js-open-menu is deprecated, use .js-back instead in " + this.id + " template");
        }
        return app.menu.open();
      }
    };

    VCItemView.prototype.hideElement = function($scrollContainer, $element, className) {
      $('.js-current-screen').addClass(className);
      return $element.velocity({
        translateY: '-100%'
      }, 500);
    };

    VCItemView.prototype.showElement = function($scrollContainer, $element, className) {
      if ($scrollContainer.scrollTop() < 50) {
        $element.velocity({
          translateY: 'none'
        }, 500);
        return $('.js-current-screen').removeClass(className);
      }
    };


    /*
    			Hide and show element with soecific class on swipe
     */

    VCItemView.prototype.smartHideElement = function() {
      var $element, $scrollContainer, className;
      $scrollContainer = $('.js-current-screen > div');
      $element = $('.c-smart-hide');
      className = 'c-scrolled';
      if (this.vs != null) {
        this.vs.undelegate();
        return this.vs = new VerticalSwipe($scrollContainer[0], {
          onSwipeTop: (function(_this) {
            return function() {
              if (window.innerHeight < 667) {
                return _this.hideElement($scrollContainer, $element, className);
              }
            };
          })(this),
          onSwipeBottom: (function(_this) {
            return function() {
              return _this.showElement($scrollContainer, $element, className);
            };
          })(this)
        });
      }
    };


    /*
    			Canvas inner wrapper height calculation
     */

    VCItemView.prototype.canvasInnerLayout = function() {
      var content, currentScreen, header;
      if ($('hide-short-info').length > 0) {
        return $('body').find('.o-main__item--canvas').css({
          height: $(window).height()
        });
      } else {
        $('body').find('.o-main__item--menu').height($(window).height() - 111);
        $('body').find('.o-main__item--canvas').css({
          height: $(window).height() - 76
        });
        currentScreen = document.querySelector('.js-current-screen');
        if (currentScreen) {
          header = currentScreen.querySelector('.c-header-wrapper');
          content = currentScreen.querySelector('.c-content-wrapper');
          if (content) {
            return content.style.height = (currentScreen.offsetHeight - (header ? header.offsetHeight : 0)) + 'px';
          }
        }
      }
    };


    /*
    			Set 2 cols view for tablet layout if needed
     */

    VCItemView.prototype.tabletLayout = function() {
      return [].forEach.call(this.$el[0].querySelectorAll('.c-card-wrapper'), function(el) {
        var className;
        if (el.querySelectorAll('.c-card-wrapper .c-card-wrapper__col').length > 1) {
          className = 'c-card-wrapper--2-col';
          if (el.classList) {
            return el.classList.add(className);
          } else {
            return el.className += ' ' + className;
          }
        }
      });
    };


    /*
    			You can specify required fields for options if .required hash of view,
    			nesting is available, for example:
    				required: {
    					'item' # @options.item
    					'rightAction.label' # @options.rightAction.label
    				}
     */

    VCItemView.prototype.checkRequired = function() {
      var key, keys, property, root, _i, _len, _ref, _results;
      _ref = this.required;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        property = _ref[_i];
        keys = property.split('.');
        root = this.options;
        _results.push((function() {
          var _j, _len1, _results1;
          _results1 = [];
          for (_j = 0, _len1 = keys.length; _j < _len1; _j++) {
            key = keys[_j];
            if (root[key] == null) {
              throw "Error: property " + property + " should be specified in options for " + this.id + " view";
            }
            _results1.push(root = root[key]);
          }
          return _results1;
        }).call(this));
      }
      return _results;
    };


    /*
    			loads data from .data hash of view and pass them to template
    			there are three ways to specify where to get the data:
    
    				...
    				data:
    					info: 'user.info', # this will be get from app.server.user.info()
    
    					posts: 'fetchPosts', # this will trigger own method
    
    					anyDataOrLibrary: {...} # the object will be passed as-is to templates,
    					 * it's convenient to pass libraries to template
    					
    					messages:
    						pointer: 'messages.fromUser' # this will be get from app.server.messages.fromUser()
    						someOtherOption: 'some string' # this field will be passed in app.server.messages.fromUser() as is
    						userId: () -> @options.userId # function is evaluated with this == view
    
    				fetchPosts: ({ success, error }) ->
    				...
    
    			The actual data will be accessable by the variable named the same as the key in the data hash.
    
    			There are build-in variables presented for templating:
    				type - type of the screen, one of 'main'|'dialog'|'modal'
     */

    VCItemView.prototype.loadData = function() {
      var data, dataLoaded, err, errorCallback, fromCache, fun, key, onLoad, options, pointer, reauth, reauthCallback, successCallback, value, _ref, _ref1, _results;
      if ((this.data.ignore != null) && this.data.ignore.call(this)) {
        return;
      }
      app.showLoader();
      this._isLoadCompleted = false;
      this._dataLoaded = false;
      this._data = null;
      fromCache = true;
      data = {};
      dataLoaded = {};
      reauth = false;
      onLoad = (function(_this) {
        return function(key) {
          if (_.every(_.values(dataLoaded))) {
            if (reauth) {
              _this.app.server.invalidateAllCache();
              _this.loadData();
            } else {
              data.fromCache = fromCache;
              _this.onDataLoaded(data);
              if (_this.el.querySelector('.c-tabs') != null) {
                new TabsScroller(_this.el.querySelector('.c-tabs'));
              }
              _this.tabletLayout();
              _this.canvasInnerLayout();
              _this.smartHideElement();
              $('.o-main').click(function(event) {
                return event.preventDefault();
              });
              $(window).resize(function() {
                return _this.canvasInnerLayout();
              });
            }
          }
        };
      })(this);
      _ref = this.data;
      _results = [];
      for (key in _ref) {
        fun = _ref[key];
        dataLoaded[key] = false;
        if (fun === 'undefined') {
          continue;
        }
        if (typeof fun === 'string' || (fun.pointer != null)) {
          pointer = (_ref1 = fun.pointer) != null ? _ref1 : fun;
          successCallback = (function(key) {
            return function(_data, _fromCache) {
              fromCache = fromCache && _fromCache;
              data[key] = _data;
              dataLoaded[key] = true;
              return onLoad();
            };
          })(key);
          errorCallback = ((function(_this) {
            return function(pointer) {
              return function(err) {
                _this._isLoadCompleted = true;
                app.hideLoader();
                if (_this.onDataLoadError != null) {
                  _this.onDataLoadError(err);
                }
                if (_this.app.config.debug) {
                  console.error("Error: during " + pointer + " load");
                  console.error(err);
                }
                _this._triggerReady();
              };
            };
          })(this))(pointer);
          reauthCallback = function() {
            return reauth = true;
          };
          options = {
            success: successCallback,
            error: errorCallback,
            reauth: reauthCallback
          };
        }
        if (typeof fun === 'string') {
          if (this[fun] != null) {
            if (this.app.config.debug) {
              try {
                _results.push(this[fun](options));
              } catch (_error) {
                err = _error;
                if (app.config.debug) {
                  console.error("Error: exception in " + fun + " method of the " + this.id + " view while fetching data for template");
                }
                throw err;
              }
            } else {
              _results.push(this[fun](options));
            }
          } else {
            _results.push(this.use(fun, options));
          }
        } else if (fun.pointer != null) {
          for (key in fun) {
            value = fun[key];
            if (key !== 'pointer') {
              if (typeof value === 'function') {
                options[key] = value.call(this);
              } else {
                options[key] = value;
              }
            }
          }
          _results.push(this.use(fun.pointer, options));
        } else {
          dataLoaded[key] = true;
          data[key] = fun;
          _results.push(setTimeout(onLoad, 0));
        }
      }
      return _results;
    };

    VCItemView.prototype.use = function(fun, options) {
      if (this.app.server[fun] == null) {
        if (app.config.debug) {
          return console.error("Error: No " + fun + " in app.server");
        }
      } else {
        return this.app.server[fun](options);
      }
    };

    VCItemView.prototype.onDataLoaded = function(data) {
      var err;
      this._isLoadCompleted = true;
      this._data = data;
      this._dataLoaded = true;
      try {
        if (this && !this.isDestroyed) {
          this.render();
        }
      } catch (_error) {
        err = _error;
        if (this.app.config.debug) {
          console.log("Error: Exception while rendering " + this.id + " template");
          setTimeout((function() {
            throw err;
          }), 0);
        }
      }
      if (this._data.fromCache) {
        setTimeout((function(_this) {
          return function() {
            return app.hideLoader();
          };
        })(this), 200);
      } else {
        app.hideLoader();
      }
    };

    VCItemView.prototype.serializeData = function() {
      if (this._data == null) {
        this._data = {};
      }

      /*
      				Build-in variables in templates
       */
      this._data.id = this.id;
      this._data.app = app;
      this._data.type = this.type;
      this._data.options = this.options;
      this._data.model = this.model != null ? this.serializeModel(this.model) : null;
      this._data.collection = this.collection != null ? this.serializeCollection(this.collection) : null;
      if (this._dataLoaded && (this.preprocessData != null)) {
        this._data = this.preprocessData(this._data);
      }
      return this._data;
    };

    VCItemView.prototype.onDataLoadError = function(err) {
      app.hideLoader();
      if (err.error === 1) {
        if (app.screens.hasConnectionErrorPopup) {
          return;
        }
        if (err.isConnectionError) {
          app.screens.hasConnectionErrorPopup = true;
          return app.screens.modal('common/info-popup', {
            msg: err.setFlash[0].msg || app.tr('Server connection error.'),
            needReload: false,
            callback: function() {
              return app.screens.hasConnectionErrorPopup = false;
            }
          });
        } else {
          if (app.config.debug) {
            return console.log('Error: Unprocessed OnDataLoadError');
          }
        }
      }
    };


    /*
    			Move to previous screen
     */

    VCItemView.prototype.jsBack = function(event) {
      if (this.type === 'main') {
        app.menu.open();
      } else if (this.type === 'dialog' || this.type === 'modal') {
        if ((event != null) && event.currentTarget.getAttribute('data-reset-energy') === "1") {
          app.userEvents.trigger("popup:closed", {});
        }
        if ((event != null) && event.currentTarget.getAttribute('data-close-popup') === "1") {
          app.screens.close();
        } else {
          app.screens.back();
        }
      } else {
        if (app.config.debug) {
          console.log("Warning: probably incorrect use of .js-back in " + this.id + " template, the type of the screen isn't 'main', 'dialog' or 'modal'");
          if (this.id == null) {
            console.log(this);
          }
        }
      }
      if (this.options.onBack != null) {
        return this.options.onBack();
      }
    };

    VCItemView.prototype.onRender = function() {
      return this.windowAnimations();
    };

    VCItemView.prototype.windowAnimations = function() {
      var bounce;
      if (this.$el.find('.c-popup').parent()) {
        if (this.type === 'modal') {
          bounce = new Bounce;
          bounce.translate({
            from: {
              x: 0,
              y: -300
            },
            duration: 600,
            stiffness: 4
          });
          return bounce.applyTo(this.$el.find('.c-popup').parent());
        }
      }
    };

    VCItemView.prototype.lockUI = function() {
      this.lockedUI = true;
      this.undelegateEvents();
      if (this.lockUItimer) {
        clearTimeout(this.lockUItimer);
        this.lockUItimer = null;
      }
      this.lockUItimer = setTimeout(((function(_this) {
        return function() {
          _this.unlockUI();
          if (_this.app.config.debug) {
            return console.log('App UI unlock by Timer ' + _this.id + " [" + _this.cid + "]");
          }
        };
      })(this)), 20000);
      if (this.app.config.debug) {
        return console.log('App UI locked:' + this.id + " [" + this.cid + "]");
      }
    };

    VCItemView.prototype.unlockUI = function() {
      if (this.lockedUI) {
        if (this.lockUItimer) {
          clearTimeout(this.lockUItimer);
        }
        this.delegateEvents();
        this.lockedUI = false;
        if (this.app.config.debug) {
          return console.log('App UI unlocked:' + this.id + " [" + this.cid + "]");
        }
      }
    };

    VCItemView.prototype.sendGAView = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        return this.app.ga('send', 'pageview', {
          page: '/scr/' + this.options.id,
          title: ''
        });
      }
    };

    return VCItemView;

  })(Marionette.ItemView);
  return VCItemView;
});
