var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['underscore', 'views/item-view', 'text!templates/login.tmpl'], function(_, ItemView, template) {
  var LoginView;
  LoginView = (function(_super) {
    __extends(LoginView, _super);

    function LoginView() {
      this.auth = __bind(this.auth, this);
      this._loginExternal = __bind(this._loginExternal, this);
      return LoginView.__super__.constructor.apply(this, arguments);
    }

    LoginView.prototype.className = 'sign-in-layout';

    LoginView.prototype.template = template;

    LoginView.prototype.events = {
      'submit .login-form': 'login',
      'click .js-login': 'login',
      'click .js-login-external': 'loginExternal'
    };

    LoginView.prototype._reauthAttemptsLeft = 1;

    LoginView.prototype.initialize = function(options) {
      var login, password, _ref;
      LoginView.__super__.initialize.call(this, options);
      if (this.app.screens.menu != null) {
        this.app.screens.menu.hs.undelegate();
      }
      this.app.menuRegion.reset();
      this.app.shortInfoRegion.reset();
      $('#startup-loader').hide();
      if (localStorage.auth != null) {
        _ref = JSON.parse(localStorage.auth), login = _ref.login, password = _ref.password;
        return this.auth(login, password);
      }
    };

    LoginView.prototype.loginExternal = function(event) {
      var provider, type;
      this.lockUI();
      event.preventDefault();
      type = event.target.getAttribute('data-type');
      provider = app.socialService.getProvider(type);
      if (!provider) {
        this.app.screens.modal('common/info-popup', {
          msg: self.app.tr("Authentication failed")
        });
      }
      if (provider.isAuthenticated()) {
        return this._loginExternal(provider);
      } else {
        return provider.auth().then((function(_this) {
          return function() {
            return _this._loginExternal(provider);
          };
        })(this), (function(_this) {
          return function() {
            return _this.app.screens.modal('common/info-popup', {
              msg: self.app.tr("Authentication failed")
            });
          };
        })(this));
      }
    };

    LoginView.prototype._loginExternal = function(provider) {
      var self;
      self = this;
      return this.app.server.social.auth({
        provider: provider.getType(),
        userId: provider.getCurrentUserId(),
        token: provider.getCurrentToken(),
        success: function(data) {
          if (data && (data != null ? data.token : void 0)) {
            localStorage.setItem('auth_token', data.token);
            return self.app.screens.main('auto_login');
          } else {
            localStorage.removeItem('auth_token');
            return self.app.screens.modal('common/info-popup', {
              msg: self.app.tr("Authentication failed")
            });
          }
        },
        error: function(data) {
          var username, _ref;
          if (data && (data != null ? data.error_code : void 0) && data.error_code === 'NO_USER') {
            username = (data != null ? data.data : void 0) && ((_ref = data.data) != null ? _ref.username : void 0) ? data.data.username : null;
            return provider.getCurrentUserData().then(function(data) {
              var userData;
              userData = data.user;
              userData.username = username;
              userData.avatar_id = userData.sex === 'male' ? 1 : 4;
              return self.app.screens.dialog('login/login-with-social', {
                user: userData,
                provider: provider.getType(),
                token: provider.getCurrentToken()
              });
            }, (function(_this) {
              return function() {
                return self.app.screens.modal('common/info-popup', {
                  msg: self.app.tr("Authentication failed")
                });
              };
            })(this));
          } else if (data && data.error_code === 'INVALID_TOKEN' && self._reauthAttemptsLeft > 0) {
            self._reauthAttemptsLeft--;
            return provider.reauth(true).then(function() {
              return self._loginExternal(provider);
            }, function() {
              return self.app.screens.modal('common/info-popup', {
                msg: self.app.tr("Authentication failed")
              });
            });
          } else {
            localStorage.removeItem('auth_token');
            return self.app.screens.modal('common/info-popup', {
              msg: self.app.tr("Authentication failed")
            });
          }
        }
      });
    };

    LoginView.prototype.login = function(event) {
      var login, password;
      this.lockUI();
      event.preventDefault();
      login = this.$el[0].querySelector('.js-user-login').value;
      password = this.$el[0].querySelector('.js-user-password').value;
      return this.auth(login, password);
    };

    LoginView.prototype.auth = function(login, password) {
      this.lockUI();
      return this.app.server.auth({
        login: login,
        password: password,
        success: (function(_this) {
          return function(data) {
            _this.app.setUserId(data.userId);
            _this.app.vent.trigger('auth:login', {
              user_id: data.userId
            });
            _this.app.screens.main('quests');
            _this.app.menu.init();
            _this.app.shortInfo.init();
            return _this.app.pushNotifications.init();
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            var _ref;
            if (data === "not json response") {
              _this.app.screens.modal('common/info-popup', {
                msg: _this.app.tr("Failed to connect to server")
              });
              return;
            }
            if (app.config.debug) {
              console.log('Error', data);
            }
            localStorage.clear();
            return _this.app.screens.modal('common/info-popup', {
              msg: ((_ref = data.setFlash) != null ? _ref[0].msg : void 0) || app.tr("Incorrect login or password")
            });
          };
        })(this)
      });
    };

    LoginView.prototype.onDomRefresh = function(options) {
      return this.$el.closest('body').addClass('hide-short-info no-swipe');
    };

    return LoginView;

  })(ItemView);
  return LoginView;
});
