var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/login/sign-up.tmpl'], function(app, ItemView, _, template) {
  var SignUpView;
  SignUpView = (function(_super) {
    __extends(SignUpView, _super);

    function SignUpView() {
      return SignUpView.__super__.constructor.apply(this, arguments);
    }

    SignUpView.prototype.className = 'sign-up-layout';

    SignUpView.prototype.template = template;

    SignUpView.prototype.data = {
      data: 'user.registrationInfo'
    };

    SignUpView.prototype.events = {
      'click .js-sign-up-submit': 'signUpSubmit',
      'click .js-select-picture': 'selectAvatar',
      'click .js-select-city': 'selectCity',
      'click .js-policy': 'policy'
    };

    SignUpView.prototype.preprocessData = function(data) {
      this.citiesCollection = new Backbone.Collection(data.data.cities);
      return data;
    };

    SignUpView.prototype.selectAvatar = function(event) {
      this.$('.sign-up-persons__image-wrapper').removeClass('sign-up-persons__image-wrapper--active');
      return $(event.currentTarget).addClass('sign-up-persons__image-wrapper--active');
    };

    SignUpView.prototype.selectCity = function(event) {
      this.lockUI();
      event.preventDefault();
      return app.screens.dialog('common/select-dialog', {
        collection: this.citiesCollection,
        model: new Backbone.Model({
          title: app.tr('vCity')
        }),
        callback: (function(_this) {
          return function(cityId) {
            event.currentTarget.setAttribute('data-id', cityId);
            return _this.$('.js-select-city .js-city-name').css("color", "inherit").html(_this.citiesCollection.get(cityId).get("title"));
          };
        })(this)
      });
    };

    SignUpView.prototype.policy = function(event) {
      return app.screens.dialog("login/policy");
    };

    SignUpView.prototype.signUpSubmit = function(event) {
      var avatar, avatarId, cityId, email, password, password_repeat, ref_id, sex, showValidationErrors, username;
      if ((this.processRequest != null) && this.processRequest) {
        return;
      }
      this.lockUI();
      event.preventDefault();
      username = this.$el[0].querySelector('.js-user-username').value;
      email = this.$el[0].querySelector('.js-user-email').value;
      password = this.$el[0].querySelector('.js-user-passwd').value;
      password_repeat = this.$el[0].querySelector('.js-user-passwd_confirm').value;
      avatarId = this.$('.sign-up-persons__image-wrapper--active').attr("data-avatar");
      cityId = this.$('.js-select-city').attr("data-id");
      avatar = this._data.data.avatars[avatarId].avatar_data;
      sex = this._data.data.avatars[avatarId].sex;
      ref_id = this.$el[0].querySelector('.js-user-ref_id').value;
      if (cityId === "0") {
        this.$('.js-city-name').css("color", "#ff4d45");
        return this.unlockUI();
      } else {
        this.processRequest = true;
        showValidationErrors = (function(_this) {
          return function(validationErrors) {
            var error, field, _results;
            _results = [];
            for (field in validationErrors) {
              error = validationErrors[field];
              _results.push(_this.$(".js-user-" + field).addClass("field-error").val("").attr('placeholder', error[0]));
            }
            return _results;
          };
        })(this);
        return this.app.server.user.registration({
          username: username,
          email: email,
          passwd: password,
          passwd_confirm: password_repeat,
          avatar: avatar,
          sex: sex,
          city_id: cityId,
          ref_id: ref_id,
          success: (function(_this) {
            return function(data) {
              return _this.app.server.logout({
                success: function() {
                  _this.processRequest = false;
                  return _this.app.server.auth({
                    login: username,
                    password: password,
                    success: function(data) {
                      _this.app.screens.once('view:ready', function() {
                        return app.tutorial.start();
                      });
                      _this.app.screens.main('quests');
                      _this.app.menu.init();
                      _this.app.shortInfo.init();
                      return _this.app.pushNotifications.init();
                    },
                    error: function(data) {
                      var _ref;
                      return app.screens.modal('common/info-popup', {
                        msg: ((_ref = data.setFlash) != null ? _ref[0].msg : void 0) || app.tr("Incorrect login or password")
                      });
                    }
                  });
                },
                error: function(data) {
                  var _ref;
                  return app.screens.modal('common/info-popup', {
                    msg: ((_ref = data.setFlash) != null ? _ref[0].msg : void 0) || app.tr("Something went wrong")
                  });
                }
              });
            };
          })(this),
          error: (function(_this) {
            return function(data) {
              _this.unlockUI();
              app.hideLoader();
              _this.processRequest = false;
              return showValidationErrors(data['validationErrors']);
            };
          })(this)
        });
      }
    };

    return SignUpView;

  })(ItemView);
  return SignUpView;
});
