define(['app', 'views/item-view', 'underscore', 'text!templates/maria.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      cityHall: 'cityHall',
      userStatus: 'user.status'
    },
    events: {
      'click .js-donate': 'donate'
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    },
    donate: function(event) {
      var cityId, _ref;
      this.lockUI();
      if ((((_ref = this._data.cityHall) != null ? _ref.cityId : void 0) != null)) {
        cityId = this._data.cityHall.cityId;
        return app.screens.dialog('maria/donate', {
          cityId: cityId,
          currency: 'vd'
        });
      }
    }
  });
});
