define(['app', 'views/item-view', 'underscore', 'text!templates/business/create-company.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    events: {
      'click #payment_type': 'changeCurrency',
      'click .js-create-company': 'createCompany',
      'click .js-select': 'selectItem'
    },
    data: {
      business: 'business'
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    },
    preprocessData: function(data) {
      var item, _i, _len, _ref;
      _ref = data.business.company_types;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        item = _ref[_i];
        item.title = item.name;
      }
      this.companyCatsCollection = new Backbone.Collection(data.business.company_types);
      return data;
    },
    selectItem: function(event) {
      this.lockUI();
      return app.screens.dialog('common/select-dialog', {
        collection: this.companyCatsCollection,
        callback: (function(_this) {
          return function(itemId) {
            event.currentTarget.setAttribute('data-id', itemId);
            return _this.$('.js-select .js-item-name').html(_this.companyCatsCollection.get(itemId).get("title"));
          };
        })(this)
      });
    },
    changeCurrency: function(event) {
      return;
      this.$el.find('.vd-info').toggle();
      this.$el.find('.vg-info').toggle();
      return this.$el.find('.js-create-company').toggleClass('c-btn--green c-btn--yellow');
    },
    createCompany: function(event) {
      var currency, name, typeId;
      this.lockUI();
      typeId = this.$('.js-select').attr("data-id");
      currency = this.$el.find('#payment_type').is(':checked') ? 'vgold' : 'vdollars';
      name = this.$el.find('.js-name').val();
      if (name === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the company's name")
        });
      } else {
        return app.server.cityHall.createCompany({
          type: typeId,
          currency: currency,
          name: name,
          success: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Company was created")
            }, app.screens.back());
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      }
    }
  });
});
