var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/maria/employees.tmpl'], function(app, ItemView, _, template) {
  var MariaEmployeesView;
  MariaEmployeesView = (function(_super) {
    __extends(MariaEmployeesView, _super);

    function MariaEmployeesView() {
      return MariaEmployeesView.__super__.constructor.apply(this, arguments);
    }

    MariaEmployeesView.prototype.template = template;

    MariaEmployeesView.prototype.data = {
      сompanyWorkersInfo: {
        pointer: 'business.сompanyWorkersInfo',
        companyId: function() {
          return this.options.companyId;
        }
      },
      effects: {
        pointer: 'business.company.effects',
        companyId: function() {
          return this.options.companyId;
        }
      },
      companyInfo: {
        pointer: 'business.companyInfo',
        companyId: function() {
          return this.options.companyId;
        }
      }
    };

    MariaEmployeesView.prototype.events = {
      'click .js-goto-employees-list': 'gotoEmployeesList',
      'click .js-goto-foreign-workers': 'gotoForeignWorkers',
      'click .js-goto-recruitment': 'gotoRecruitment',
      'click .js-goto-storage': 'gotoStorage',
      'click .js-goto-common': 'gotoCommon',
      'click .js-up-level': 'upLevel',
      'click .js-effects': 'showEffects'
    };


    /*
    			Center cloud
     */

    MariaEmployeesView.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    MariaEmployeesView.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    MariaEmployeesView.prototype.gotoCommon = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('maria/company', {
        companyId: companyId
      });
    };

    MariaEmployeesView.prototype.gotoStorage = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('maria/company-storage', {
        companyId: companyId
      });
    };

    MariaEmployeesView.prototype.gotoEmployeesList = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/employees-list', {
        companyId: companyId
      });
    };

    MariaEmployeesView.prototype.gotoForeignWorkers = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/hiring-migrants', {
        companyId: companyId
      });
    };

    MariaEmployeesView.prototype.gotoRecruitment = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/recruitment', {
        companyId: companyId
      });
    };

    MariaEmployeesView.prototype.upLevel = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Do you want to upgrade the workers limit?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.business.upLevel({
              companyId: companyId,
              success: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    MariaEmployeesView.prototype.showEffects = function(event) {
      var companyId;
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('maria/city-effects', {
        companyId: companyId
      });
    };

    return MariaEmployeesView;

  })(ItemView);
  return MariaEmployeesView;
});
