var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['underscore', 'views/item-view', 'text!templates/menu.tmpl'], function(_, ItemView, template) {
  var MenuView;
  MenuView = (function(_super) {
    __extends(MenuView, _super);

    function MenuView() {
      return MenuView.__super__.constructor.apply(this, arguments);
    }

    MenuView.prototype.template = template;

    MenuView.prototype.events = {
      'click .js-goto-parties': 'showPartyInfo'
    };

    MenuView.prototype.data = {
      badges: 'user.notification_badges',
      info: 'user.info.short',
      bb: 'events.bb.silent',
      election: 'events.election.silent',
      ot: 'events.ot.silent',
      at: 'military.at.areas',
      at_result: 'military.at.areasArchive',
      parties: 'party.list'
    };

    MenuView.prototype.addListeners = function() {
      MenuView.__super__.addListeners.apply(this, arguments);
      this.listenTo(app, 'User.messages.UnreadCount.update', this.updateMessagesUnreadCount);
      this.listenTo(app, 'User.Friends.RequestCount.update', this.updateFriendsRequestCount);
      this.listenTo(app, 'User.Feed.newMessageCount.update', this.updateFeedNewMessageCount);
      return this.listenTo(app, 'quest_finished', this.updateFinishedQuests);
    };

    MenuView.prototype.updateFinishedQuests = function(args) {
      var exists, quest, _i, _len, _ref;
      if (!this._data || !this._data.badges || !this._data.badges.completedQuests) {
        return;
      }
      exists = false;
      _ref = this._data.badges.completedQuests.list;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        quest = _ref[_i];
        if (quest.id === args.data.quest.id) {
          exists = true;
          break;
        }
      }
      if (!exists) {
        this._data.badges.completedQuests.list.push(args.data.quest);
        this._data.badges.completedQuests.completed = this._data.badges.completedQuests.list.length;
        return this.render();
      }
    };

    MenuView.prototype.updateMessagesUnreadCount = function(args) {
      if (!this._data || !this._data.badges) {
        return;
      }
      this._data.badges.messagesCount = args.data.body.value;
      return this.render();
    };

    MenuView.prototype.updateFriendsRequestCount = function(args) {
      if (!this._data || !this._data.badges) {
        return;
      }
      this._data.badges.friendshipRequestsCount = args.data.body.value;
      return this.render();
    };

    MenuView.prototype.updateFeedNewMessageCount = function(args) {
      if (!this._data || !this._data.badges) {
        return;
      }
      this._data.badges.feedCount = args.data.body.value;
      return this.render();
    };

    MenuView.prototype.showPartyInfo = function(event) {
      var partyId;
      this.lockUI();
      partyId = event.currentTarget.getAttribute('data-party-id');
      return app.screens.dialog('parties/common', {
        screen_options: partyId,
        partyId: partyId
      });
    };

    return MenuView;

  })(ItemView);
  return MenuView;
});
