var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/messages.tmpl'], function(app, ItemView, _, template) {
  var MessagesView;
  MessagesView = (function(_super) {
    __extends(MessagesView, _super);

    function MessagesView() {
      this.updateMessagesUnreadCount = __bind(this.updateMessagesUnreadCount, this);
      return MessagesView.__super__.constructor.apply(this, arguments);
    }

    MessagesView.prototype.className = 'messages-layout';

    MessagesView.prototype.template = template;

    MessagesView.prototype.data = {
      messages: 'messages'
    };

    MessagesView.prototype.events = {
      'click .js-goto-conversations': 'gotoConversations',
      'click .js-goto-profile': 'gotoProfile'
    };

    MessagesView.prototype.addListeners = function() {
      MessagesView.__super__.addListeners.apply(this, arguments);
      return app.on('User.messages.UnreadCount.update', this.updateMessagesUnreadCount);
    };

    MessagesView.prototype.updateMessagesUnreadCount = function(args) {
      if (!this._data.messages) {
        return;
      }
      this._data.messages.totalNewMessageCount = args.data.body.value;
      if (args.data.body.value > 0) {
        this.$el.find('.message_count').show();
      } else {
        this.$el.find('.message_count').hide();
      }
      return this.$el.find('.message_count').html(args.data.body.value);
    };

    MessagesView.prototype.gotoConversations = function(event) {
      var userId;
      this.lockUI();
      userId = event.currentTarget.getAttribute('data-user-id');
      return app.screens.dialog('messages/conversations', {
        userId: userId
      });
    };

    MessagesView.prototype.gotoProfile = function(event) {
      var hasProfile, userId;
      this.lockUI();
      event.stopPropagation();
      userId = event.currentTarget.getAttribute('data-user-id');
      hasProfile = event.currentTarget.getAttribute('data-user-has-profile') === 'true';
      if (hasProfile) {
        return app.screens.dialog('users/profile', {
          userId: userId
        });
      }
    };


    /*
    			Center cloud
     */

    MessagesView.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    MessagesView.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return MessagesView;

  })(ItemView);
  return MessagesView;
});
