var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/areas-takeover.tmpl', 'jquery.countdown'], function(app, ItemView, _, template, countdown) {
  var AreasTakeoverView;
  AreasTakeoverView = (function(_super) {
    __extends(AreasTakeoverView, _super);

    function AreasTakeoverView() {
      return AreasTakeoverView.__super__.constructor.apply(this, arguments);
    }

    AreasTakeoverView.prototype.template = template;

    AreasTakeoverView.prototype.className = 'military-layout';

    AreasTakeoverView.prototype.data = {
      user: 'user.info.short',
      info: 'military.info',
      areas: 'military.at.areas',
      areasArchive: 'military.at.areasArchive'
    };

    AreasTakeoverView.prototype.events = {
      'click .js-goto-tacticel-map': 'gotoTacticalMap'
    };

    AreasTakeoverView.prototype.preprocessData = function(data) {
      var a, area, mobilizationAreas, _i, _len, _ref;
      if (!data || !data.areas) {
        return data;
      }
      mobilizationAreas = [];
      _ref = data.areas;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        area = _ref[_i];
        if (data.user.user.User.city_id === area.defendersCityId && area.preparation) {
          mobilizationAreas.push(area);
          a = 1;
        }
      }
      data.mobilizationAreas = mobilizationAreas;
      return data;
    };

    AreasTakeoverView.prototype.pvpRequest = function() {
      this.lockUI();
      return app.server.military.pvp.request();
    };

    AreasTakeoverView.prototype.gotoTacticalMap = function(event) {
      var areaId;
      this.lockUI();
      areaId = event.currentTarget.getAttribute('data-area-id');
      return app.screens.dialog('military-base/tactical-map', {
        areaId: areaId
      });
    };


    /*
    			Center cloud
     */

    AreasTakeoverView.prototype.centerCloud = function() {
      var height;
      if ($('.c-cloud').length > 0) {
        height = $('.js-current-screen').outerHeight() - $('.c-header-wrapper').outerHeight() - $('.c-cloud').outerHeight();
        return $('.c-cloud').css('margin-top', height / 2);
      }
    };

    AreasTakeoverView.prototype.onDomRefresh = function() {
      var area, _i, _j, _len, _len1, _ref, _ref1, _results;
      this.centerCloud();
      if (this._data.areas != null) {
        _ref = this._data.areas;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          area = _ref[_i];
          this.$(".js-militarization-countdown#" + area.areaTakeoverId).countdown(Date.now() + area.preparationLeft * 1000, (function(_this) {
            return function(event) {
              return $(event.currentTarget).text(event.strftime('%-H:%M:%S'));
            };
          })(this)).on('finish.countdown', (function(_this) {
            return function(ev) {
              return _this.reload();
            };
          })(this));
        }
      }
      if (this._data.mobilizationAreas != null) {
        _ref1 = this._data.mobilizationAreas;
        _results = [];
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          area = _ref1[_j];
          _results.push(this.$(".js-mobilization-countdown#mobilization" + area.areaTakeoverId).countdown(Date.now() + area.preparationLeft * 1000, (function(_this) {
            return function(event) {
              return $(event.currentTarget).text(event.strftime('%-H:%M:%S'));
            };
          })(this)).on('finish.countdown', (function(_this) {
            return function(ev) {
              return $(event.currentTarget).parent('.js-mobilization-warning').remove();
            };
          })(this)));
        }
        return _results;
      }
    };

    return AreasTakeoverView;

  })(ItemView);
  return AreasTakeoverView;
});
