define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/blockpost-popup.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      post: {
        pointer: 'military.at.areas.post',
        areaId: function() {
          return this.options.areaId;
        },
        postId: function() {
          return this.options.postId;
        }
      }
    },
    events: {
      'click .js-fight': 'fight',
      'click .js-scout': 'scout',
      'click .js-last-scouting': 'lastScouting'
    },
    fight: function() {
      this.lockUI();
      return app.server.military.at.checkClone({
        success: (function(_this) {
          return function(data) {
            return app.screens.dialog('profile', {
              from: 'military',
              areaId: _this.options.areaId,
              postId: _this.options.postId
            });
          };
        })(this)
      });
    },
    scout: function() {
      this.lockUI();
      return app.server.military.at.areas.scout({
        areaId: this.options.areaId,
        postId: this.options.postId,
        success: (function(_this) {
          return function(scoutingResult) {
            return _this.options.tacticalMap.setScoutNumbers(_this.options.postId, scoutingResult.assailantsClonesNumber, scoutingResult.defendersClonesNumber);
          };
        })(this)
      });
    },
    lastScouting: function() {
      var scoutingResult;
      scoutingResult = this._data.post.lastScoutingResult;
      return this.options.tacticalMap.setScoutNumbers(this.options.postId, scoutingResult.assailantsClonesNumber, scoutingResult.defendersClonesNumber);
    }
  });
});
