var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/combat-skills-popup.tmpl'], function(app, ItemView, _, template) {
  var CombatSkillsPopup;
  CombatSkillsPopup = (function(_super) {
    __extends(CombatSkillsPopup, _super);

    function CombatSkillsPopup() {
      return CombatSkillsPopup.__super__.constructor.apply(this, arguments);
    }

    CombatSkillsPopup.prototype.template = template;

    CombatSkillsPopup.prototype.data = {
      info: 'fightPoints.info'
    };

    CombatSkillsPopup.prototype.events = {
      'click .js-skill-up': 'fightSkillUp'
    };

    CombatSkillsPopup.prototype.fightSkillUp = function(event) {
      var fightSkillTypeId;
      this.lockUI();
      fightSkillTypeId = event.currentTarget.getAttribute('data-skillType-id');
      return app.server.fightPoints.upLevel({
        fightSkillTypeId: fightSkillTypeId,
        doesNotReload: true,
        success: (function(_this) {
          return function(data) {
            var fightPointsEl, levelEl;
            if (data.profile.User.fight_points > 0) {
              fightPointsEl = _this.el.querySelector('.js-fight-points');
              fightPointsEl.textContent = data.profile.User.fight_points;
              levelEl = _this.el.querySelector(".js-skill-level[data-skillType-id=\"" + fightSkillTypeId + "\"]");
              levelEl.textContent = parseInt(levelEl.textContent) + 1;
              return _this.unlockUI();
            } else {
              return _this.jsBack();
            }
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            _this.jsBack();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    return CombatSkillsPopup;

  })(ItemView);
  return CombatSkillsPopup;
});
