var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/gangs.tmpl'], function(app, ItemView, _, template) {
  var GangsView;
  GangsView = (function(_super) {
    __extends(GangsView, _super);

    function GangsView() {
      return GangsView.__super__.constructor.apply(this, arguments);
    }

    GangsView.prototype.template = template;

    GangsView.prototype.className = 'military-layout dark-theme';

    GangsView.prototype.data = {
      info: 'military.info',
      gangs: 'military.pve.gangs'
    };

    GangsView.prototype.events = {
      'click .js-gang': 'selectComplexity',
      'click .js-rank': 'selectRank',
      'click .js-fight': 'fight'
    };

    GangsView.prototype.selectComplexity = function(event) {
      var complexity, gangName;
      complexity = +event.currentTarget.getAttribute('data-complexity');
      gangName = event.currentTarget.getAttribute('data-name');
      if (complexity > this.availableComplexity) {
        return;
      }
      this.complexity = complexity;
      this.availableRank = this._data.gangs.progress[this.complexity - 1].availableRank;
      this.rank = this.availableRank;
      this.setComplexity(this.complexity, this.rank);
      this.setGangName(gangName);
      this.setAvailableRank(this.availableRank);
      this.setRank(this.rank);
      return this.setEnergy(this.complexity, this.rank);
    };

    GangsView.prototype.selectRank = function(event) {
      var rank;
      rank = +event.currentTarget.getAttribute('data-rank');
      return this.rankSelector(rank);
    };

    GangsView.prototype.rankSelector = function(rank) {
      if (rank <= this.availableRank) {
        this.rank = rank;
        this.setRank(this.rank);
        return this.setEnergy(this.complexity, this.rank);
      }
    };

    GangsView.prototype.setComplexity = function(complexity, rank) {
      var botsEl, rewardsEl, sliderEl, _ref;
      if (((_ref = this._data) != null ? _ref.gangs : void 0) == null) {
        this.energy = 0;
      }
      if (complexity > this.availableComplexity) {
        return;
      }
      sliderEl = this.el.querySelector('.js-gang-slider');
      sliderEl.setAttribute('data-complexity', complexity);
      rewardsEl = this.el.querySelector('.js-rewards');
      rewardsEl.setAttribute('data-complexity', complexity);
      botsEl = this.el.querySelector('.js-bots');
      return botsEl.setAttribute('data-complexity', complexity);
    };

    GangsView.prototype.setAvailableRank = function(availableRank) {
      return this.el.querySelector('.js-rank-select').setAttribute('data-rank-available', availableRank);
    };

    GangsView.prototype.setRank = function(rank) {
      var botsEl, rewardsEl, _ref;
      this.el.querySelector('.js-rank-select').setAttribute('data-rank', rank);
      rewardsEl = this.el.querySelector('.js-rewards');
      rewardsEl.setAttribute('data-rank', rank);
      botsEl = this.el.querySelector('.js-bots');
      botsEl.setAttribute('data-rank', rank);
      if (((_ref = this._data) != null ? _ref.gangs : void 0) != null) {
        this.$('.js-wins').html(this._data.gangs.progress[this.complexity - 1].wins[rank - 1]);
        return this.$('.js-wins-unlock').html(this._data.gangs.progress[this.complexity - 1].winsUnlock[rank]);
      }
    };

    GangsView.prototype.setEnergy = function(complexity, rank) {
      var energyEl;
      this.energy = this._data.gangs.progress[complexity - 1].ranks[rank - 1].energy;
      energyEl = this.el.querySelector('.js-energy');
      return energyEl.innerHTML = this.energy;
    };

    GangsView.prototype.setGangName = function(name) {
      var nameEl;
      nameEl = this.el.querySelector('.js-gang-name');
      return nameEl.innerHTML = name;
    };

    GangsView.prototype.fight = function(event) {
      var oldData;
      this.lockUI();
      oldData = this._data;
      return this.app.server.military.pve.fight({
        complexity: this.complexity,
        rank: this.rank,
        success: (function(_this) {
          return function(data) {
            var openCombatPointsPopup, openInjuryPopup, openRankPopup, openResultPopup;
            _this.app.vent.trigger('military-base:gangs_fought', {
              data: data
            });
            if (data.userWin && (parseInt(oldData.gangs.progress[_this.complexity - 1].wins[_this.rank - 1]) + 1 === parseInt(oldData.gangs.progress[_this.complexity - 1].winsUnlock[_this.rank]))) {
              _this.complexity = void 0;
              _this.rank = void 0;
            }
            openInjuryPopup = function(onBack) {
              var options;
              if (data.result.traumas.length !== 0) {
                options = {
                  injured: {
                    light: 0,
                    medium: 0,
                    height: 0
                  },
                  traumasEffect: 0
                };
                if (onBack != null) {
                  options.onBack = onBack;
                }
                data.result.traumas.forEach(function(trauma) {
                  options.injured[trauma.name] += 1;
                  return options.traumasEffect += +trauma.result;
                });
                return app.screens.modal('common/injury-popup', options);
              } else {
                if (onBack != null) {
                  return onBack();
                }
              }
            };
            openRankPopup = function(onBack) {
              var options;
              if (data.result.rank != null) {
                options = {
                  rank: data.result.rank
                };
                if (onBack != null) {
                  options.onBack = onBack;
                }
                options.fightType = 'pve';
                return app.screens.modal('military-base/new-rank-popup', options);
              } else {
                if (onBack != null) {
                  return onBack();
                }
              }
            };
            openResultPopup = function(onBack) {
              var options;
              options = data;
              if (onBack != null) {
                options.onBack = onBack;
              }
              options.fightType = 'pve';
              options.repeat = {
                method: _this.fight,
                context: _this,
                event: event
              };
              return app.screens.modal('military-base/fight-result-popup', options);
            };
            openCombatPointsPopup = function(onBack) {
              var options;
              if (data.result.rank != null) {
                options = data;
                if (onBack != null) {
                  options.onBack = onBack;
                }
                options.fightType = 'pve';
                return app.screens.modal('military-base/combat-skills-popup', options);
              } else {
                if (onBack != null) {
                  return onBack();
                }
              }
            };
            return openResultPopup(function() {
              return openRankPopup(function() {
                return openCombatPointsPopup(function() {
                  return openInjuryPopup();
                });
              });
            });
          };
        })(this),
        error: (function(_this) {
          return function(err) {
            _this.unlockUI();
            if (err.setFlash) {
              return err.setFlash.forEach(function(msg) {
                return app.screens.modal('common/info-popup', {
                  msg: msg.msg
                });
              });
            }
          };
        })(this)
      });
    };


    /*
    			Center cloud
     */

    GangsView.prototype.centerCloud = function() {
      var height;
      if ($('.c-cloud').length > 0) {
        height = $('.js-current-screen').outerHeight() - $('.c-header-wrapper').outerHeight() - $('.c-cloud').outerHeight();
        return $('.c-cloud').css('margin-top', height / 2);
      }
    };

    GangsView.prototype.onDomRefresh = function() {
      var gangName, _ref, _ref1, _ref2;
      this.centerCloud();
      if (((_ref = this._data) != null ? _ref.gangs : void 0) != null) {
        this.availableComplexity = this._data.gangs.progress.length;
        this.complexity = (_ref1 = this.complexity) != null ? _ref1 : this.availableComplexity;
        this.availableRank = this._data.gangs.progress[this.complexity - 1].availableRank;
        this.rank = (_ref2 = this.rank) != null ? _ref2 : this.availableRank;
        gangName = this._data.gangs.progress[this.complexity - 1].name;
        this.setComplexity(this.complexity, this.rank);
        this.setGangName(gangName);
        this.setAvailableRank(this.availableRank);
        this.setRank(this.rank);
        return this.setEnergy(this.complexity, this.rank);
      }
    };

    return GangsView;

  })(ItemView);
  return GangsView;
});
