var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/tactics.tmpl'], function(app, ItemView, _, template) {
  var TacticsView;
  TacticsView = (function(_super) {
    __extends(TacticsView, _super);

    function TacticsView() {
      return TacticsView.__super__.constructor.apply(this, arguments);
    }

    TacticsView.prototype.template = template;

    TacticsView.prototype.data = {
      tactics: 'military.cloneTactics'
    };

    TacticsView.prototype.events = {
      'click .js-fight': 'fight',
      'click .js-select-preset': 'selectPreset',
      'click .js-select-tactic': 'selectTactic'
    };

    TacticsView.prototype.preprocessData = function(data) {
      var arrId, association, item, preset, tactic, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _ref2, _ref3;
      _ref = data.tactics.presets;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        preset = _ref[_i];
        preset.id = preset.CloneTacticPreset.id;
        preset.title = preset.CloneTacticPreset.title;
        _ref1 = preset.CloneTacticPresetAssociation;
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          association = _ref1[_j];
          association.type = association.CloneTacticGroup.type;
        }
      }
      this.availablePresets = new Backbone.Collection(data.tactics.presets);
      this.currentPreset = this.availablePresets.last();
      this.currentAssociations = new Backbone.Collection(this.currentPreset.get("CloneTacticPresetAssociation"));
      data.currentUserPreset = this.currentPreset;
      _ref2 = data.tactics.tactic_groups;
      for (arrId in _ref2) {
        item = _ref2[arrId];
        item.id = arrId;
        item.type = item.CloneTacticGroup.type;
        _ref3 = item.CloneTactic;
        for (_k = 0, _len2 = _ref3.length; _k < _len2; _k++) {
          tactic = _ref3[_k];
          tactic.CloneTacticGroup = {
            type: item.CloneTacticGroup.type
          };
        }
      }
      this.tacticGroups = new Backbone.Collection(data.tactics.tactic_groups);
      return data;
    };

    TacticsView.prototype.onRender = function() {
      if (this.currentPreset != null) {
        return this.onSelectPreset(this.currentPreset);
      }
    };

    TacticsView.prototype.selectPreset = function(event) {
      return app.screens.dialog('common/select-dialog', {
        collection: this.availablePresets,
        model: new Backbone.Model({
          title: app.tr('Available tactics presets')
        }),
        callback: (function(_this) {
          return function(modelId) {
            _this.currentPreset = _this.availablePresets.get(modelId);
            _this.currentAssociations = new Backbone.Collection(_this.currentPreset.get("CloneTacticPresetAssociation"));
            event.currentTarget.setAttribute('data-preset', _this.currentPreset.get("id"));
            _this.$('.js-select-preset .js-preset-title').html(_this.currentPreset.get("title"));
            return _this.onSelectPreset(_this.currentPreset);
          };
        })(this)
      });
    };

    TacticsView.prototype.onSelectPreset = function(presetModel) {
      var additionalInput, arrId, enableInput, group, tactic, _ref, _results;
      enableInput = presetModel.get("CloneTacticPreset").user_id != null;
      _ref = presetModel.get("CloneTacticPresetAssociation");
      _results = [];
      for (arrId in _ref) {
        tactic = _ref[arrId];
        group = tactic.CloneTacticGroup.type;
        this.$(".js-select-tactic .js-" + group + "-tactic").html(tactic.CloneTactic.title);
        additionalInput = this.$(".js-additional-" + group);
        if (tactic.CloneTactic.parameter_type != null) {
          additionalInput.show().attr("placeholder", tactic.CloneTactic.parameter_title).data("assocId", arrId).val(tactic.parameter_value);
          if (enableInput) {
            _results.push(additionalInput.removeAttr('disabled'));
          } else {
            _results.push(additionalInput.attr('disabled', 'disabled'));
          }
        } else {
          _results.push(additionalInput.hide());
        }
      }
      return _results;
    };

    TacticsView.prototype.selectTactic = function(event) {
      var additionalInput, groupTacticsCollection, tacticGroup, thisTypeTacticsModel;
      tacticGroup = event.currentTarget.getAttribute('data-tactic-group');
      if (this.currentPreset.get("CloneTacticPreset").user_id != null) {
        additionalInput = this.$(".js-additional-" + tacticGroup);
        additionalInput.hide();
        thisTypeTacticsModel = this.tacticGroups.findWhere({
          type: tacticGroup
        });
        groupTacticsCollection = new Backbone.Collection(thisTypeTacticsModel.get("CloneTactic"));
        return app.screens.dialog('common/select-dialog', {
          collection: groupTacticsCollection,
          model: new Backbone.Model({
            title: app.tr('Attack Tactics')
          }),
          callback: (function(_this) {
            return function(modelId) {
              var selectedTactic, thisTypeAssociation;
              selectedTactic = groupTacticsCollection.get(modelId);
              thisTypeAssociation = _this.currentAssociations.findWhere({
                type: tacticGroup
              });
              thisTypeAssociation.set('clone_tactic_id', selectedTactic.get("id"));
              thisTypeAssociation.set('CloneTactic', selectedTactic.toJSON());
              _this.currentAssociations.set([thisTypeAssociation], {
                remove: false
              });
              _this.$(".js-" + tacticGroup + "-tactic").html(selectedTactic.get("title"));
              if (selectedTactic.get("parameter_type")) {
                return additionalInput.removeAttr('disabled').val("").show().attr("placeholder", selectedTactic.get("parameter_title")).data("group", tacticGroup).data("type", selectedTactic.get("parameter_type"));
              }
            };
          })(this)
        });
      } else {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("You can change tactic settings only for Your tactics")
        });
      }
    };

    TacticsView.prototype.fight = function() {
      var associationsData, error;
      this.lockUI();
      if (this.currentPreset.get("CloneTacticPreset").user_id != null) {
        error = false;
        associationsData = [];
        this.currentAssociations.forEach(function(association) {
          var additionalData;
          if ((association.get("CloneTactic").parameter_type != null) && association.get("CloneTactic").parameter_type === 'integer') {
            additionalData = parseInt(this.$(".js-additional-" + (association.get("CloneTacticGroup").type)).val());
            if (isNaN(additionalData)) {
              error = true;
              return app.screens.modal('common/info-popup', {
                msg: "" + (association.get("CloneTactic").parameter_title) + " "
              });
            }
            association.set("parameter_value", additionalData);
          }
          return associationsData.push({
            CloneTacticPresetAssociation: {
              id: association.get("id"),
              clone_tactic_id: association.get("clone_tactic_id"),
              parameter_value: association.get("CloneTactic").parameter_type != null ? association.get("parameter_value") : null
            }
          });
        });
        if (error) {
          return;
        }
        return app.server.military.saveCustomTactics({
          associationsData: associationsData,
          success: (function(_this) {
            return function(data) {
              return _this.sendClone();
            };
          })(this)
        });
      } else {
        return this.sendClone();
      }
    };

    TacticsView.prototype.sendClone = function() {
      var tacticsArr;
      tacticsArr = {};
      this.currentAssociations.forEach(function(association) {
        tacticsArr[association.get("CloneTacticGroup").type] = {
          type: association.get("CloneTactic").type
        };
        if (association.get("CloneTactic").parameter_type != null) {
          return tacticsArr[association.get("CloneTacticGroup").type]['parameter_value'] = association.get("parameter_value");
        }
      });
      return app.server.military.at.sendClone({
        areaId: this.options.areaId,
        postId: this.options.postId,
        tactics: tacticsArr,
        success: function(data) {
          var successPopupOptions;
          successPopupOptions = {
            msg: data.setFlash[0].msg
          };
          successPopupOptions.onBack = data.traumas.length !== 0 ? function() {
            var options;
            options = {
              injured: {
                light: 0,
                medium: 0,
                height: 0
              },
              traumasEffect: 0
            };
            if (typeof onBack !== "undefined" && onBack !== null) {
              options.onBack = onBack;
            }
            data.traumas.forEach(function(trauma) {
              options.injured[trauma.name] += 1;
              return options.traumasEffect += +trauma.result;
            });
            return app.screens.modal('common/injury-popup', options);
          } : function() {
            if (typeof onBack !== "undefined" && onBack !== null) {
              return onBack();
            }
          };
          return app.screens.modal('common/success-popup', successPopupOptions, app.screens.back());
        }
      });
    };

    return TacticsView;

  })(ItemView);
  return TacticsView;
});
