var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/news.tmpl'], function(app, ItemView, _, template) {
  var MyNews;
  MyNews = (function(_super) {
    __extends(MyNews, _super);

    function MyNews() {
      return MyNews.__super__.constructor.apply(this, arguments);
    }

    MyNews.prototype.template = template;

    MyNews.prototype.data = {
      subscriptions: 'news.userSubscriptions',
      unread: 'news.unreadPosts',
      unreadFamous: 'news.unreadFamousPosts',
      newspaper: 'news.userNewspaper'
    };

    MyNews.prototype.events = {
      'click .js-newspaper': 'goToNewspaper',
      'click .js-post': 'goToPost'
    };

    MyNews.prototype.goToNewspaper = function(event) {
      var newspaperSlug;
      this.lockUI();
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/newspaper', {
        newspaperSlug: newspaperSlug
      });
    };

    MyNews.prototype.goToPost = function(event) {
      var newspaperSlug, postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/article', {
        newspaperSlug: newspaperSlug,
        postId: postId
      });
    };


    /*
    			Center cloud
     */

    MyNews.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    MyNews.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return MyNews;

  })(ItemView);
  return MyNews;
});
