var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/news/latest.tmpl'], function(app, ItemView, _, template) {
  var AllNews;
  AllNews = (function(_super) {
    __extends(AllNews, _super);

    function AllNews() {
      return AllNews.__super__.constructor.apply(this, arguments);
    }

    AllNews.prototype.template = template;

    AllNews.prototype.data = {
      latest: 'news.latest'
    };

    AllNews.prototype.events = {
      'click .js-newspaper': 'goToNewspaper',
      'click .js-post': 'goToPost'
    };

    AllNews.prototype.goToNewspaper = function(event) {
      var newspaperSlug;
      this.lockUI();
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/newspaper', {
        newspaperSlug: newspaperSlug
      });
    };

    AllNews.prototype.goToPost = function(event) {
      var newspaperSlug, postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/article', {
        newspaperSlug: newspaperSlug,
        postId: postId
      });
    };


    /*
    			Center cloud
     */

    AllNews.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    AllNews.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return AllNews;

  })(ItemView);
  return AllNews;
});
