var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/news/my-newspaper.tmpl', 'views/components/clusterize-helper'], function(app, ItemView, _, template, ClusterizeHelper) {
  var MyNewspaper;
  MyNewspaper = (function(_super) {
    __extends(MyNewspaper, _super);

    function MyNewspaper() {
      return MyNewspaper.__super__.constructor.apply(this, arguments);
    }

    MyNewspaper.prototype.template = template;

    MyNewspaper.prototype.data = {
      newspaper: 'news.userNewspaper',
      unread: 'news.unreadPosts',
      unreadFamous: 'news.unreadFamousPosts'
    };

    MyNewspaper.prototype.events = {
      'click .js-manage-newspaper': 'manageNewspaper',
      'click .js-post': 'goToEditPost'
    };

    MyNewspaper.prototype.goToEditPost = function(event) {
      var newspaperSlug, postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/edit-article', {
        newspaperSlug: newspaperSlug,
        postId: postId
      });
    };

    MyNewspaper.prototype.manageNewspaper = function(event) {
      if (app.config.debug) {
        return console.log("manage newspaper");
      }
    };


    /*
    			Center cloud
     */

    MyNewspaper.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    MyNewspaper.prototype.onDomRefresh = function() {
      this.centerCloud();
      return ClusterizeHelper(this.$el);
    };

    return MyNewspaper;

  })(ItemView);
  return MyNewspaper;
});
