var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/news/open-newspaper.tmpl'], function(app, ItemView, _, template) {
  var OpenNewspaper;
  OpenNewspaper = (function(_super) {
    __extends(OpenNewspaper, _super);

    function OpenNewspaper() {
      return OpenNewspaper.__super__.constructor.apply(this, arguments);
    }

    OpenNewspaper.prototype.template = template;

    OpenNewspaper.prototype.className = 'no-bg-image';

    OpenNewspaper.prototype.data = {
      price: 'news.getOpenPrice',
      blocks: 'user.blocks'
    };

    OpenNewspaper.prototype.events = {
      'click .js-apply': 'createNewspaper'
    };

    OpenNewspaper.prototype.createNewspaper = function(event) {
      var newspaperName;
      this.lockUI();
      newspaperName = this.$el.find('.js-name').val();
      if (newspaperName === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the name")
        });
      } else {
        return app.server.news.openNewspaper({
          newspaperName: newspaperName,
          success: function(data) {
            if (!data.error) {
              app.screens.back();
              return app.screens.modal('common/success-popup', {
                msg: data.setFlash[0].msg || app.tr("Newspaper has been opened")
              });
            }
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      }
    };

    return OpenNewspaper;

  })(ItemView);
  return OpenNewspaper;
});
