var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/quests.tmpl', 'views/components/clusterize-helper'], function(app, ItemView, _, template, ClusterizeHelper) {
  var QuestsView;
  QuestsView = (function(_super) {
    __extends(QuestsView, _super);

    function QuestsView() {
      return QuestsView.__super__.constructor.apply(this, arguments);
    }

    QuestsView.prototype.template = template;

    QuestsView.prototype.className = 'quests-layout';

    QuestsView.prototype.required = ['isNew'];

    QuestsView.prototype.data = {
      quests: 'quests'
    };

    QuestsView.prototype.events = {
      'click .js-quest-info': 'questInfo'
    };

    QuestsView.prototype.callPopup = function() {
      return app.screens.modal('quests/quests-popup', {
        overlay: false,
        msg: app.tr('VirCities honored worker'),
        info: app.tr('Spend 500 energy for work'),
        energyInfo: '25 / 500'
      });
    };

    QuestsView.prototype.questInfo = function(event) {
      var questId;
      questId = event.currentTarget.getAttribute('data-quest-id');
      return app.screens.dialog('quests/quest', {
        questId: questId
      });
    };

    QuestsView.prototype.onRender = function(event) {
      QuestsView.__super__.onRender.call(this);
      if (this.options.openMenu != null) {
        return app.menu.open();
      }
    };

    QuestsView.prototype.onDomRefresh = function() {
      this.$el.closest('body').removeClass('hide-short-info no-swipe');
      return ClusterizeHelper(this.$el);
    };

    QuestsView.prototype.preprocessData = function(data) {
      if ((data != null ? data.quests : void 0) != null) {
        data.quests_new_count = data.quests.newQuests != null ? Object.keys(data.quests.newQuests).length : 0;
        data.quests_active_count = data.quests.npcQuestsInProgress != null ? Object.keys(data.quests.npcQuestsInProgress).length : 0;
        data.quests_completed_count = data.quests.completedQuests != null ? Object.keys(data.quests.completedQuests).length : 0;
      }
      return data;
    };

    return QuestsView;

  })(ItemView);
  return QuestsView;
});
