var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/referrals.tmpl'], function(app, ItemView, _, template) {
  var Referrals;
  Referrals = (function(_super) {
    __extends(Referrals, _super);

    function Referrals() {
      this._redrawStep = __bind(this._redrawStep, this);
      this._slideProvider = __bind(this._slideProvider, this);
      this._onSlideBtnClick = __bind(this._onSlideBtnClick, this);
      this._onShareBtnClick = __bind(this._onShareBtnClick, this);
      this.onRender = __bind(this.onRender, this);
      this.preprocessData = __bind(this.preprocessData, this);
      return Referrals.__super__.constructor.apply(this, arguments);
    }

    Referrals.prototype.template = template;

    Referrals.prototype.className = 'no-bg-image';

    Referrals.prototype.data = {
      ref_data: 'user.get_referrals_share_data'
    };

    Referrals.prototype.events = {
      'click .js-provider-slider-control': '_onSlideBtnClick',
      'click #js-provider-slider-icon': '_onShareBtnClick'
    };

    Referrals.prototype._shareData = {};

    Referrals.prototype.socialProviders = {
      'vk': {
        type: 'vk',
        'name': 'Vkontakte'
      },
      'fb': {
        type: 'fb',
        'name': 'Facebook'
      },
      'google': {
        type: 'google',
        'name': 'Google+'
      }
    };

    Referrals.prototype.preprocessData = function(data) {
      var shareUrl, _ref;
      shareUrl = this.app.config.serverURL + '/social/referrals/code/' + this.app.userId;
      if ((data != null ? (_ref = data.ref_data) != null ? _ref.share : void 0 : void 0)) {
        this._shareData = data.ref_data.share;
      } else {
        data = {
          url: shareUrl
        };
        this._shareData = data;
      }
      return data;
    };

    Referrals.prototype.onRender = function() {
      this.shareUrl = this.app.config.serverURL + '/social/referrals/code/' + this.app.userId;
      this.currentProvider = null;
      return this._slideProvider(0);
    };

    Referrals.prototype._onShareBtnClick = function(event) {
      var $lang, data, provider, _ref, _ref1, _ref2;
      $lang = app.translations.getLn();
      provider = this.app.socialService.getProvider(this.currentProvider);
      data = {
        'title': ((_ref = this._shareData) != null ? _ref.title : void 0) || null,
        'description': ((_ref1 = this._shareData) != null ? _ref1.description : void 0) || null,
        'url': this._shareData.url + '?ln=' + $lang,
        'image': ((_ref2 = this._shareData) != null ? _ref2.image : void 0) || null
      };
      return provider.share(data);
    };

    Referrals.prototype._onSlideBtnClick = function(event) {
      var step;
      step = parseInt(event.currentTarget.getAttribute('data-step'), 10);
      return this._slideProvider(step);
    };

    Referrals.prototype._slideProvider = function(step) {
      var currentStep, icon, nextStep, providerTypes, title;
      providerTypes = Object.keys(this.socialProviders);
      currentStep = providerTypes.indexOf(this.currentProvider);
      if (currentStep === -1) {
        currentStep = 0;
      }
      nextStep = step + currentStep;
      if (nextStep >= providerTypes.length) {
        nextStep = 0;
      } else if (nextStep < 0) {
        nextStep = providerTypes.length - 1;
      }
      this.currentProvider = providerTypes[nextStep];
      icon = this.el.querySelector('#js-provider-slider-icon');
      icon.setAttribute('src', './images/library/icons/referals-img-' + this.currentProvider + '.png');
      title = this.el.querySelector('#js-provider-slider-title');
      title.innerHTML = this.socialProviders[this.currentProvider].name;
      return this._redrawStep(nextStep, providerTypes.length);
    };

    Referrals.prototype._redrawStep = function(current, total) {
      var el, fragment, i, wrapper, _i, _ref;
      wrapper = this.el.querySelector('#js-provider-slider-step');
      fragment = document.createDocumentFragment();
      for (i = _i = 0, _ref = total - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
        el = document.createElement('i');
        if (i === current) {
          el.className = 'o-icon--dot-3 u-bgc--grey-4 u-mr-5';
        } else {
          el.className = 'o-icon--dot-3 u-bgc--grey-5 u-mr-5';
        }
        fragment.appendChild(el);
      }
      wrapper.innerHTML = '';
      wrapper.appendChild(fragment);
      return {
        _getUserId: (function(_this) {
          return function() {
            return app.shortInfo.view._data.info.userId;
          };
        })(this)
      };
    };

    return Referrals;

  })(ItemView);
  return Referrals;
});
