var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['jquery', 'app', 'views/item-view', 'underscore', 'text!templates/shop.tmpl'], function($, app, ItemView, _, template) {
  var ShopView;
  ShopView = (function(_super) {
    __extends(ShopView, _super);

    function ShopView() {
      this.onBeforeDestroy = __bind(this.onBeforeDestroy, this);
      this._updateTimer = __bind(this._updateTimer, this);
      this._updateTimers = __bind(this._updateTimers, this);
      this.onItemBuy = __bind(this.onItemBuy, this);
      this.preprocessData = __bind(this.preprocessData, this);
      return ShopView.__super__.constructor.apply(this, arguments);
    }

    ShopView.prototype.template = template;

    ShopView.prototype.data = {
      shop: 'shop.list'
    };

    ShopView.prototype.events = {
      'click .js-buy': 'onItemBuy',
      'click .js-vgold-buy': 'onVgoldBuy'
    };

    ShopView.prototype._timerIntervalId = 0;

    ShopView.prototype._goods = {};

    ShopView.prototype.preprocessData = function(data) {
      var goods, timer, _i, _len, _ref, _ref1;
      if ((data != null ? (_ref = data.shop) != null ? _ref.goods : void 0 : void 0)) {
        timer = false;
        _ref1 = data.shop.goods;
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          goods = _ref1[_i];
          if (goods.discount) {
            goods.color = 'red';
          } else {
            goods.color = 'yellow';
          }
          if (goods.is_special) {
            goods.color = 'blue';
          }
          if (goods.published_end) {
            goods.time_left = this._intervalStringFromTimestamp(goods.published_end);
            timer = true;
          }
          this._goods[goods.id] = goods;
        }
        if (timer) {
          this._timerIntervalId = setInterval(this._updateTimers, 1000);
        }
      }
      return data;
    };

    ShopView.prototype.onVgoldBuy = function() {
      return this.app.shop.gotoVGoldPurchase();
    };

    ShopView.prototype.onItemBuy = function(event) {
      var itemId;
      itemId = event.currentTarget.getAttribute('data-item-id');
      return this.app.screens.modal('shop/purchase-popup', {
        item: this._goods[itemId]
      });
    };

    ShopView.prototype._updateTimers = function() {
      var element, elements, _i, _len, _results;
      elements = this.el.querySelectorAll('.js-shop-timer');
      _results = [];
      for (_i = 0, _len = elements.length; _i < _len; _i++) {
        element = elements[_i];
        _results.push(this._updateTimer(element));
      }
      return _results;
    };

    ShopView.prototype._updateTimer = function(el) {
      var end, id, item, str;
      end = parseInt(el.getAttribute('data-timestamp')) || 0;
      str = this._intervalStringFromTimestamp(end);
      if (str) {
        return el.innerHTML = str;
      } else {
        id = el.getAttribute('data-item-id');
        item = this.el.querySelector('#js-shop-item-' + id);
        return item.parentNode.removeChild(item);
      }
    };

    ShopView.prototype._intervalStringFromTimestamp = function(timestamp) {
      var diff, div, key, now, part, parts, strParts, strTime;
      now = Math.floor((new Date()).getTime() / 1000);
      diff = timestamp - now;
      if (diff <= 0) {
        return null;
      }
      parts = {
        'days': 3600 * 24,
        'hours': 3600,
        'minutes': 60
      };
      strParts = {};
      for (key in parts) {
        div = parts[key];
        strParts[key] = Math.floor(diff / div);
        diff = diff - strParts[key] * div;
      }
      strParts['seconds'] = diff;
      for (key in strParts) {
        part = strParts[key];
        part = part.toString();
        strParts[key] = part.length < 2 ? '0' + part : part;
      }
      strTime = '';
      if (strParts['days'] !== '00') {
        strTime = strTime + strParts['days'] + ' ';
      }
      strTime = strTime + ' ' + strParts['hours'] + ':' + strParts['minutes'] + ':' + strParts['seconds'];
      return strTime;
    };

    ShopView.prototype.onBeforeDestroy = function() {
      if (this._timerIntervalId) {
        return clearInterval(this._timerIntervalId);
      }
    };


    /*
    			Center cloud
     */

    ShopView.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    ShopView.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return ShopView;

  })(ItemView);
  return ShopView;
});
