var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/shop/vgold.tmpl'], function(app, ItemView, _, template) {
  var ShopVgoldView;
  ShopVgoldView = (function(_super) {
    __extends(ShopVgoldView, _super);

    function ShopVgoldView() {
      this.onProviderChange = __bind(this.onProviderChange, this);
      return ShopVgoldView.__super__.constructor.apply(this, arguments);
    }

    ShopVgoldView.prototype.template = template;

    ShopVgoldView.prototype.events = {
      'click .js-buy': 'onVGoldBuy',
      'click .js-change-provider': 'onProviderChange'
    };

    ShopVgoldView.prototype._currentProvider = null;

    ShopVgoldView.prototype._providers = {};

    ShopVgoldView.prototype.initialize = function(options) {
      ShopVgoldView.__super__.initialize.call(this, options);
      this._providers = app.paymentsService.getEnabledProviders();
      return this._currentProvider = this._providers.length ? this._providers[0] : null;
    };

    ShopVgoldView.prototype.serializeData = function() {
      return {
        currentProvider: this._currentProvider,
        providers: this._providers,
        currencyList: this._currentProvider ? app.paymentsService.provider(this._currentProvider).loadCurrencyList() : []
      };
    };

    ShopVgoldView.prototype.onProviderChange = function(event) {
      var provider;
      provider = event.currentTarget.getAttribute('data-provider');
      if (app.paymentsService.isEnabled(provider) && provider !== this._currentProvider) {
        this._currentProvider = provider;
        return this.render();
      }
    };

    ShopVgoldView.prototype.onVGoldBuy = function(event) {
      var itemId, itemVgold, pageId, provider;
      pageId = this.options.id;
      provider = app.paymentsService.provider(this._currentProvider);
      itemId = event.currentTarget.getAttribute('data-item-id');
      itemVgold = provider.getCurrencyVgold(itemId);
      if (app.gaEnabled) {
        app.ga('send', 'pageview', {
          page: '/scr/' + pageId + '/vgold-purchase/' + itemVgold,
          title: ''
        });
        app.ga('send', 'event', 'shop', 'vgoldbuybutton', itemId, itemVgold);
      }
      app.showLoader();
      return provider.order(itemId).then(function(data) {
        var msg;
        app.hideLoader();
        app.shortInfo.refresh();
        if (data && data.status === 'uncompleted') {
          msg = app.tr('Purchase uncompleted. Please try to refresh purchases or contact us');
          msg += "\n (purchase id: " + data.transaction_id + ')';
          return app.screens.modal('common/info-popup', {
            msg: msg
          });
        } else {
          if (app.gaEnabled) {
            app.ga('send', 'pageview', {
              page: '/scr/' + pageId + '/vgold-success/' + itemVgold,
              title: ''
            });
            app.ga('send', 'event', 'shop', 'vgoldbuy', itemId, itemVgold);
          }
          return app.screens.modal('common/success-popup', {
            msg: app.tr("Purchase completed"),
            currency: 'vgold',
            amount: data.amount
          });
        }
      }, function(data) {
        var _ref, _ref1;
        app.hideLoader();
        if (data != null ? data.isVerified : void 0) {
          return app.screens.modal('shop/fail-popup', {
            msg: (data != null ? (_ref = data.error) != null ? _ref.message : void 0 : void 0) || app.tr('Purchase failed')
          });
        } else {
          return app.screens.modal('common/info-popup', {
            msg: (data != null ? (_ref1 = data.error) != null ? _ref1.message : void 0 : void 0) || app.tr('Purchase failed')
          });
        }
      });
    };


    /*
    			Center cloud
     */

    ShopVgoldView.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    ShopVgoldView.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return ShopVgoldView;

  })(ItemView);
  return ShopVgoldView;
});
