var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['underscore', 'views/item-view', 'text!templates/short-info.tmpl', 'moment', 'jquery.countdown', 'views/components/currency'], function(_, ItemView, template, moment, countdown, formatCurrency) {
  var ShortInfoView;
  ShortInfoView = (function(_super) {
    __extends(ShortInfoView, _super);

    function ShortInfoView() {
      this.initialize = __bind(this.initialize, this);
      return ShortInfoView.__super__.constructor.apply(this, arguments);
    }

    ShortInfoView.prototype.template = template;

    ShortInfoView.prototype.events = {
      'click .c-person__injury--red': 'injuryPopup',
      'click .c-person__injury--green': 'energyPopup',
      'click .js-vgold-buy': 'onVgoldBuy'
    };

    ShortInfoView.prototype.data = {
      info: 'user.info.short'
    };

    ShortInfoView.prototype.initialize = function(options) {
      this.options = options;
      this.listenTo(app.userEvents, "energy:updated", this.updateEnergyField);
      return ShortInfoView.__super__.initialize.call(this, this.options);
    };

    ShortInfoView.prototype.preprocessData = function(data) {
      return data;
    };

    ShortInfoView.prototype.injuryPopup = function(event) {
      var injured, traumasEffect, _ref;
      if (((_ref = this._data) != null ? _ref.info : void 0) != null) {
        this.lockUI();
        injured = this._data.info.injured;
        traumasEffect = this._data.info.traumasEffect;
        return this.app.screens.modal('common/injury-popup', {
          injured: injured,
          traumasEffect: traumasEffect
        });
      }
    };

    ShortInfoView.prototype.energyPopup = function(event) {
      var items, recoveryTime, _ref;
      if (((_ref = this._data) != null ? _ref.info : void 0) != null) {
        this.lockUI();
        recoveryTime = this._data.info.user.User.delta_recovery_energy;
        items = this._data.info.eatEffects;
        return this.app.screens.modal('common/energy-popup', {
          items: items,
          recoveryTime: recoveryTime
        });
      }
    };

    ShortInfoView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });

      /* turn off tooltip
      			if @_data?.info?
      				a = moment()
      				b = moment(@_data.info.user.User.last_energy_update, 'seconds')
      				 * Formula - min(now - last_energy_update, delta_recovery_energy)
      				time = Math.min(a.diff(b), @_data.info.user.User.delta_recovery_energy)
      				 * Countdown date format
      				finalDate = moment(moment(moment()).add(time, 's')).toDate()
      				
      				self = @
      				@$el.find('.c-menu__tooltip').countdown(finalDate, (event) ->
      					$(@).text(
      						event.strftime('%M:%S')
      					)
      				).on('finish.countdown', (ev) ->
      					app.server.user.info.short.cache.invalidate()
      					app.menu.reload()
      					app.shortInfo.view.reload()
      				)
       */
    };

    ShortInfoView.prototype.energyTooltip = function() {
      return this.$el.find('.c-menu__tooltip').toggle();
    };

    ShortInfoView.prototype.updateEnergyField = function(newEnergy) {
      return this.$el.find('.js-energy').html(newEnergy);
    };

    ShortInfoView.prototype.onVgoldBuy = function() {
      return this.app.shop.gotoVGoldPurchase();
    };

    return ShortInfoView;

  })(ItemView);
  return ShortInfoView;
});
