define(['app', 'views/item-view', 'underscore', 'text!templates/stadium/choose-trainer.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    required: ['callback'],
    data: {
      'trainers': 'stadium.trainers'
    },
    events: {
      'click .js-choose-program': 'chooseProgram'
    },
    chooseProgram: function(event) {
      var coefficient, currency, licenseId, price, programId;
      programId = event.currentTarget.getAttribute('data-program-id');
      licenseId = event.currentTarget.getAttribute('data-license-id');
      price = event.currentTarget.getAttribute('data-price');
      currency = event.currentTarget.getAttribute('data-currency');
      coefficient = event.currentTarget.getAttribute('data-coefficient');
      return this.options.callback({
        programId: programId,
        licenseId: licenseId,
        price: price,
        currency: currency,
        coefficient: coefficient
      });
    }
  });
});
