var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/stadium/licenses.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var licensesView;
  licensesView = (function(_super) {
    __extends(licensesView, _super);

    function licensesView() {
      return licensesView.__super__.constructor.apply(this, arguments);
    }

    licensesView.prototype.template = template;

    licensesView.prototype.data = {
      licenses: 'work.licenses'
    };

    licensesView.prototype.events = {
      'click .js-buy-license': 'buyLicense'
    };

    licensesView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    licensesView.prototype.buyLicense = function(event) {
      var currency, img, licenseId, name, price;
      this.lockUI();
      licenseId = event.currentTarget.getAttribute('data-license-id');
      name = event.currentTarget.getAttribute('data-name');
      price = event.currentTarget.getAttribute('data-price');
      currency = event.currentTarget.getAttribute('data-currency');
      img = event.currentTarget.getAttribute('data-img');
      return app.screens.modal('common/buy-popup', {
        name: name,
        maxCount: 1,
        price: price,
        currency: currency,
        img: img,
        callback: (function(_this) {
          return function(count) {
            return app.server.work.licenses.buyTrainerLicense({
              licenseId: licenseId,
              success: function(data) {
                var _ref;
                app.screens.back();
                return app.screens.modal('common/info-popup', {
                  msg: ((_ref = data.setFlash) != null ? _ref[0].msg : void 0) || app.tr("Insufficient level to purchase a license")
                });
              },
              error: function(data) {
                app.screens.back();
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    return licensesView;

  })(ItemView);
  return licensesView;
});
