define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/currencies-sell-grouped.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      'currency': {
        pointer: 'tradeCenter.availableCurrency'
      }
    },
    events: {
      'click .js-items-lot': 'sell'
    },
    sell: function(event) {
      var amount, currency;
      this.lockUI();
      amount = event.currentTarget.getAttribute('data-amount');
      currency = event.currentTarget.getAttribute('data-currency');
      return app.screens.dialog('trade-center/sell-currency', {
        currency: currency,
        available: amount
      });
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    }
  });
});
