define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/currencies-vg2vd.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      'lots': 'tradeCenter.currencyVgLots'
    },
    events: {
      'click .js-buy-lot': 'buyLot'
    },
    buyLot: function(event) {
      var data, lotId, lotInfo, offersCollection;
      this.lockUI();
      data = this.serializeData();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      offersCollection = new Backbone.Collection(data.lots.offers);
      lotInfo = offersCollection.get(lotId);
      return app.screens.modal('trade-center/purchase-currency', {
        model: lotInfo
      });
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    }
  });
});
