define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/items-sell-grouped.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      items: {
        pointer: 'tradeCenter.availableItems',
        category: function() {
          return this.options.category;
        }
      }
    },
    events: {
      'click .js-items-lot': 'sell'
    },
    sell: function(event) {
      var itemAmount, itemName, itemTypeId;
      this.lockUI();
      itemTypeId = event.currentTarget.getAttribute('data-item-type-id');
      itemName = event.currentTarget.getAttribute('data-item-name');
      itemAmount = event.currentTarget.getAttribute('data-item-amount');
      return app.screens.dialog('trade-center/sell-item', {
        itemTypeId: itemTypeId,
        itemName: itemName,
        itemAmount: itemAmount,
        lotComission: this._data.items.commission_per_unit
      });
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    }
  });
});
