var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/lot-settings.tmpl', 'views/common/precision-check'], function(app, ItemView, _, template, precisionCheck) {
  var LotSettingsView;
  LotSettingsView = (function(_super) {
    __extends(LotSettingsView, _super);

    function LotSettingsView() {
      return LotSettingsView.__super__.constructor.apply(this, arguments);
    }

    LotSettingsView.prototype.template = template;

    LotSettingsView.prototype.events = {
      'click .o-switcher': 'changeCurrency',
      'click .js-change-lot': 'changeLot'
    };

    LotSettingsView.prototype.changeCurrency = function(event) {
      return $(event.currentTarget).toggleClass('o-switcher--active');
    };

    LotSettingsView.prototype.changeLot = function(event) {
      var currency, exchangeId, price;
      this.lockUI();
      exchangeId = this._data.model['id'];
      price = this.$('.js-items-price').val();
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vgold' : 'vdollars';
      if (precisionCheck(price)) {
        this.undelegateEvents();
        return app.server.tradeCenter.editLot({
          exchangeId: exchangeId,
          price: price,
          currency: currency,
          success: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Lot edited")
            }, app.screens.back());
          },
          error: (function(_this) {
            return function(data) {
              var options;
              options = {
                msg: data.setFlash[0].msg || app.tr("Something went wrong"),
                onBack: function() {
                  return _this.delegateEvents();
                }
              };
              return app.screens.modal('common/info-popup', options);
            };
          })(this)
        });
      }
    };

    LotSettingsView.prototype.onRender = function() {
      return this.$('.js-items-price').change((function(_this) {
        return function(event) {
          var price;
          price = parseFloat($(event.currentTarget).val());
          if (!isNaN(price)) {
            return $(event.currentTarget).val(price.toFixed(2));
          } else {
            return $(event.currentTarget).val(_this.model.get("price").toFixed(2));
          }
        };
      })(this));
    };

    return LotSettingsView;

  })(ItemView);
  return LotSettingsView;
});
