var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/lots.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var LotsView;
  LotsView = (function(_super) {
    __extends(LotsView, _super);

    function LotsView() {
      return LotsView.__super__.constructor.apply(this, arguments);
    }

    LotsView.prototype.template = template;

    LotsView.prototype.data = {
      lots: {
        pointer: 'tradeCenter.lotsOffer',
        currency: function() {
          return this.options.currency;
        },
        itemTypeId: function() {
          return this.options.itemTypeId;
        },
        sort: function() {
          return this.options.sortType;
        },
        direction: function() {
          return this.options.sortDirection;
        }
      }
    };

    LotsView.prototype.events = {
      'click .js-buy-lot': 'buyLot',
      'click .js-sort-lots': 'showSort',
      'click .js-sort-lots li': 'sortLots'
    };

    LotsView.prototype.initialize = function(options) {
      options.sortType = "price";
      options.sortDirection = "asc";
      return LotsView.__super__.initialize.call(this, options);
    };

    LotsView.prototype.showSort = function(event) {
      return $('.js-sort-lots ul').toggle();
    };

    LotsView.prototype.sortLots = function(event) {
      this.lockUI();
      event.preventDefault();
      this.options.sortType = event.currentTarget.getAttribute('data-sort-by');
      this.options.sortDirection = event.currentTarget.getAttribute('data-sort-direction');
      return this.reload();
    };

    LotsView.prototype.buyLot = function(event) {
      var corporationId, data, lotId, lotInfo, offersCollection;
      data = this.serializeData();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      offersCollection = new Backbone.Collection(data.lots.offers);
      lotInfo = offersCollection.get(lotId);
      lotInfo.set('item_info', data.lots.item_info);
      lotInfo.set('buyer', data.lots.buyer);
      corporationId = this.options.corporationId;
      return app.screens.modal('trade-center/purchase-item', {
        model: lotInfo,
        corporationId: corporationId
      });
    };

    LotsView.prototype.onRender = function() {
      var currentSortText;
      currentSortText = $("li[data-sort-by=" + this.options.sortType + "][data-sort-direction=" + this.options.sortDirection + "]").html();
      return $(".current-sort").html(currentSortText);
    };

    LotsView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    return LotsView;

  })(ItemView);
  return LotsView;
});
