define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/purchase-item.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    events: {
      'click .js-confirm': 'purchaseItem'
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    },
    onRender: function() {
      return this.$('.js-items-number').change((function(_this) {
        return function(event) {
          var itemsAmount;
          itemsAmount = $(event.currentTarget).val();
          if (itemsAmount > _this.model.get('number')) {
            $(event.currentTarget).val(_this.model.get('number'));
            itemsAmount = _this.model.get('number');
          }
          return _this.$('.js-payment-amount').html((itemsAmount * parseFloat(_this.model.get('price'))).toFixed(2));
        };
      })(this));
    },
    purchaseItem: function() {
      var corporationId, number, self;
      this.lockUI();
      self = this;
      number = this.$('.js-items-number').val();
      corporationId = this.options.corporationId || 0;
      return app.server.tradeCenter.buyLot({
        exchangeId: this.model.get('id'),
        number: number,
        corporationId: corporationId,
        success: function(data) {
          app.vent.trigger('trade-center:item_purchased', {
            data: self.model.get('item_info')
          });
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Items purchased")
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    }
  });
});
