var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/sell-currency.tmpl', 'views/components/currency', 'views/common/precision-check'], function(app, ItemView, _, template, formatCurrency, precisionCheck) {
  var SellItemView;
  SellItemView = (function(_super) {
    __extends(SellItemView, _super);

    function SellItemView() {
      return SellItemView.__super__.constructor.apply(this, arguments);
    }

    SellItemView.prototype.template = template;

    SellItemView.prototype.events = {
      'click .js-create-lot': 'createLot'
    };

    SellItemView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    SellItemView.prototype.createLot = function(event) {
      var amount, price;
      this.lockUI();
      this.undelegateEvents();
      amount = this.$('.js-items-amount').val();
      price = this.$('.js-items-price').val();
      if (precisionCheck(price)) {
        this.undelegateEvents();
        return app.server.tradeCenter.createCurrencyLot({
          amount: amount,
          price: price,
          type: this.options.currency,
          success: (function(_this) {
            return function(data) {
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("The lot is active")
              }, app.screens.back());
            };
          })(this),
          error: (function(_this) {
            return function(data) {
              var options;
              options = {
                msg: data.setFlash[0].msg || app.tr("Something went wrong"),
                onBack: function() {
                  return _this.delegateEvents();
                }
              };
              return app.screens.modal('common/info-popup', options);
            };
          })(this)
        });
      }
    };

    SellItemView.prototype.onRender = function() {
      this.$('.js-items-amount').change((function(_this) {
        return function(event) {
          var amount, userHave;
          amount = parseInt($(event.currentTarget).val());
          userHave = parseInt(_this.options.available);
          if (isNaN(amount)) {
            return $(event.currentTarget).val(0);
          } else if (amount > userHave) {
            return $(event.currentTarget).val(userHave);
          }
        };
      })(this));
      return this.$('.js-items-price').change((function(_this) {
        return function(event) {
          var price;
          price = parseFloat($(event.currentTarget).val());
          if (!isNaN(price)) {
            return $(event.currentTarget).val(price.toFixed(2));
          } else {
            return $(event.currentTarget).val("0.00");
          }
        };
      })(this));
    };

    return SellItemView;

  })(ItemView);
  return SellItemView;
});
