var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/sell-item.tmpl'], function(app, ItemView, _, template) {
  var SellItemCompanyView;
  SellItemCompanyView = (function(_super) {
    __extends(SellItemCompanyView, _super);

    function SellItemCompanyView() {
      return SellItemCompanyView.__super__.constructor.apply(this, arguments);
    }

    SellItemCompanyView.prototype.template = template;

    SellItemCompanyView.prototype.data = {
      items: {
        pointer: 'tradeCenter.companyItemsToSell',
        companyId: function() {
          return this.options.companyId;
        }
      }
    };

    SellItemCompanyView.prototype.events = {
      'click .o-switcher': 'changeCurrency',
      'click .js-create-lot': 'createLot',
      'click .js-select': 'selectItem'
    };

    SellItemCompanyView.prototype.preprocessData = function(data) {
      var item, _i, _len, _ref;
      _ref = data.items.companyItemsArray;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        item = _ref[_i];
        item.id = item.ItemType.id;
        item.title = item.ItemType.name + " (" + item.CompanyItem.quantity + ")";
      }
      this.companyItemsCollection = new Backbone.Collection(data['items']['companyItemsArray']);
      return data;
    };

    SellItemCompanyView.prototype.onRender = function() {
      if (this._dataLoaded) {
        this.$('.js-items-amount').change((function(_this) {
          return function(event) {
            var amount, companyHave, itemId;
            amount = parseInt($(event.currentTarget).val());
            itemId = parseInt(_this.$('.js-select').attr("data-id"));
            if (itemId !== 0) {
              companyHave = _this.companyItemsCollection.get(itemId).get('CompanyItem')['quantity'];
              if (isNaN(amount)) {
                return $(event.currentTarget).val(0);
              } else if (amount > companyHave) {
                $(event.currentTarget).val(companyHave);
                return _this.$('.js-commission').html((companyHave * _this._data['items']['commission_per_unit']).toFixed(2));
              } else {
                return _this.$('.js-commission').html((amount * _this._data['items']['commission_per_unit']).toFixed(2));
              }
            } else {
              return _this.$('.js-commission').html((amount * _this._data['items']['commission_per_unit']).toFixed(2));
            }
          };
        })(this));
        return this.$('.js-items-price').change((function(_this) {
          return function(event) {
            var price;
            price = parseFloat($(event.currentTarget).val());
            if (!isNaN(price)) {
              return $(event.currentTarget).val(price.toFixed(2));
            } else {
              return $(event.currentTarget).val("0.00");
            }
          };
        })(this));
      }
    };

    SellItemCompanyView.prototype.changeCurrency = function(event) {
      $(event.currentTarget).toggleClass('o-switcher--active');
      if (this.$el.find('.o-switcher').hasClass('o-switcher--active')) {
        this.$('.js-commission-currency').addClass('o-icon--vgold');
        return this.$('.js-commission-currency').removeClass('o-icon--vdollar');
      } else {
        this.$('.js-commission-currency').addClass('o-icon--vdollar');
        return this.$('.js-commission-currency').removeClass('o-icon--vgold');
      }
    };

    SellItemCompanyView.prototype.selectItem = function(event) {
      this.lockUI();
      return app.screens.dialog('common/select-dialog', {
        collection: this.companyItemsCollection,
        callback: (function(_this) {
          return function(itemId) {
            var amount, companyHave;
            event.currentTarget.setAttribute('data-id', itemId);
            _this.$('.js-select .js-item-name').html(_this.companyItemsCollection.get(itemId).get("title"));
            amount = parseInt(_this.$('.js-items-amount').val());
            companyHave = _this.companyItemsCollection.get(itemId).get('CompanyItem')['quantity'];
            if (isNaN(amount) || (amount > companyHave)) {
              _this.$('.js-items-amount').val(companyHave);
              return _this.$('.js-commission').html((companyHave * _this._data['items']['commission_per_unit']).toFixed(2));
            }
          };
        })(this)
      });
    };

    SellItemCompanyView.prototype.createLot = function(event) {
      var amount, currency, itemTypeId, price;
      this.lockUI();
      itemTypeId = this.$('.js-select').attr("data-id");
      amount = this.$('.js-items-amount').val();
      price = this.$('.js-items-price').val();
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vgold' : 'vdollars';
      return app.server.tradeCenter.createLotCompany({
        companyId: this.options.companyId,
        itemTypeId: itemTypeId,
        amount: amount,
        price: price,
        currency: currency,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("The lot is active")
            }, app.screens.back());
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    return SellItemCompanyView;

  })(ItemView);
  return SellItemCompanyView;
});
