var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/sell-stock.tmpl', 'views/common/precision-check'], function(app, ItemView, _, template, precisionCheck) {
  var SellStockView;
  SellStockView = (function(_super) {
    __extends(SellStockView, _super);

    function SellStockView() {
      return SellStockView.__super__.constructor.apply(this, arguments);
    }

    SellStockView.prototype.template = template;

    SellStockView.prototype.events = {
      'click #payment_type': 'changeCurrency',
      'click .js-create-lot': 'createLot'
    };

    SellStockView.prototype.changeCurrency = function(event) {
      this.$('.vd-info').toggle();
      return this.$('.vg-info').toggle();
    };

    SellStockView.prototype.createLot = function(event) {
      var amount, currency, price;
      this.lockUI();
      amount = this.$('.js-items-amount').val();
      price = this.$('.js-items-price').val();
      currency = this.$('#payment_type').is(':checked') ? 'vgold' : 'vdollars';
      if (precisionCheck(price)) {
        return app.server.tradeCenter.createStockLot({
          corporationId: this.options.corporationId,
          amount: amount,
          price: price,
          currency: currency,
          success: (function(_this) {
            return function(data) {
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("The lot is active")
              }, app.screens.back());
            };
          })(this),
          error: (function(_this) {
            return function(data) {
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Something went wrong")
              });
            };
          })(this)
        });
      }
    };

    SellStockView.prototype.onRender = function() {
      this.$('.js-items-amount').change((function(_this) {
        return function(event) {
          var amount, userHave;
          amount = parseInt($(event.currentTarget).val());
          userHave = parseInt(_this.options.amount);
          if (isNaN(amount)) {
            return $(event.currentTarget).val(0);
          } else if (amount > userHave) {
            $(event.currentTarget).val(userHave);
            return _this.$('.js-commission').html((userHave * parseFloat(_this.options.lotComission)).toFixed(2));
          } else {
            return _this.$('.js-commission').html((amount * parseFloat(_this.options.lotComission)).toFixed(2));
          }
        };
      })(this));
      return this.$('.js-items-price').change((function(_this) {
        return function(event) {
          var price;
          price = parseFloat($(event.currentTarget).val());
          if (!isNaN(price)) {
            return $(event.currentTarget).val(price.toFixed(2));
          } else {
            return $(event.currentTarget).val("0.00");
          }
        };
      })(this));
    };

    return SellStockView;

  })(ItemView);
  return SellStockView;
});
