define(['app', 'views/item-view', 'underscore', 'text!templates/tutor/tutor-blank.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .js-next-screen': 'nextScreen',
      'click .o-click-area': 'somethingWrong'
    },
    _controlSelector: null,
    _wrapperSelector: '.js-tutor-content-wrapper',
    _topOffset: 110,
    _rageClicks: 0,
    somethingWrong: function(event) {
      this._rageClicks++;
      if (this._rageClicks > 2) {
        app.modalDialog.close();
      }
      if ($(this._controlSelector).length === 0) {
        return app.modalDialog.close();
      }
    },
    nextScreen: function(event) {
      if (app.config.debug) {
        return console.log('next screen not specified!');
      }
    },
    onDomRefresh: function() {
      var $rect, cssObj, left, rect, top, wrapper;
      if (this._wrapperSelector === '.js-menu') {
        app.menu.open();
      }
      $rect = $(this._controlSelector);
      rect = $rect.get(0);
      if ($rect.length < 1) {
        app.modalDialog.close();
        return;
      }
      $rect.addClass('c-pulsate');
      wrapper = document.querySelector(this._wrapperSelector);
      if (wrapper) {
        wrapper.scrollTop += rect.getBoundingClientRect().top - this._topOffset;
      }
      left = rect.getBoundingClientRect().left;
      top = rect.getBoundingClientRect().top;
      cssObj = {
        width: $rect.outerWidth(),
        height: $rect.outerHeight(),
        top: top,
        left: left
      };
      return $('.js-next-screen').css(cssObj);
    }
  });
});
